 /*
*  DESCRIPTION for iomacros.h
*  	Read/Write macros for memory mapped I/O
*/

#ifndef _IOMACROS_H
#define _IOMACROS_H
#include "type.h"
/****************************************************************************
						Constants Definitions
****************************************************************************/
#define IO_READ8(p)            (uint8_t)(*(volatile uint8_t *)(p))
#define IO_WRITE8(p,c)         (*((volatile uint8_t *)(p)) = ((uint8_t)(c)))

#define IO_READ16(p)           (uint16_t)(*(volatile uint16_t *)(p))
#define IO_WRITE16(p,v)        (*((volatile uint16_t *)(p)) = (uint16_t)(v))

#define IO_READ32(p)           (uint32_t)(*(volatile uint32_t *)(p))
#define IO_WRITE32(p,v)        (*((volatile uint32_t *)(p)) = (uint32_t)(v))

//bit operation
#define BSET32(reg, bit)		((reg) |= (bit))
#define BCLR32(reg, bit)		((reg) &= ~(bit))

#endif
