#include "sys.h"  
#include "type.h"
#include "cpm_drv.h"
#include "tc_drv.h"
#include "delay.h"
#include "libRegOpt.h"
#include "clk_switch_drv.h"
#include "cache_drv.h"

uint32_t g_sys_clk;//ϵͳʱȫֱ
uint32_t g_ips_clk;
uint32_t g_trim_clk = OSC_160M_HZ;

//ƫƵַ
//NVIC_VectTab:ַ
//Offset:ƫ		 
void NVIC_SetVectorTable(uint32_t NVIC_VectTab,uint32_t Offset)	 
{ 	   	  
	SCB->VTOR=NVIC_VectTab|(Offset&(uint32_t)0xFFFFFE00);//NVICƫƼĴ,VTOR9λ,[8:0]
}
//NVIC
//NVIC_Group:NVIC 0~4 ܹ5 		   
void NVIC_PriorityGroupConfig(uint8_t NVIC_Group)	 
{ 
	uint32_t temp,temp1;	  
	temp1=(~NVIC_Group)&0x07;//ȡλ
	temp1<<=8;
	temp=SCB->AIRCR;  //ȡǰ
	temp&=0X0000F8FF; //ǰ
	temp|=0X05FA0000; //дԿ
	temp|=temp1;	   
	SCB->AIRCR=temp;  //÷	    	  				   
}
//NVIC 
//NVIC_PreemptionPriority:ռȼ
//NVIC_SubPriority       :Ӧȼ
//NVIC_Channel           :жϱ
//NVIC_Group             :жϷ 0~3
//עȼܳ趨ķΧ!벻Ĵ
//黮:
//0:0λռȼ,3λӦȼ
//1:1λռȼ,2λӦȼ
//2:2λռȼ,1λӦȼ
//3:3λռȼ,0λӦȼ

//NVIC_SubPriorityNVIC_PreemptionPriorityԭ,ֵԽС,Խ	   
void NVIC_Init(uint8_t NVIC_PreemptionPriority,uint8_t NVIC_SubPriority,uint8_t NVIC_Channel,uint8_t NVIC_Group)	 
{ 
	uint32_t temp;	  
	NVIC_PriorityGroupConfig(NVIC_Group);//÷
	temp=NVIC_PreemptionPriority<<(3-NVIC_Group);	  
	temp|=NVIC_SubPriority&(0x07>>NVIC_Group);
	temp&=0x7;								//ȡλ
	NVIC->ISER[NVIC_Channel/32]|=1<<NVIC_Channel%32;//ʹжλ(ҪĻ,ICERӦλΪ1)
	NVIC->IP[NVIC_Channel]|=temp<<5;				//Ӧȼȼ   	    	  				   
} 
////ⲿжú
////ֻGPIOA~I;PVD,RTC,USB_OTG,USB_HS,̫ѵ
////:
////GPIOx:0~8,GPIOA~I
////BITx:Ҫʹܵλ;
////TRIM:ģʽ,1,;2,Ͻ;3ƽ
////úһֻ1IO,IO,ε
////úԶӦж,Լ   	    
//void Ex_NVIC_Config(uint8_t GPIOx,uint8_t BITx,uint8_t TRIM) 
//{ 
//	uint8_t EXTOFFSET=(BITx%4)*4;  
//	RCC->APB2ENR|=1<<14;  						//ʹSYSCFGʱ  
//	SYSCFG->EXTICR[BITx/4]&=~(0x000F<<EXTOFFSET);//ԭã
//	SYSCFG->EXTICR[BITx/4]|=GPIOx<<EXTOFFSET;	//EXTI.BITxӳ䵽GPIOx.BITx 
//	//Զ
//	EXTI->IMR|=1<<BITx;					//line BITxϵж(Ҫֹжϣ򷴲)
//	if(TRIM&0x01)EXTI->FTSR|=1<<BITx;	//line BITx¼½ش
//	if(TRIM&0x02)EXTI->RTSR|=1<<BITx;	//line BITx¼ش
//} 	

//THUMBָֻ֧
//·ʵִлָWFI  

//ģʽ	  
void Sys_Standby(void)
{ 
	SCB->SCR|=1<<2;		//ʹSLEEPDEEPλ (SYS->CTRL)	   
//	RCC->APB1ENR|=1<<28;//ʹܵԴʱ 
//	PWR->CSR|=1<<8;     //WKUPڻ
//	PWR->CR|=1<<2;      //Wake-up ־
//	PWR->CR|=1<<1;      //PDDSλ
	if((CPM->CPM_SLPCFGR & 0x80000000) == 0)
	{
//		CPM->CPM_PWRCR &=~ 0x0c;	//disable LVD if enter lp/poff1/poff1.5 mode.
		CPM_PWRCR_OptBits(0x0c,RESET);
	}
	else
	{
//		CPM->CPM_PWRCR |= 0x0c;		//enable LVD if enter poff2 mode.
		CPM_PWRCR_OptBits(0x0c,SET);
	}
	WFI_SET();			//ִWFIָ,ģʽ
//	CPM->CPM_PWRCR |= 0x0c;		//enable LVD after wake-up from lowpower.
	CPM_PWRCR_OptBits(0x0c,SET);
}	     
//ϵͳλ   
void Sys_Soft_Reset(void)
{   
	SCB->AIRCR =0X05FA0000|(uint32_t)0x04;	  
} 		 

void Sys_Init(void)
{
	/*TC has been closed in startup_ARMCM4.s*/
//	TC_Reset_Init(TC_WDP_0_5, 0xffff, FALSE); // disable TC reset
	
	delay(250000);
	
	Sys_Clk_Init(OSC_150M_HZ, SYS_CLK_DIV_1,IPS_CLK_DIV_2);
	
	//EFLASHģ
	DCACHE_Init(cacheOff, cacheThrough, cacheOff, cacheOff);
	ICACHE_Init(cacheOff, cacheThrough, cacheOff, cacheOff);
	
	//	CPM_VCC5V_Bypass(); //оƬ3.3V1.8VʱԹҪߣ򿪴˽ӿڣԹҪ󲻸߿Բ; оƬ5Vʱδ˽ӿ,ܻоƬ
}

void WFI_SET(void)
{
	__ASM volatile("wfi");		  
}
//رж(ǲfaultNMIж)
void INTX_DISABLE(void)
{
	__ASM volatile("cpsid i");
}
//ж
void INTX_ENABLE(void)
{
	__ASM volatile("cpsie i");		  
}
//ջַ
//addr:ջַ
__asm void MSR_MSP(uint32_t addr) 
{
	MSR MSP, r0 			//set Main Stack value
	BX r14
}





















