/************************************************************************
  * Copyright(c) 2023 Levetop Semiconductor Co.,Led. All rights reserved.
  * @file     delay.c
  * @author   UartTFT Application Team
  * @version  V0.0.1
  * @date     2023-01-01
  * @brief    
 *************************************************************************/

#include "delay.h"
#include "sys.h"
#include "cpm_drv.h"

/*******************************************************************************
 * Function Name  : DelayMS
 * Description    : Delay n MS
 * Input          : delaymSDelay Parame
 * Output         : None
 * Return         : None
 *******************************************************************************/
void DelayMS(vu32 delaymS)
{
	//	uint32_t counter=0;
	uint32_t k = 0;
	vu32 counter_ms = g_sys_clk / 6000;

	while (delaymS--)
	{
		while (k < counter_ms)
			k++;
		k = 0;
	}
}

/*******************************************************************************
 * Function Name  : DelayuS
 * Description    : Delay n uS
 * Input          : delaymSDelay Parame
 * Output         : None
 * Return         : None
 *******************************************************************************/
void DelayUS(vu32 delayuS)
{
	uint32_t k = 0;
	vu32 counter_us = g_sys_clk / 6000000;

	while (delayuS--)
	{
		while (k < counter_us)
			k++;
		k = 0;
	}
}

/*******************************************************************************
 * Function Name  : delay
 * Description    : Delay n nop
 * Input          : time: n npo
 * Output         : None
 * Return         : None
 *******************************************************************************/
void delay(vu32 time)
{
	while (time--)
		;
}
