/************************************************************************
  * Copyright(c) 2023 Levetop Semiconductor Co.,Led. All rights reserved.
  * @file     function_drv.h
  * @author   UartTFT Application Team
  * @version  V0.0.1
  * @date     2023-01-01
  * @brief    
 *************************************************************************/

#ifndef _FUNCTION_DRV_H
#define _FUNCTION_DRV_H

#include "type.h"
#include "spi_drv.h"
#include "eport_drv.h"

/*
--Backlight
--Buzzer
--Wav
--SD
*/

//------------------------------------------ Backlight ------------------------------
void LCD_BL_Init(uint16_t PWM_Width);
void LT_BacklightSet(uint16_t PWM_Width);
void LT_BacklightClose(void);
void LT_BacklightOpen(void);

extern uint8_t Auto_Backlight; // Automatic backlight
extern uint8_t Backlight_Off;
extern uint8_t Backlight_On;
extern uint16_t gDutyBuf[];

//------------------------------------------ Buzzer ------------------------------
void touch_buzzer_init(void);
void touch_buzzer(void);
void touch_buzzer_close(void);

extern uint8_t buzzer_start;

//------------------------------------------ WAV ------------------------------
void WAV_amplifier_EN(void);
void WAV_amplifier_DIS(void);

//------------------------------------------ Encoder ------------------------------
#define PINA		 SPI_ReadGpioData(SPI3, SPI_SCK)//I2C_ReadGpioData(I2C1, I2C_SDA)
#define PINB 		 SPI_ReadGpioData(SPI3, SPI_MOSI)//I2C_ReadGpioData(I2C1, I2C_SCL)
//#define ENCODER_KEY  EPORT_ReadGpioData(EPORT_PIN10)

void Encoder_Init(void);

//------------------------------------------ SD ------------------------------
#define SD_CS_SET     EPORT_WriteGpioData(EPORT_PIN3,Bit_SET)
#define SD_CS_RESET   EPORT_WriteGpioData(EPORT_PIN3,Bit_RESET)
#define Speed_High    SPI_BaudRatePrescaler_4
#define Speed_Low     SPI_BaudRatePrescaler_256

void SD_SPIx_Initial(void);
uint16_t SD_SPIx_ReadWriteByte(uint16_t TxData);
void SD_SPIx_SetSpeed(uint16_t speed);
void SD_SPIx_DMA_Tran(uint8_t *Tx_Addr, uint8_t *Rx_Addr, uint32_t length);
void SD_SPIx_DMA_Wait(void);
void SD_SPI_close(void);
void SD_IN_Enable(void);    // enable SD detection
uint8_t SD_detection(void); // SD detection

//------------------------------------------   ------------------------------

#endif /* _FUNCTION_DRV_H */
