/************************************************************************
  * Copyright(c) 2023 Levetop Semiconductor Co.,Led. All rights reserved.
  * @file     pic.c
  * @author   UartTFT Application Team
  * @version  V0.0.1
  * @date     2023-01-01
  * @brief    
 *************************************************************************/

#include "pit.h"
#include "bsp.h"
#include "function_drv.h"
#include "data.h"
#include "tp_ctp.h"
#include "pit32_drv.h"
#include "sys.h"
#include "wav_dac.h"
#include "uart.h"
#include "eport_drv.h"

uint8_t flag_MB_REG[20];

#if (UARTBUS_OPTION == 0)

// timer for dynamic display
void PIT1_Init(void)
{
	NVIC_Init(1, 0, PIT1_IRQn, 2);

	PIT1->PCSR &= (~PCSR_EN);
	PIT1->PCSR = (5 << 8) | PCSR_OVW | PCSR_PIE | PCSR_RLD | PCSR_PDBG; // 75mhz/32  Interrupt mode
	PIT1->PMR = 23437;													// 10ms
	PIT1->PCSR |= PCSR_EN;
}

void PIT1_IRQHandler(void)
{
	PIT1->PCSR |= (1 << 2); // 4.clear PIF interrupt flag

	if (Gif_num > 0)
		Gif_flag = 1;
	if (Adj_loop > 0)
		Adj_time++;
	if (DioKb_flag == 1)
		Cusor_time++;
	if (AioKb_flag == 1)
		Cusor_time++;
	if (GBKioKb_flag == 1)
		Cusor_time++;
	if (Scroll_num > 0)
		Scroll_flag = 1;
	if (curve_num > 0)
		curve_flag = 1;
	if (Backlight_flag)
		Backlight_count++;
	if (buzzer_start)
	{
		buzzer_10ms_count++;
		if (buzzer_10ms_count >= 5)
		{
			touch_buzzer_close();
			buzzer_start = 0;
			buzzer_10ms_count = 0;
		}
	}
#if (LT_TOUCH_FLAG == 1)
	if (RTP_read_Flag == 1)
	{
		RTP_time++;
		if (RTP_time > 5)
		{
			RTP_read_Flag = 0;
			RTP_time = 0;
		}
	}
#endif
	page_refreshing++;
	ctp_press_t++;

//#if LT_ENCODER
//	if (SW_flag4 != 2 || SW_flag4 != 3)
//		key_time++;

//	if (Encoder_read_Flag == 1)
//	{
//		if (Encoder_type == 0)
//		{
//			Encoder_time++;
//			if (Encoder_time > 1)
//			{
//				if (EPORT_ReadGpioData(EPORT_PIN5) == 1)
//				{
//					Encoder_read_Flag = 0;
//					Encoder_time = 0;
//					key_time = 0;
//					SW_flag = 1;
//				}
//			}
//		}
//		else if (Encoder_type == 4)
//		{
//			Encoder_time++;
//			if (Encoder_time > 1)
//			{
//				if (SW_flag4 == 1)
//				{
//					SW_flag4 = 2;
//					SW_flag = 3;
//					Encoder_read_Flag = 0;
//					Encoder_time = 0;
//					key_time = 0;
//				}

////				if (EPORT_ReadGpioData(EPORT_PIN5) == 1)
////				{
////					if (Encoder_time > (Long_press * 5))
////					{
////						SW_flag4 = 3;
////						SW_flag = 4;
////					}
////					else
////					{
////						SW_flag4 = 1;
////						// SW_flag = 2;
////					}
////					Encoder_read_Flag = 0;
////					Encoder_time = 0;
////					key_time = 0;
////				}
//				if (Encoder_time > (Long_press * 5) && SW_flag4 != 3)
//				{
//					SW_flag4 = 3;
//					SW_flag = 4;
//					Encoder_read_Flag = 0;
//					Encoder_time = 0;
//					key_time = 0;
//				}
//				if (EPORT_ReadGpioData(EPORT_PIN5) == 1 == 1)
//				{
//					SW_flag4 = 1;
//					Encoder_read_Flag = 0;
//					Encoder_time = 0;
//					key_time = 0;
//				}
//			}
//		}
//	}
//	if (SW_flag4 == 1)
//	{
//		Encoder_time++;
//		if (Encoder_time > Double_click_interval * 5) // The valid time of double click is exceeded
//		{
//			SW_flag4 = 1;
//			SW_flag = 2;
//		}
//	}
//	if (Enc1)
//	{
//		Encoder_Freetime++;
//		if (Encoder_Freetime > 100)
//		{
//			Encoder_Freetime = 0;
//			knob_dir = 0;
//			Enc1 = 0;
//		}
//	}
//#endif
#if LT_ENCODER
	if (SW_flag4 != 2 || SW_flag4 != 3)
		key_time++;

	if (Encoder_read_Flag == 1)
	{
		Backlight_count = 0;
		if (Encoder_type == 0)
		{
			Encoder_time++;
			if (Encoder_time > 1)
			{
#if RP4_FLAG
				if (EPORT_ReadGpioData(EPORT_PIN4) == 1)
				{
					Encoder_read_Flag = 0;
					Encoder_time = 0;
					key_time = 0;
					SW_flag = 1;
				}
#else
				if (EPORT_ReadGpioData(EPORT_PIN0) == 1)
				{
					Encoder_read_Flag = 0;
					Encoder_time = 0;
					key_time = 0;
					SW_flag = 1;
				}
#endif
			}
		}
		else if (Encoder_type == 4)
		{
			Encoder_time++;
			if (Encoder_time > 1)
			{
				if (SW_flag4 == 1)
				{
					SW_flag4 = 2;
					SW_flag = 3;
					Encoder_read_Flag = 0;
					Encoder_time = 0;
					key_time = 0;
				}
				if (Encoder_time > (Long_press * 5) && SW_flag4 != 3)
				{
					SW_flag4 = 3;
					SW_flag = 4;
					Encoder_read_Flag = 0;
					Encoder_time = 0;
					key_time = 0;
				}
#if RP4_FLAG
				if (EPORT_ReadGpioData(EPORT_PIN4) == 1)
				{
					SW_flag4 = 1;
					Encoder_read_Flag = 0;
					Encoder_time = 0;
					key_time = 0;
				}
#else
				if (EPORT_ReadGpioData(EPORT_PIN0) == 1)
				{
					SW_flag4 = 1;
					Encoder_read_Flag = 0;
					Encoder_time = 0;
					key_time = 0;
				}
#endif

			}
		}
	}
	if (SW_flag4 == 1)
	{
		Encoder_time++;
		if (Encoder_time > Double_click_interval * 5) // Double-click valid time exceeded
		{
			SW_flag4 = 1;
			SW_flag = 2;
		}
	}
	if (Enc1)
	{
		Encoder_Freetime++;
		if (Encoder_Freetime > 100)
		{
			Encoder_Freetime = 0;
			knob_dir = 0;
			Enc1 = 0;
		}
	}
#endif
}
#endif

#if (UARTBUS_OPTION == 1)

void PIT1_Init(void)
{
	NVIC_Init(1, 0, PIT1_IRQn, 2);

	PIT1->PCSR &= (~PCSR_EN);
	PIT1->PCSR = (3 << 8) | PCSR_OVW | PCSR_PIE | PCSR_RLD | PCSR_PDBG; // 75mhz/8  Interrupt mode
	PIT1->PMR = 9375;													// 1ms
	PIT1->PCSR |= PCSR_EN;
}

#define MB_ERR_CMD 0x01
#define MB_ERR_ADDR 0x02
#define MB_ERR_DATA 0x03
#define MB_ERR_FAULT 0x04

volatile MB_CMD_RXINFO gMB_CMDRX;
volatile uint8_t MB_SLA_RXBUF[256] = {0};
volatile uint16_t MB_SLA_Len = 0;
volatile uint8_t Addr_ModBus_Sla = 0x01;
volatile uint8_t Feedback_ModbusBuf[256] = {0};

volatile uint32_t pit_1ms_count = 0;
volatile uint8_t uart_flag = 0;
volatile uint32_t pit_1ms_count2 = 0;

void PIT1_IRQHandler(void)
{
	uint16_t CRC_MCU = 0, CRC_RX = 0;
	uint16_t i = 0, j = 0;
	uint8_t temp = 0, num = 0, cnt = 0;

	PIT1->PCSR |= PCSR_PIF; // clear PIF interrupt flag
	pit_1ms_count++;
	pit_1ms_count2++;

	if (pit_1ms_count == 5 && uart_flag) // If the serial port is detected for 5ms and no data is received, the reception is completed
	{
		pit_1ms_count = 0;
		uart_flag = 0;

		MB_SLA_Len = gUsartRx.Count;
		memcpy(MB_SLA_RXBUF, gUsartRx.Buf, MB_SLA_Len);
		gUsartRx.Count = 0;

		if (MB_SLA_RXBUF[0] == Addr_ModBus_Sla || MB_SLA_RXBUF[0] == 0) // Transceiver node consistency or broadcast mode
		{
			CRC_MCU = (MB_SLA_RXBUF[MB_SLA_Len - 1] << 8) + (MB_SLA_RXBUF[MB_SLA_Len - 2] & 0x00FF);
			CRC_RX = CRC16(MB_SLA_RXBUF, MB_SLA_Len - 2);
			if (CRC_MCU == CRC_RX) // CRC Correct calibration
			{
				gMB_CMDRX.CMD = MB_SLA_RXBUF[1];
				gMB_CMDRX.Addr = MB_SLA_RXBUF[2] << 8 | MB_SLA_RXBUF[3];

				if (gMB_CMDRX.CMD == 0x03 && MB_SLA_RXBUF[0] != 0) // Read command response (broadcast mode read function is meaningless)
				{
					gMB_CMDRX.Num = MB_SLA_RXBUF[4] << 8 | MB_SLA_RXBUF[5];
					if (gMB_CMDRX.Addr < VAR_ADDR_S) // Variable address
					{
						Feedback_ModbusBuf[0] = Addr_ModBus_Sla;
						Feedback_ModbusBuf[1] = gMB_CMDRX.CMD;
						Feedback_ModbusBuf[2] = 2 * gMB_CMDRX.Num;
						for (i = 0; i < gMB_CMDRX.Num; i++)
						{
							Feedback_ModbusBuf[3 + 2 * i] = var[2 * (gMB_CMDRX.Addr + i)];
							Feedback_ModbusBuf[4 + 2 * i] = var[2 * (gMB_CMDRX.Addr + i) + 1];
						}
						LT_SendData_CRC_NoFrame(Feedback_ModbusBuf, 3 + Feedback_ModbusBuf[2]);
					}
					else if (gMB_CMDRX.Addr >= VAR_ADDR_S && gMB_CMDRX.Addr <= VAR_ADDR_E) // Register address
					{
						if (gMB_CMDRX.Addr <= (VAR_TIME + 5) || gMB_CMDRX.Addr + gMB_CMDRX.Num >= (VAR_TIME + 0))
						{
							var[(VAR_TIME + 0) * 2 + 1] = calendar.w_year - 2000;
							var[(VAR_TIME + 1) * 2 + 1] = calendar.w_month;
							var[(VAR_TIME + 2) * 2 + 1] = calendar.w_date;
							var[(VAR_TIME + 3) * 2 + 1] = calendar.hour;
							var[(VAR_TIME + 4) * 2 + 1] = calendar.min;
							var[(VAR_TIME + 5) * 2 + 1] = calendar.sec;
						}

						Feedback_ModbusBuf[0] = Addr_ModBus_Sla;
						Feedback_ModbusBuf[1] = gMB_CMDRX.CMD;
						Feedback_ModbusBuf[2] = 2 * gMB_CMDRX.Num;
						for (i = 0; i < gMB_CMDRX.Num; i++)
						{
							Feedback_ModbusBuf[3 + 2 * i] = var[2 * (gMB_CMDRX.Addr + i)];
							Feedback_ModbusBuf[4 + 2 * i] = var[2 * (gMB_CMDRX.Addr + i) + 1];
						}
						LT_SendData_CRC_NoFrame(Feedback_ModbusBuf, 3 + Feedback_ModbusBuf[2]);
					}
					else
					{
						Feedback_ModbusBuf[0] = Addr_ModBus_Sla;
						Feedback_ModbusBuf[1] = gMB_CMDRX.CMD + 0x80;
						Feedback_ModbusBuf[2] = MB_ERR_ADDR;
						LT_SendData_CRC_NoFrame(Feedback_ModbusBuf, 3);
					}
				}
				else if (gMB_CMDRX.CMD == 0x06) // Write instruction response
				{
					if (gMB_CMDRX.Addr < VAR_ADDR_S) // Variable address
					{
						var[2 * gMB_CMDRX.Addr] = MB_SLA_RXBUF[4];
						var[2 * gMB_CMDRX.Addr + 1] = MB_SLA_RXBUF[5];

						if (MB_SLA_RXBUF[0] != 0)
							LT_SendData_CRC_NoFrame(MB_SLA_RXBUF, 6);
					}
					else if (gMB_CMDRX.Addr >= VAR_ADDR_S && gMB_CMDRX.Addr <= VAR_ADDR_E) // Register address
					{
						var[2 * gMB_CMDRX.Addr] = MB_SLA_RXBUF[4];
						var[2 * gMB_CMDRX.Addr + 1] = MB_SLA_RXBUF[5];
						flag_MB_REG[gMB_CMDRX.Addr - VAR_ADDR] = 1;

						if (MB_SLA_RXBUF[0] != 0)
							LT_SendData_CRC_NoFrame(MB_SLA_RXBUF, 6);
					}
					else
					{
						Feedback_ModbusBuf[0] = Addr_ModBus_Sla;
						Feedback_ModbusBuf[1] = gMB_CMDRX.CMD + 0x80;
						Feedback_ModbusBuf[2] = MB_ERR_ADDR;
						if (MB_SLA_RXBUF[0] != 0)
							LT_SendData_CRC_NoFrame(Feedback_ModbusBuf, 3);
					}
				}
				else if (gMB_CMDRX.CMD == 0x10) // Write multiple instruction response
				{
					gMB_CMDRX.Num = MB_SLA_RXBUF[4] << 8 | MB_SLA_RXBUF[5];
					if (gMB_CMDRX.Addr < VAR_ADDR_S) // Variable address
					{
						// Save data
						for (i = 0; i < gMB_CMDRX.Num; i++)
						{
							var[2 * (gMB_CMDRX.Addr + i)] = MB_SLA_RXBUF[7 + 2 * i];
							var[2 * (gMB_CMDRX.Addr + i) + 1] = MB_SLA_RXBUF[8 + 2 * i];
						}
						if (MB_SLA_RXBUF[0] != 0)
							LT_SendData_CRC_NoFrame(MB_SLA_RXBUF, 6);
					}
					else if (gMB_CMDRX.Addr >= VAR_ADDR_S && gMB_CMDRX.Addr <= VAR_ADDR_E) // Register address
					{
						for (i = 0; i < gMB_CMDRX.Num; i++)
						{
							var[2 * (gMB_CMDRX.Addr + i)] = MB_SLA_RXBUF[7 + 2 * i];
							var[2 * (gMB_CMDRX.Addr + i) + 1] = MB_SLA_RXBUF[8 + 2 * i];
							flag_MB_REG[gMB_CMDRX.Addr - VAR_ADDR + i] = 1;
						}
						if (MB_SLA_RXBUF[0] != 0)
							LT_SendData_CRC_NoFrame(MB_SLA_RXBUF, 6);
					}
					else if (gMB_CMDRX.Addr >= VAR_CURVE_WS && gMB_CMDRX.Addr <= VAR_CURVE_WE) 
					{
						gMB_CMDRX.Num = MB_SLA_RXBUF[4] << 8 | MB_SLA_RXBUF[5];

						temp = gMB_CMDRX.Addr & 0xFFF;
						for (i = 0; i < CURVE_CHANNEL; i++) //Record how many groups of channels
						{
							if (temp & (1 << i))
								num++;
						}

						i = 0;
						j = 0;
						while (j < gMB_CMDRX.Num) // Store data to corresponding channels respectively
						{
							if (temp & (1 << i))
							{
								Curve_buff[i][Curve_count[i]] = MB_SLA_RXBUF[7 + 2 * j] << 8 | MB_SLA_RXBUF[8 + 2 * j];
								Curve_count[i]++;
								if (Curve_count[i] >= 1024)
								{
									Curve_count[i] = 0;
								}
								curve_update_flag[i] = 1;
								j++;
							}
							i++;
							if (i >= CURVE_CHANNEL)
								i = 0;
						}

						if (gMB_CMDRX.Num % num) // When multi-channel buffer data is triggered, if some channel data is missing, the missing part will be supplemented
						{
							for (i = 0; i < CURVE_CHANNEL; i++)
							{
								if (temp & (1 << i))
									cnt++;
								if (cnt > gMB_CMDRX.Num % num && (temp & (1 << i)))
								{
									if (Curve_count[i] != 0)
										Curve_buff[i][Curve_count[i]] = Curve_buff[i][Curve_count[i] - 1];
									else
										Curve_buff[i][0] = Curve_buff[i][1023];

									Curve_count[i]++;
									if (Curve_count[i] >= 1024)
									{
										Curve_count[i] = 0;
									}
								}
							}
						}
						if (MB_SLA_RXBUF[0] != 0)
							LT_SendData_CRC_NoFrame(MB_SLA_RXBUF, 6);
					}
					else if (gMB_CMDRX.Addr >= VAR_CURVE_CS && gMB_CMDRX.Addr <= VAR_CURVE_CE)
					{
						temp = gMB_CMDRX.Addr & 0xFF;
						for (i = 0; i < CURVE_CHANNEL; i++) // Store data to corresponding channels respectively
						{
							if (temp & (1 << i))
							{
								for (j = 0; j < 1024; j++)
								{
									Curve_buff[i][j] = 0x00;
								}

								Curve_count[i] = 0;
								curve_update_flag[i] = 1;
							}
						}
						if (MB_SLA_RXBUF[0] != 0)
							LT_SendData_CRC_NoFrame(MB_SLA_RXBUF, 6);
					}
					else
					{
						Feedback_ModbusBuf[0] = Addr_ModBus_Sla;
						Feedback_ModbusBuf[1] = gMB_CMDRX.CMD + 0x80;
						Feedback_ModbusBuf[2] = MB_ERR_ADDR;
						if (MB_SLA_RXBUF[0] != 0)
							LT_SendData_CRC_NoFrame(Feedback_ModbusBuf, 3);
					}
				}
				else
				{
					Feedback_ModbusBuf[0] = Addr_ModBus_Sla;
					Feedback_ModbusBuf[1] = gMB_CMDRX.CMD + 0x80;
					Feedback_ModbusBuf[2] = MB_ERR_CMD;
					if (MB_SLA_RXBUF[0] != 0)
						LT_SendData_CRC_NoFrame(Feedback_ModbusBuf, 3);
				}
			}
			else
			{
			}
		}
		else // The sending and receiving nodes are inconsistent
		{
		}

		//		gUsartRx.Count = 0;
	}

	if (pit_1ms_count2 >= 10)
	{
		pit_1ms_count2 = 0;

		if (Gif_num > 0)
			Gif_flag = 1;
		if (Adj_loop > 0)
			Adj_time++;
		if (DioKb_flag == 1)
			Cusor_time++;
		if (AioKb_flag == 1)
			Cusor_time++;
		if (GBKioKb_flag == 1)
			Cusor_time++;
		if (Scroll_num > 0)
			Scroll_flag = 1;
		if (curve_num > 0)
			curve_flag = 1;
		if (Backlight_flag)
			Backlight_count++;
		if (buzzer_start)
		{
			buzzer_10ms_count++;
			if (buzzer_10ms_count >= 5)
			{
				touch_buzzer_close();
				buzzer_start = 0;
				buzzer_10ms_count = 0;
			}
		}
#if (LT_TOUCH_FLAG == 1)
		if (RTP_read_Flag == 1)
		{
			RTP_time++;
			if (RTP_time > 5)
			{
				RTP_read_Flag = 0;
				RTP_time = 0;
			}
		}
#endif
		page_refreshing++;
		ctp_press_t++;

#if LT_ENCODER
		if (Encoder_read_Flag == 1)
		{
			Encoder_time++;
			if (Encoder_time > 1)
			{
				if (EPORT_ReadGpioData(EPORT_PIN4) == 1)
					SW_flag = 1;
				Encoder_read_Flag = 0;

				Encoder_time = 0;
			}
		}
		if (Enc1)
		{
			Encoder_Freetime++;
			if (Encoder_Freetime > 100)
			{
				Encoder_Freetime = 0;
				knob_dir = 0;
				Enc1 = 0;
			}
		}
#endif
	}
}

#endif

#if (UARTBUS_OPTION == 2)
void PIT1_Init(void)
{
	NVIC_Init(1, 0, PIT1_IRQn, 2);

	PIT1->PCSR &= (~PCSR_EN);
	PIT1->PCSR = (3 << 8) | PCSR_OVW | PCSR_PIE | PCSR_RLD | PCSR_PDBG; // 75mhz/8  Interrupt mode
	PIT1->PMR = 9375;													// 1ms
	PIT1->PCSR |= PCSR_EN;
}

volatile uint32_t pit_1ms_count = 0;
volatile uint8_t uart_flag = 0;

volatile uint32_t pit_1ms_count2 = 0;
volatile uint32_t tx_10ms_cnt = 0;
volatile uint8_t tx_500ms_flag = 0;

volatile uint32_t pit_1ms_count3 = 0;
volatile uint8_t timeout_flag = 0;
volatile uint8_t MB_SLA_RXBUF[256] = {0};
volatile uint16_t MB_SLA_Len = 0;

void PIT1_IRQHandler(void)
{
	uint16_t CRC_MCU = 0, CRC_RX = 0;
	uint16_t i = 0;

	PIT1->PCSR |= PCSR_PIF; // clear PIF interrupt flag
	pit_1ms_count++;
	pit_1ms_count2++;
	pit_1ms_count3++;

	if (pit_1ms_count >= 5 && uart_flag) // If the serial port is detected for 5ms and no data is received, the reception is completed
	{
		pit_1ms_count = 0;
		uart_flag = 0;
		gUsartRx.Flag = 1;

		MB_SLA_Len = gUsartRx.Count;
		memcpy(MB_SLA_RXBUF, gUsartRx.Buf, MB_SLA_Len);
		gUsartRx.Count = 0;

		CRC_MCU = (MB_SLA_RXBUF[MB_SLA_Len - 1] << 8) + (MB_SLA_RXBUF[MB_SLA_Len - 2] & 0x00FF);
		CRC_RX = CRC16(MB_SLA_RXBUF, MB_SLA_Len - 2);

		if (CRC_MCU == CRC_RX) // CRC correct calibration
		{
			if (MB_SLA_RXBUF[0] == gUsartTx.Sla_Add) // The sending and receiving nodes are consistent
			{
				pit_1ms_count3 = 0;
				timeout_flag = 0;
				if (MB_SLA_RXBUF[1] == gUsartTx.CMD)
				{
					if (gUsartTx.CMD == 0x03) // Read command response
					{
						if (gUsartTx.Len == MB_SLA_RXBUF[2]) // Judge whether the number of read bytes sent and responded is the same
						{
							for (i = 0; i < MB_SLA_RXBUF[2] / 2; i++) // Save variables
							{
								var[2 * (gUsartTx.Var_Add) + 2 * i] = MB_SLA_RXBUF[3 + 2 * i];
								var[2 * (gUsartTx.Var_Add) + 2 * i + 1] = MB_SLA_RXBUF[3 + 2 * i + 1];

								if (gUsartTx.Var_Add >= VAR_ADDR && gUsartTx.Var_Add <= (VAR_ADDR+0xFF)) // Register address
								{
									flag_MB_REG[gUsartTx.Var_Add - VAR_ADDR + i] = 1;
								}
							}

							/*   Customization
							//Solves the problem that the new value of the variable is overwritten by the old value when the variable is read and written at the same time
							if(Master_mode03_flag[0] == 1)
							{
								var[0x2002*2]   = Master_mode03_Var[0];
								var[0x2002*2+1] = Master_mode03_Var[1];
							}
							if(Master_mode03_flag[1] == 1)
							{
								var[0x2003*2]   = Master_mode03_Var[2];
								var[0x2003*2+1] = Master_mode03_Var[3];
							}
							*/

							if (gUsartTx.Mode == 0x02) // Data clearing of parameter pointer address in mode 2
							{
								var[2 * (gUsartTx.Opt_Add)] = 0;
								var[2 * (gUsartTx.Opt_Add) + 1] = 0;
							}
							else if (gUsartTx.Mode == 0x03) // Customized Code_ The flag bit corresponding to mode 3 is cleared
							{
								Master_mode03_flag[gUsartTx.Opt_Add] = 0;
							}
							tx_repeat_cnt = 0;
							tx_repeat_flag = 0; // The response will not need to be retransmitted, and the next command will be executed
						}
						else
						{
							tx_repeat_flag = 1;
						}
					}
					else if (gUsartTx.CMD == 0x06) // Write instruction response
					{
						if (gUsartTx.REG_Add == (MB_SLA_RXBUF[2] << 8 | MB_SLA_RXBUF[3])) // Judge whether the register address of sending and responding is the same
						{
							if (gUsartTx.Mode == 0x02) // Data clearing of parameter pointer address in mode 2
							{
								var[2 * (gUsartTx.Opt_Add)] = 0;
								var[2 * (gUsartTx.Opt_Add) + 1] = 0;
							}
							else if (gUsartTx.Mode == 0x03) // Customized Code_ The flag bit corresponding to mode 3 is cleared
							{
								Master_mode03_flag[gUsartTx.Opt_Add] = 0;
							}
							tx_repeat_cnt = 0;
							tx_repeat_flag = 0; // The response will not need to be retransmitted, and the next command will be executed
						}
						else
						{
							tx_repeat_flag = 1;
						}
					}
					else if (gUsartTx.CMD == 0x10) // Write multiple instruction response
					{
						if (gUsartTx.REG_Add == (MB_SLA_RXBUF[2] << 8 | MB_SLA_RXBUF[3])) // Judge whether the register address of sending and responding is the same
						{
							if (gUsartTx.Mode == 0x02) // Data clearing of parameter pointer address in mode 2
							{
								var[2 * (gUsartTx.Opt_Add)] = 0;
								var[2 * (gUsartTx.Opt_Add) + 1] = 0;
							}
							else if (gUsartTx.Mode == 0x03) // Customized Code_ The flag bit corresponding to mode 3 is cleared
							{
								Master_mode03_flag[gUsartTx.Opt_Add] = 0;
							}
							tx_repeat_cnt = 0;
							tx_repeat_flag = 0; // The response will not need to be retransmitted, and the next command will be executed
						}
						else
						{
							tx_repeat_flag = 1;
						}
					}
				}
				else // Resend if the answer is wrong
				{
					tx_repeat_flag = 1;
				}
			}
			else // Resend if the sending and receiving nodes are inconsistent
			{
				tx_repeat_flag = 1;
			}
		}
		else
		{
			tx_repeat_flag = 1; // Resend if CRC check error
		}
		if (gUsartTx.Sla_Add != 0)
			tx_en_flag = 1; // After receiving a frame of unicast mode slave response, it is allowed to send flag bit enable
		//		gUsartRx.Count = 0;
	}

	if (pit_1ms_count3 > gUsartTx.Timeout && timeout_flag)
	{
		pit_1ms_count3 = 0;
		timeout_flag = 0;
		tx_repeat_flag = 1;
		tx_en_flag = 1; // After receiving a frame, allow to send flag bit enable
	}

	if (pit_1ms_count2 > 10)
	{
		pit_1ms_count2 = 0;

		tx_10ms_cnt++;
		if (tx_10ms_cnt > 50)
		{
			//			tx_10ms_cnt = 0;
			tx_500ms_flag = 1;
		}

		if (Gif_num > 0)
			Gif_flag = 1;
		if (Adj_loop > 0)
			Adj_time++;
		if (DioKb_flag == 1)
			Cusor_time++;
		if (AioKb_flag == 1)
			Cusor_time++;
		if (GBKioKb_flag == 1)
			Cusor_time++;
		if (Scroll_num > 0)
			Scroll_flag = 1;
		if (curve_num > 0)
			curve_flag = 1;
		if (Backlight_flag)
			Backlight_count++;
		if (buzzer_start)
		{
			buzzer_10ms_count++;
			if (buzzer_10ms_count >= 5)
			{
				touch_buzzer_close();
				buzzer_start = 0;
				buzzer_10ms_count = 0;
			}
		}
#if (LT_TOUCH_FLAG == 1)
		if (RTP_read_Flag == 1)
		{
			RTP_time++;
			if (RTP_time > 5)
			{
				RTP_read_Flag = 0;
				RTP_time = 0;
			}
		}
#endif
		page_refreshing++;
		ctp_press_t++;

#if LT_ENCODER
		if (Encoder_read_Flag == 1)
		{
			Encoder_time++;
			if (Encoder_time > 1)
			{
				if (EPORT_ReadGpioData(EPORT_PIN4) == 1)
					SW_flag = 1;
				Encoder_read_Flag = 0;

				Encoder_time = 0;
			}
		}
		if (Enc1)
		{
			Encoder_Freetime++;
			if (Encoder_Freetime > 100)
			{
				Encoder_Freetime = 0;
				knob_dir = 0;
				Enc1 = 0;
			}
		}
#endif
	}
}
#endif

void PIT2_Init(uint16_t arr)
{
	NVIC_Init(2, 0, PIT2_IRQn, 2);

	PIT2->PCSR &= (~PCSR_EN);
	PIT2->PCSR = (0 << 8) | PCSR_OVW | PCSR_PIE | PCSR_RLD | PCSR_PDBG; // 75mhz/1  Interrupt mode
	PIT2->PMR = arr - 3;

	PIT2->PCSR &= ~PCSR_EN;
}

void PIT2_IRQHandler(void)
{
}

// Disable timer PIT1
void LT_UsartTimeDisable(void)
{
	PIT1->PCSR &= ~PCSR_PIE;
	PIT1->PCSR &= ~PCSR_EN;
}

// Enable timer PIT1
void LT_UsartTimeEnable(void)
{

	PIT1->PCSR |= PCSR_PIE;
	PIT1->PCSR |= PCSR_EN;
}

// Set Load value for timer PIT1
void LT_UsartTimeSetCounter(uint32_t Counter)
{
	PIT1->PMR = Counter;
	PIT1->PCSR |= PCSR_PIF;
	LT_UsartTimeEnable();
}
