/*
 * alg_demo.c
 *
 *  Created on: 201769
 *      Author: 
 */

#include "alg_drv.h"
#include "debug.h"
#include "string.h"
#include "alg_drv.h"
#include "eflash_drv.h"
#include "cpm_drv.h"
#include "core_cm4.h"
#include "algo_demo.h"
#include "trng_drv.h"

static void AES_Demo(void)
{
	int i, datalen;
	unsigned char ed_mode, cbc_mode;
	unsigned char encr_key[32] = {0x11,0x22,0x33,0x44,0x55,0x66,0x77,0x88,0x99,0xAA,0xBB,0xCC,0xDD,0xEE,0xFF,0x00,0x11,0x22,0x33,0x44,0x55,0x66,0x77,0x88,0x99,0xAA,0xBB,0xCC,0xDD,0xEE,0xFF,0x00};
	unsigned char cbc_iv[16] = {0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11};
	unsigned int key_mode;
	unsigned char srcaddr[1024] = {0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F};
	unsigned char desaddr1[1024];
	unsigned char desaddr2[1024];
	int result;
	const unsigned char cipher_aes128_ecb[32] = {0xA5,0xD2,0xAB,0x70,0x45,0xD0,0x96,0xA4,0xC2,0xF1,0xE3,0xFA,0x0C,0x0C,0xC3,0x2C,0xA5,0xD2,0xAB,0x70,0x45,0xD0,0x96,0xA4,0xC2,0xF1,0xE3,0xFA,0x0C,0x0C,0xC3,0x2C};
	const unsigned char cipher_aes192_ecb[32] = {0x23,0xB1,0x26,0x2D,0xE8,0xD6,0xA5,0x73,0xB7,0x89,0x32,0xDD,0x15,0x71,0x70,0xA4,0x23,0xB1,0x26,0x2D,0xE8,0xD6,0xA5,0x73,0xB7,0x89,0x32,0xDD,0x15,0x71,0x70,0xA4};
	const unsigned char cipher_aes256_ecb[32] = {0xAD,0xA6,0xDB,0xCD,0x7B,0xA9,0xC6,0xDA,0x07,0x50,0x04,0x2C,0x56,0x03,0xAE,0x47,0xAD,0xA6,0xDB,0xCD,0x7B,0xA9,0xC6,0xDA,0x07,0x50,0x04,0x2C,0x56,0x03,0xAE,0x47};

	const unsigned char cipher_aes128_cbc[32] = {0x77,0xDF,0xA7,0x24,0x98,0x3C,0x2C,0x4C,0x38,0xC2,0x95,0x86,0xFF,0xD6,0x2F,0x94,0x2A,0x2A,0x6D,0x00,0x04,0x33,0x64,0x40,0x73,0x36,0xC5,0x76,0x42,0xD0,0x4E,0x2D};
//	const unsigned char cipher_aes192_cbc[32] = {0xB9,0xD1,0x5B,0x06,0x1C,0x5A,0xC9,0x88,0x46,0x2A,0x73,0x2D,0xA8,0xDA,0x10,0x40,0x3B,0xB5,0xA6,0x48,0xC9,0xC4,0xE5,0x82,0x3E,0xDF,0x20,0xF0,0x13,0xD4,0x18,0x23};
//	const unsigned char cipher_aes256_cbc[32] = {0x43,0xD5,0x99,0xD1,0x7E,0x6F,0x93,0x12,0xEA,0x59,0xAB,0x19,0xE1,0xEF,0x75,0x00,0x39,0x0E,0x96,0xE1,0xB9,0xEC,0x64,0x57,0x5C,0x41,0xBC,0x36,0xD7,0x1F,0x82,0x94};


	/********************** ʹù̶*****************************/
	datalen = 32;

	// aes 128 ecb
	ed_mode = 0;
	cbc_mode = 0;
	key_mode = 0;

	memset(desaddr1,0x0,sizeof(desaddr1));

	result = AES_EnDecrypt_2(ed_mode,cbc_mode,encr_key,cbc_iv,key_mode, srcaddr, desaddr1, datalen);

	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}

	for(i=0; i<datalen; i++)
	{
		if(desaddr1[i] != *((uint8_t*)cipher_aes128_ecb+i))
		{
			__asm volatile("bkpt 0x12");
		}
	}

	ed_mode = 1;
	result = AES_EnDecrypt_2(ed_mode,cbc_mode,encr_key,cbc_iv,key_mode, desaddr1, desaddr2, datalen);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}

	for(i=0; i<datalen; i++)
	{
		if(srcaddr[i] != desaddr2[i])
		{
			__asm volatile("bkpt 0x12");
		}
	}

	// aes 128 cbc
	ed_mode = 0;
	cbc_mode = 1;
	key_mode = 0;

	result = AES_EnDecrypt_2(ed_mode,cbc_mode,encr_key,cbc_iv,key_mode, srcaddr, desaddr1, datalen);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}

	for(i=0; i<datalen; i++)
	{
		if(desaddr1[i] != *((uint8_t*)cipher_aes128_cbc+i))
		{
			__asm volatile("bkpt 0x12");
		}
	}

	ed_mode = 1;

	result = AES_EnDecrypt_2(ed_mode,cbc_mode,encr_key,cbc_iv,key_mode, desaddr1, desaddr2, datalen);

	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	for(i=0; i<datalen; i++)
	{
		if(srcaddr[i] != desaddr2[i])
		{
			__asm volatile("bkpt 0x12");
		}
	}
	
	// aes 192 ecb
	ed_mode = 0;
	cbc_mode = 0;
	key_mode = 1;

	result = AES_EnDecrypt_2(ed_mode,cbc_mode,encr_key,cbc_iv,key_mode, srcaddr, desaddr1, datalen);

	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}

	for(i=0; i<datalen; i++)
	{
		if(desaddr1[i] != *((uint8_t*)cipher_aes192_ecb+i))
		{
			__asm volatile("bkpt 0x12");
		}
	}

	ed_mode = 1;

	result = AES_EnDecrypt_2(ed_mode,cbc_mode,encr_key,cbc_iv,key_mode, desaddr1, desaddr2, datalen);

	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}

	for(i=0; i<datalen; i++)
	{
		if(srcaddr[i] != desaddr2[i])
		{
			__asm volatile("bkpt 0x12");
		}
	}	

	// aes 192 cbc
	key_mode = 1;
	ed_mode = 0;	
	cbc_mode = 1;

	result = AES_EnDecrypt_2(ed_mode,cbc_mode,encr_key,cbc_iv,key_mode, srcaddr, desaddr1, datalen);

	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	/*
	for(i=0; i<datalen; i++)
	{
		if(desaddr1[i] != *((uint8_t*)cipher_aes192_ctr+i))
		{
			__asm volatile("bkpt 0x12");
		}
	}
	*/
	ed_mode = 1;

	result = AES_EnDecrypt_2(ed_mode,cbc_mode,encr_key,cbc_iv,key_mode, desaddr1, desaddr2, datalen);

	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}

	for(i=0; i<datalen; i++)
	{
		if(srcaddr[i] != desaddr2[i])
		{
			__asm volatile("bkpt 0x12");
		}
	}	
	
	// aes 256 ecb
	key_mode = 2;
	ed_mode = 0;	
	cbc_mode = 0;

	result = AES_EnDecrypt_2(ed_mode,cbc_mode,encr_key,cbc_iv,key_mode, srcaddr, desaddr1, datalen);

	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}

	for(i=0; i<datalen; i++)
	{
		if(desaddr1[i] != *((uint8_t*)cipher_aes256_ecb+i))
		{
			__asm volatile("bkpt 0x12");
		}
	}

	ed_mode = 1;

	result = AES_EnDecrypt_2(ed_mode,cbc_mode,encr_key,cbc_iv,key_mode, desaddr1, desaddr2, datalen);

	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	for(i=0; i<datalen; i++)
	{
		if(srcaddr[i] != desaddr2[i])
		{
			__asm volatile("bkpt 0x12");
		}
	}


	// aes 256 cbc
	key_mode = 2;
	ed_mode = 0;	
	cbc_mode = 1;

	result = AES_EnDecrypt_2(ed_mode,cbc_mode,encr_key,cbc_iv,key_mode, srcaddr, desaddr1, datalen);

	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	/*
	for(i=0; i<datalen; i++)
	{
		if(desaddr1[i] != *((uint8_t*)cipher_aes256_ctr+i))
		{
			__asm volatile("bkpt 0x12");
		}
	}
	*/
	ed_mode = 1;

	result = AES_EnDecrypt_2(ed_mode,cbc_mode,encr_key,cbc_iv,key_mode, desaddr1, desaddr2, datalen);

	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	for(i=0; i<datalen; i++)
	{
		if(srcaddr[i] != desaddr2[i])
		{
			__asm volatile("bkpt 0x12");
		}
	}

	/********************** ʹ*****************************/
	datalen = 1024;
	for(i=0; i<32; i++)
	{
		encr_key[i] = (uint8_t)GetRandomWord();
	}

	for (i=0; i<16; i++)
	{
		cbc_iv[i] = (uint8_t)GetRandomWord();
	}

	for(i = 0 ; i < datalen ; i++)
	{
		srcaddr[i]  = (uint8_t)GetRandomWord();
		desaddr1[i] = 0;
		desaddr2[i] = 0;
	}

	cbc_mode   = ((unsigned char)GetRandomWord())%2;
	key_mode = ((unsigned char)GetRandomWord())%3;

	ed_mode = 0;

	result = AES_EnDecrypt_2(ed_mode,cbc_mode,encr_key,cbc_iv,key_mode, srcaddr, desaddr1, datalen);

	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}

	ed_mode = 1;

	result = AES_EnDecrypt_2(ed_mode,cbc_mode,encr_key,cbc_iv,key_mode, desaddr1, desaddr2, datalen);

	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}

	for(i=0; i<datalen; i++)
	{
		if(srcaddr[i] != desaddr2[i])
		{
			__asm volatile("bkpt 0x12");
		}
	}

	result = AES_EnDecrypt_2(ed_mode,cbc_mode,(uint8_t *)0x8042018,cbc_iv,key_mode, srcaddr, desaddr1, datalen);

	if (result != SUCCESS_ALG)
	{
		printf("AES eflash test fail\r\n");
		__asm volatile("bkpt 0x12");
	}

}

static void DES_Demo(void)
{
	int i, datalen;
	unsigned char iv[8] = {0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11};
	unsigned char ed_mode, s_mode;
	unsigned char key[24] = {0x11,0x22,0x33,0x44,0x55,0x66,0x77,0x88,0x99,0xAA,0xBB,0xCC,0xDD,0xEE,0xFF,0x00,0x22,0x22,0x22,0x22,0x22,0x22,0x22,0x22};
	unsigned char srcaddr[1024] = {0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F};
	unsigned char desaddr1[1024];
	unsigned char desaddr2[1024];
	int result;
	const unsigned char cipher_des_ecb[32] = {0x9A,0xB9,0xB1,0x88,0xB1,0x6A,0x62,0x40,0xD6,0x59,0x0D,0x1D,0x61,0x67,0xC2,0x64,0x9A,0xB9,0xB1,0x88,0xB1,0x6A,0x62,0x40,0xD6,0x59,0x0D,0x1D,0x61,0x67,0xC2,0x64};
	const unsigned char cipher_des_cbc[32] = {0x0F,0x8A,0x55,0x58,0x1C,0x69,0xF6,0x82,0x93,0x60,0x49,0x14,0xBF,0xB2,0xCB,0x0E,0xDD,0x75,0x92,0xFE,0xD3,0x5D,0xA9,0x2B,0x8C,0x3A,0x54,0x8D,0x36,0xB6,0x62,0x3C};
	const unsigned char cipher_3des2_ecb[32] = {0x47,0x8B,0x31,0x5F,0xA9,0x00,0xFE,0x28,0xE1,0xDA,0x75,0x14,0x8E,0x26,0x9B,0x66,0x47,0x8B,0x31,0x5F,0xA9,0x00,0xFE,0x28,0xE1,0xDA,0x75,0x14,0x8E,0x26,0x9B,0x66};
	const unsigned char cipher_3des2_cbc[32] = {0x7D,0xA1,0xF9,0x15,0x5B,0x0B,0xE5,0x72,0x5A,0x2A,0x39,0x53,0x22,0x92,0xD8,0x71,0x85,0x19,0x4F,0x5B,0xC0,0x59,0x39,0xCF,0x3D,0xEF,0x1C,0x5A,0x15,0x3B,0x68,0xFF};
	const unsigned char cipher_3des3_ecb[32] = {0x88,0x27,0xCD,0x4C,0x95,0xD5,0x71,0x5F,0x1C,0xED,0x9C,0x53,0x55,0x5C,0xEC,0xD1,0x88,0x27,0xCD,0x4C,0x95,0xD5,0x71,0x5F,0x1C,0xED,0x9C,0x53,0x55,0x5C,0xEC,0xD1};
	const unsigned char cipher_3des3_cbc[32] = {0x7D,0x2D,0x72,0x6D,0x98,0x0E,0xD7,0x7D,0xD0,0x42,0xCE,0x69,0xCE,0xEF,0xA8,0x0A,0xAA,0x1F,0x3B,0x7F,0x27,0x17,0x6B,0x7D,0x58,0x84,0x83,0x95,0x82,0x96,0xA4,0x49};

	/********************** ʹù̶*****************************/
	datalen = 32;

	// des 8ֽԿecb
	s_mode = 0;
	ed_mode = 0;
	result = DES_EnDecrypt_2(ed_mode, s_mode, key, 8, iv, srcaddr, desaddr1, datalen, 0);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	for(i=0; i<datalen; i++)
	{
		if(desaddr1[i] != *((uint8_t*)cipher_des_ecb+i))
		{
			__asm volatile("bkpt 0x12");
		}
	}
	ed_mode = 1;
	result = DES_EnDecrypt_2(ed_mode, s_mode, key, 8, iv, desaddr1, desaddr2, datalen, 0);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	for(i=0; i<datalen; i++)
	{
		if(srcaddr[i] != desaddr2[i])
		{
			__asm volatile("bkpt 0x12");
		}
	}

	// des 8ֽԿcbc
	s_mode = 1;
	ed_mode = 0;
	result = DES_EnDecrypt_2(ed_mode, s_mode, key, 8, iv, srcaddr, desaddr1, datalen, 0);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	for(i=0; i<datalen; i++)
	{
		if(desaddr1[i] != *((uint8_t*)cipher_des_cbc+i))
		{
			__asm volatile("bkpt 0x12");
		}
	}
	ed_mode = 1;
	result = DES_EnDecrypt_2(ed_mode, s_mode, key, 8, iv, desaddr1, desaddr2, datalen, 0);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	for(i=0; i<datalen; i++)
	{
		if(srcaddr[i] != desaddr2[i])
		{
			__asm volatile("bkpt 0x12");
		}
	}


	// 3des 16ֽԿecb
	s_mode = 0;
	ed_mode = 0;
	result = DES_EnDecrypt_2(ed_mode, s_mode, key, 16, iv, srcaddr, desaddr1, datalen, 0);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	for(i=0; i<datalen; i++)
	{
		if(desaddr1[i] != *((uint8_t*)cipher_3des2_ecb+i))
		{
			__asm volatile("bkpt 0x12");
		}
	}
	ed_mode = 1;
	result = DES_EnDecrypt_2(ed_mode, s_mode, key, 16, iv, desaddr1, desaddr2, datalen, 0);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	for(i=0; i<datalen; i++)
	{
		if(srcaddr[i] != desaddr2[i])
		{
			__asm volatile("bkpt 0x12");
		}
	}

	// 3des 16ֽԿcbc
	s_mode = 1;
	ed_mode = 0;
	result = DES_EnDecrypt_2(ed_mode, s_mode, key, 16, iv, srcaddr, desaddr1, datalen, 0);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	for(i=0; i<datalen; i++)
	{
		if(desaddr1[i] != *((uint8_t*)cipher_3des2_cbc+i))
		{
			__asm volatile("bkpt 0x12");
		}
	}
	ed_mode = 1;
	result = DES_EnDecrypt_2(ed_mode, s_mode, key, 16, iv, desaddr1, desaddr2, datalen, 0);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	for(i=0; i<datalen; i++)
	{
		if(srcaddr[i] != desaddr2[i])
		{
			__asm volatile("bkpt 0x12");
		}
	}

	// 3des 24ֽԿecb
	s_mode = 0;
	ed_mode = 0;
	result = DES_EnDecrypt_2(ed_mode, s_mode, key, 24, iv, srcaddr, desaddr1, datalen, 0);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	for(i=0; i<datalen; i++)
	{
		if(desaddr1[i] != *((uint8_t*)cipher_3des3_ecb+i))
		{
			__asm volatile("bkpt 0x12");
		}
	}
	ed_mode = 1;
	result = DES_EnDecrypt_2(ed_mode, s_mode, key, 24, iv, desaddr1, desaddr2, datalen, 0);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	for(i=0; i<datalen; i++)
	{
		if(srcaddr[i] != desaddr2[i])
		{
			__asm volatile("bkpt 0x12");
		}
	}

	// 3des 24ֽԿcbc
	s_mode = 1;
	ed_mode = 0;
	result = DES_EnDecrypt_2(ed_mode, s_mode, key, 24, iv, srcaddr, desaddr1, datalen, 0);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	for(i=0; i<datalen; i++)
	{
		if(desaddr1[i] != *((uint8_t*)cipher_3des3_cbc+i))
		{
			__asm volatile("bkpt 0x12");
		}
	}
	ed_mode = 1;
	result = DES_EnDecrypt_2(ed_mode, s_mode, key, 24, iv, desaddr1, desaddr2, datalen, 0);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	for(i=0; i<datalen; i++)
	{
		if(srcaddr[i] != desaddr2[i])
		{
			__asm volatile("bkpt 0x12");
		}
	}

	/********************** ʹ*****************************/
	datalen = 1024;

	for(i = 0 ; i < 24 ; i++)
	{
		key[i] = (uint8_t)GetRandomWord();
	}
	for (i=0; i<8; i++)
	{
		iv[i] = (uint8_t)GetRandomWord();
	}

	s_mode = ((unsigned char)GetRandomWord())%2;

	for(i = 0 ; i < datalen ; i++)
	{
		srcaddr[i]  = (uint8_t)GetRandomWord();
		desaddr1[i] = 0;
		desaddr2[i] = 0;
	}

	ed_mode = 0;
	result = DES_EnDecrypt_2(ed_mode, s_mode, key, 8, iv, srcaddr, desaddr1, datalen, 0);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}

	ed_mode = 1;
	result = DES_EnDecrypt_2(ed_mode, s_mode, key, 8, iv, desaddr1, desaddr2, datalen, 0);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}

	for(i = 0 ; i < datalen ; i++)
	{
		if(srcaddr[i] != desaddr2[i])
		{
			__asm volatile("bkpt 0x12");
		}
	}

	result = DES_EnDecrypt_2(ed_mode, s_mode, (uint8_t *)0X8042001, 8, iv, srcaddr, desaddr1, datalen, 0);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
}


static void SMS4_Demo(void)
{
	int i, datalen;
	int result;

	unsigned char ed_mode, s_mode;
	unsigned char srcaddr[1024]={0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F};
	unsigned char desaddr1[1024];
	unsigned char desaddr2[1024];
	unsigned char SMS4_KEY[16] = {0x11,0x22,0x33,0x44,0x55,0x66,0x77,0x88,0x99,0xAA,0xBB,0xCC,0xDD,0xEE,0xFF,0x00};
	unsigned char SMS4_IV[16] = {0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11};
	const unsigned char cipher_sm4_ecb[32] = {0x03,0xF8,0xF5,0x14,0x4B,0xF1,0x2F,0xD1,0x80,0xB2,0x87,0x7F,0x5B,0x2C,0x6E,0x2C,0x03,0xF8,0xF5,0x14,0x4B,0xF1,0x2F,0xD1,0x80,0xB2,0x87,0x7F,0x5B,0x2C,0x6E,0x2C};
	const unsigned char cipher_sm4_cbc[32] = {0x8E,0xCF,0xEA,0x12,0x19,0x70,0x33,0x73,0x11,0x32,0xFD,0xC2,0x1F,0x65,0x39,0x9D,0xA0,0x60,0xA1,0x15,0xD3,0x44,0xC0,0x99,0x66,0x4D,0xF4,0xA7,0x33,0x05,0xBE,0x19};


	/********************** ʹù̶*****************************/
	datalen = 32;
	// sm4 ecb
	s_mode = 0;
	ed_mode = 0;
	result = SMS4_EnDecrypt_2(ed_mode, s_mode, SMS4_KEY, SMS4_IV, srcaddr, desaddr1, datalen);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	for(i=0; i<datalen; i++)
	{
		if(desaddr1[i] != *((uint8_t*)cipher_sm4_ecb+i))
		{
			__asm volatile("bkpt 0x12");
		}
	}

	ed_mode = 1;
	result = SMS4_EnDecrypt_2(ed_mode, s_mode, SMS4_KEY, SMS4_IV, desaddr1, desaddr2, datalen);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}

	for(i=0; i<datalen; i++)
	{
		if(srcaddr[i] != desaddr2[i])
		{
			__asm volatile("bkpt 0x12");
		}
	}

	// sm4 cbc
	s_mode = 1;
	ed_mode = 0;
	result = SMS4_EnDecrypt_2(ed_mode, s_mode, SMS4_KEY, SMS4_IV, srcaddr, desaddr1, datalen);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	for(i=0; i<datalen; i++)
	{
		if(desaddr1[i] != *((uint8_t*)cipher_sm4_cbc+i))
		{
			__asm volatile("bkpt 0x12");
		}
	}
	ed_mode = 1;
	result = SMS4_EnDecrypt_2(ed_mode, s_mode, SMS4_KEY, SMS4_IV, desaddr1, desaddr2, datalen);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}

	for(i=0; i<datalen; i++)
	{
		if(srcaddr[i] != desaddr2[i])
		{
			__asm volatile("bkpt 0x12");
		}
	}

	/********************** ʹ*****************************/
	datalen = 1024;
	for(i=0; i<16; i++)
	{
		SMS4_KEY[i] = (uint8_t)GetRandomWord();
		SMS4_IV[i] = (uint8_t)GetRandomWord();
	}

	for(i=0; i<datalen; i++)
	{
		srcaddr[i]  = (uint8_t)GetRandomWord();
		desaddr1[i] = 0;
		desaddr2[i] = 0;
	}

	s_mode = ((unsigned char)GetRandomWord())%2;

	ed_mode = 0;
	result = SMS4_EnDecrypt_2(ed_mode, s_mode, SMS4_KEY, SMS4_IV, srcaddr, desaddr1, datalen);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}

	ed_mode = 1;
	result = SMS4_EnDecrypt_2(ed_mode, s_mode, SMS4_KEY, SMS4_IV, desaddr1, desaddr2, datalen);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}

	for(i = 0 ; i < datalen ; i++)
	{
		if(srcaddr[i] != desaddr2[i])
		{
			__asm volatile("bkpt 0x12");
		}
	}

	result = SMS4_EnDecrypt_2(ed_mode, s_mode, (uint8_t *)0X8042005, SMS4_IV, desaddr1, desaddr2, datalen);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}

}

static void SHA_Demo(void)
{
	unsigned int i, len;
	unsigned char *pbuf;

	unsigned char sha_result[64];
	unsigned char sha_tmp[64];
	unsigned char buf[2048];
	unsigned char fixdata_sha256[0xB0] = {0xC5,0x01,0x5F,0x72,0x44,0x71,0x2D,0x2B,0x96,0x1F,0x1C,0x4A,0xBE,0x28,0xE9,0x51,0x1E,0x28,0x8F,0x0D,0x7D,0x4D,0x9E,0x03,0x6C,0x6B,0xA0,0x11,0x9E,0x51,0x82,0x57,0x2E,0x1B,0x50,0x1B,0xEA,0x17,0xC9,0x4F,0x19,0x71,0x92,0x7C,0x5A,0x6D,0x18,0x7D,0x8B,0x14,0x5C,0x73,0xDA,0x3B,0x3C,0x76,0x6F,0x03,0xFD,0x7E,0x4E,0x5A,0x1C,0x78,0x62,0x02,0xB1,0x1F,0xD3,0x1D,0xEC,0x41,0x13,0x58,0x73,0x34,0x47,0x10,0xA4,0x01,0xF0,0x57,0x12,0x6B,0x0B,0x70,0xB1,0x64,0xFF,0x7F,0x87,0x76,0x07,0x5D,0xEA,0x20,0x09,0x2E,0x86,0x7F,0xEF,0x56,0xC5,0x09,0xFE,0x2F,0x53,0x03,0xC5,0x70,0xCB,0x05,0x95,0x33,0xD7,0x14,0xA0,0x5D,0x49,0x78,0x33,0x59,0xF3,0x33,0xAB,0x3A,0x49,0x73,0x0E,0x6E,0x14,0x2F,0x70,0x3A,0xC0,0x45,0x92,0x11,0x08,0x43,0x57,0x15,0x09,0x3A,0x04,0x4A,0x10,0x6D,0x69,0x63,0x92,0x18,0x65,0x4C,0x36,0x23,0x5A,0x43,0xD6,0x42,0x99,0x7B,0xE0,0x66,0xC7,0x72,0x8B,0x7A,0xC8,0x62,0xA6,0x65,0xBC,0x3B,0x1C,0x29};

	Hash_tx haha;
	int result;

	pbuf = (unsigned char *)buf;
	for(i=0; i<2048; i++)
	{
		*(unsigned char *)(pbuf+i) = (unsigned char)GetRandomWord();
	}

	//ݳ
	len = 1025;

	/*****************************  SM3  ******************************/
	SHA_Init_2(&haha, HASH_SM3);
	SHA_Update_2(&haha, pbuf, 1025);
	SHA_Final_2(&haha, sha_result);

	SHA_Init_2(&haha, HASH_SM3);
	for(i = 0 ; i < 1024 ; i = i + 64)
	{
		SHA_Update_2(&haha, pbuf + i, 64);
	}

	SHA_Update_2(&haha, pbuf + 1024, len - 1024);
	SHA_Final_2(&haha, sha_tmp);

	for(i = 0 ; i < SM3_R_Len ; i++)
	{
		if(sha_tmp[i] != sha_result[i])
		{
			printf("\n MODE_SM3 ERROR: Soft_Data_out[%d]=[0x%x]!=[0x%x]\n", i, sha_tmp[i], sha_result[i]);
			__asm volatile("bkpt 0x12");
		}
	}
	printf("\nsm3 test ok\n");

	/*****************************  SHA-0  ******************************/
	SHA_Init_2(&haha, HASH_SHA0);
	SHA_Update_2(&haha, pbuf, 1025);
	SHA_Final_2(&haha, sha_result);

	SHA_Init_2(&haha, HASH_SHA0);
	for(i = 0 ; i < 1024 ; i = i + 64)
	{
		SHA_Update_2(&haha, pbuf + i, 64);
	}
	SHA_Update_2(&haha, pbuf + 1024, len - 1024);
	SHA_Final_2(&haha, sha_tmp);

	for(i = 0 ; i < SHA0_R_Len ; i++)
	{
		if(sha_tmp[i] != sha_result[i])
		{
			printf("\n MODE_SHA0 ERROR: Soft_Data_out[%d]=[0x%x]!=[0x%x]\n",i,sha_tmp[i],sha_result[i]);
			__asm volatile("bkpt 0x12");
		}
	}
	printf("\nsha0 test ok\n");

	/*****************************  SHA-1  ******************************/
	SHA_Init_2(&haha, HASH_SHA1);
	SHA_Update_2(&haha, pbuf, 1025);
	SHA_Final_2(&haha, sha_result);

	SHA_Init_2(&haha, HASH_SHA1);
	for(i = 0 ; i < 1024 ; i = i + 64)
	{
		SHA_Update_2(&haha, pbuf + i, 64);
	}
	SHA_Update_2(&haha, pbuf + 1024, len - 1024);
	SHA_Final_2(&haha, sha_tmp);

	for(i = 0 ; i < SHA1_R_Len ; i++)
	{
		if(sha_tmp[i] != sha_result[i])
		{
			printf("\n MODE_SHA1 ERROR: Soft_Data_out[%d]=[0x%x]!=[0x%x]\n",i,sha_tmp[i],sha_result[i]);
			__asm volatile("bkpt 0x12");
		}
	}
	printf("\nsha1 test ok\n");

	/*****************************  SHA-224  ******************************/
	SHA_Init_2(&haha, HASH_SHA224);
	SHA_Update_2(&haha, pbuf, 1025);
	SHA_Final_2(&haha, sha_result);

	SHA_Init_2(&haha, HASH_SHA224);
	for(i = 0 ; i < 1024 ; i = i + 64)
	{
		SHA_Update_2(&haha, pbuf + i, 64);
	}

	SHA_Update_2(&haha, pbuf + 1024, len - 1024);
	SHA_Final_2(&haha, sha_tmp);

	for(i = 0 ; i < SHA224_R_Len ; i++)
	{
		if(sha_tmp[i] != sha_result[i])
		{
			printf("\n MODE_SHA224 ERROR: Soft_Data_out[%d]=[0x%x]!=[0x%x]\n", i, sha_tmp[i], sha_result[i]);
			__asm volatile("bkpt 0x12");
		}
	}
	printf("\nsha224 test ok\n");

	/*****************************  SHA-256  ******************************/

	//********************ʹù̶ݲ*******************
	memcpy(pbuf, fixdata_sha256, 0xB0);
	result = SHA_Init_2(&haha, HASH_SHA256);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	result = SHA_Update_2(&haha, pbuf, 0xB0);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	result = SHA_Final_2(&haha, sha_result);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}


	//********************ʹ*********************
	result = SHA_Init_2(&haha, HASH_SHA256);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	result = SHA_Update_2(&haha, pbuf, 1025);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	result = SHA_Final_2(&haha, sha_result);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}

	result = SHA_Init_2(&haha, HASH_SHA256);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}

	for(i = 0 ; i < 1024 ; i = i + 64)
	{
		result = SHA_Update_2(&haha, pbuf + i, 64);
		if (result != SUCCESS_ALG)
		{
			__asm volatile("bkpt 0x12");
		}
	}

	result = SHA_Update_2(&haha, pbuf + 1024, len - 1024);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	result = SHA_Final_2(&haha, sha_tmp);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}


	for(i = 0 ; i < SHA256_R_Len ; i++)
	{
		if(sha_tmp[i] != sha_result[i])
		{
			printf("\n MODE_SHA256 ERROR: Soft_Data_out[%d]=[0x%x]!=[0x%x]\n", i, sha_tmp[i], sha_result[i]);
			__asm volatile("bkpt 0x12");
		}
	}
	printf("\nsha256 test ok\n");

	/*****************************  SHA-384  ******************************/
	SHA_Init_2(&haha, HASH_SHA384);
	SHA_Update_2(&haha, pbuf, 1000);
	SHA_Final_2(&haha, sha_result);

	SHA_Init_2(&haha, HASH_SHA384);
	for(i=0;i<896;i=i+128)
	{
		SHA_Update_2(&haha, pbuf + i, 128);
	}

	SHA_Update_2(&haha, pbuf + 896, 1000 - 896);
	SHA_Final_2(&haha, sha_tmp);

	for(i = 0  ; i < SHA384_R_Len ; i++)
	{
		if(sha_tmp[i] != sha_result[i])
		{
			printf("\n MODE_SHA384 ERROR: Soft_Data_out[%d]=[0x%x]!=[0x%x]\n", i, sha_tmp[i], sha_result[i]);
			__asm volatile("bkpt 0x12");
		}
	}
	printf("\nsha384 test ok\n");

	/*****************************  SHA-512  ******************************/

	//********************ʹù̶ݲ*******************
	memcpy(pbuf, fixdata_sha256, 0xB0);
	result = SHA_Init_2(&haha, HASH_SHA512);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	result = SHA_Update_2(&haha, pbuf, 0xB0);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	result = SHA_Final_2(&haha, sha_result);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}

	//********************ʹ*********************

	SHA_Init_2(&haha, HASH_SHA512);
	SHA_Update_2(&haha, pbuf, 1000);
	SHA_Final_2(&haha, sha_result);

	SHA_Init_2(&haha, HASH_SHA512);
	for(i=0;i<896;i=i+128)
	{
		SHA_Update_2(&haha, pbuf + i, 128);
	}

	SHA_Update_2(&haha, pbuf + 896, 1000 - 896);
	SHA_Final_2(&haha, sha_tmp);

	for(i = 0  ; i < SHA512_R_Len ; i++)
	{
		if(sha_tmp[i] != sha_result[i])
		{
			printf("\n MODE_SHA512 ERROR: Soft_Data_out[%d]=[0x%x]!=[0x%x]\n", i, sha_tmp[i], sha_result[i]);
			__asm volatile("bkpt 0x12");
		}
	}
	printf("\nsha512 test ok\n");


	SHA_Init_2(&haha, HASH_SM3);
	SHA_Update_2(&haha, (uint8_t *)0x8042111, 200);
	SHA_Final_2(&haha, sha_result);

}

static void SM2_Demo(void)
{
	int result,i;
	uint16_t j;
	uint16_t klen;
	uint16_t entla=0;
	uint8_t plain[1024];
	uint8_t new_plain[1024];
	uint8_t cipher[1024+96];
	uint8_t IDA[128];
	uint8_t res_e[32];
	uint8_t pub_key[64];
	uint8_t pri_key[32];
	uint8_t signatureR[32];
	uint8_t signatureS[32];
	uint8_t za[32];
	uint8_t zb[32];
	uint8_t sa[32];
	uint8_t sb[32];

	const uint8_t ida[] = {0x36,0x59,0x57,0x43,0x5b,0x69,0x14,0x39};
	const uint8_t idb[] = {0x48,0x03,0xf7,0x04,0xfe,0x11,0x7d,0x81,0x31,0x37,0x30,0x33,0x32,0x32,0x10,0x20};

	uint8_t exchange_key_buf[32];
	const uint8_t exchange_cmp_key[] = {0xE7,0xAE,0xAD,0xBA,0x5C,0x53,0x2E,0x2A,0x65,0xA9,0x5B,0xFE,0xAA,0x3A,0xA2,0xF4};
	const uint8_t plain_256[16] = {0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F};
	const uint8_t cipher_256[16+96] = {0x6E,0x7F,0x44,0x1D,0x88,0x38,0x18,0x91,0x3A,0x72,0xCA,0x14,0xC0,0xF5,0xCE,0x4D,0xEC,0xE3,0xC0,0x32,0xE9,0x8A,0xDC,0x16,0xE7,0xE4,0xAA,0xAF,0xE8,0x58,0x23,0x84,0xFC,0xD0,0xBB,0x35,0x06,0x88,0x6D,0x75,0xDD,0x5E,0x16,0xBA,0x82,0x3D,0xD3,0xC1,0xDC,0x08,0x63,0x97,0x92,0xAC,0x77,0x5E,0xD4,0x4B,0x59,0xC2,0x9B,0x86,0xFA,0x12,0xE0,0xD0,0x50,0x69,0xE1,0xB0,0xB3,0x6B,0x2A,0x15,0x72,0xE4,0x86,0xF3,0x5C,0x11,0xD5,0xF9,0x0B,0x87,0x71,0x06,0x17,0x8F,0xE9,0x88,0x41,0x18,0x00,0xCD,0x70,0x5D,0x2D,0x4B,0x87,0x7A,0xC5,0xF1,0x33,0xF7,0x65,0x26,0x31,0x58,0x06,0xDA,0xD5,0x01};
	const uint8_t pub_key_256[64] = {0x3A,0x06,0x6E,0x82,0x57,0x68,0x8F,0x9C,0x94,0x0E,0x7E,0x35,0xDE,0x72,0x1F,0x31,0xA6,0x02,0x86,0x6C,0xCF,0x4E,0x08,0x16,0x95,0x18,0xCD,0xC9,0xBC,0x9D,0x0C,0x36,0x44,0x6D,0x06,0xE5,0xE2,0x59,0x53,0x1D,0x5A,0xAD,0x30,0xE6,0x81,0x13,0x3B,0x54,0x28,0xFD,0x5D,0x4E,0x70,0x3B,0xD1,0xB7,0x40,0x3A,0xE7,0xF9,0x0B,0x5A,0x92,0xF4};
	const uint8_t pri_key_256[32] = {0xF2,0xA4,0x65,0xEA,0x8A,0x33,0x92,0x90,0x79,0x0D,0x18,0x61,0x5A,0xF2,0xC5,0xBD,0x38,0x62,0x32,0x3F,0x1F,0xB7,0x24,0x08,0x9B,0x09,0x81,0x92,0x8A,0x55,0x5C,0xB8};
	const uint8_t signatureR_256[32] = {0x17,0xE7,0xD0,0x00,0x91,0x5B,0x4B,0x11,0x36,0xF3,0xFB,0x65,0xEB,0xD2,0x3B,0x61,0x11,0x9A,0xDF,0xD7,0x4E,0xD7,0xBE,0x7F,0xD3,0xF5,0x43,0x87,0x72,0x69,0xF5,0x6C};
	const uint8_t signatureS_256[32] = {0xBE,0xE7,0xAC,0x71,0x69,0x91,0x0D,0xB3,0x20,0xA6,0xC7,0xFD,0xBA,0x55,0x6B,0xD2,0x1B,0xD6,0x1C,0xB6,0x04,0x3C,0x81,0x1F,0xE3,0xE0,0x2D,0x1F,0xEB,0x81,0xF2,0xFB};
	const uint8_t Message_256[32] = {0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F};
	const uint8_t IDA_256[16] = {0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38};
	const uint8_t E_256[32] = {0x5E,0x06,0xA0,0x25,0x1B,0x30,0xBC,0x55,0x67,0xA8,0x28,0xF5,0xE4,0x01,0x91,0xE3,0x90,0x8C,0xE5,0x32,0x9D,0xBA,0x09,0xA0,0xD8,0x93,0x99,0xE0,0x45,0x74,0x03,0x12};

	const uint8_t self_pri[32] = {0x83, 0xa4, 0xbf, 0x43, 0xb3, 0x24, 0x2a, 0xbe, 0x25, 0x06, 0x22, 0x14, 0x35, 0xd5, 0xb7, 0x95, 0x6b, 0x11, 0x78, 0xb6, 0xa9, 0x12, 0x0d, 0xed, 0xc8, 0x2c, 0xfe, 0x5d, 0xae, 0xb5, 0x49, 0x36};
	const uint8_t self_pub[64] = {0x57,0xd4,0x1b,0xc4,0x60,0x1b,0x72,0x1c,0x7d,0x38,0x7c,0x80,0xcd,0x11,0xa9,0x40,0xfa,0x8a,0x9a,0x95,0x0c,0x25,0x06,0xf4,0x04,0x7d,0x54,0x01,0x67,0x59,0xf6,0x8d,0x68,0x1e,0xd2,0x8c,0x85,0x8d,0x7c,0xf6,0xfd,0x56,0xd3,0xd0,0xf0,0xf6,0xe4,0xd4,0x1c,0x12,0x3d,0x22,0xe9,0xcb,0x0f,0xc7,0x53,0xe0,0x3c,0xad,0xd5,0xde,0x85,0x75};
	const uint8_t self_temp_pri[32] = {0xdb,0xf2,0x38,0xa8,0x08,0x4f,0x92,0x79,0x55,0xdf,0x8a,0x8a,0x9c,0x4d,0xbc,0x50,0xe9,0xbe,0x8d,0x62,0x9f,0x41,0xaf,0xb3,0x9d,0x13,0xbc,0x83,0x79,0x5b,0x17,0x95};
	const uint8_t self_temp_pub[64] = {0x44,0x86,0x36,0xb9,0xbd,0x25,0x61,0x8e,0x2f,0x6c,0x4a,0x58,0x6f,0xa7,0x19,0xea,0xd9,0x5a,0x28,0xae,0x86,0x3f,0xc8,0x3f,0xbb,0x70,0x71,0xda,0xbd,0x74,0xd6,0xde,0x3b,0x1b,0xb8,0x48,0x3d,0x5a,0x9e,0x08,0x04,0x96,0xa7,0x43,0xb5,0x01,0x29,0xd5,0x32,0xa2,0xfa,0x35,0x8f,0xe6,0x61,0x70,0x7a,0x3c,0xaf,0x5e,0x0c,0xa4,0xed,0x61};
//	const uint8_t other_pri[32];
	const uint8_t other_pub[64] = {0x28,0x19,0x64,0x13,0xcf,0x51,0x37,0x9c,0x62,0x5d,0x75,0x52,0xd8,0xb2,0xfa,0x6c,0x83,0xc3,0xd9,0x95,0x99,0xf0,0x00,0x5d,0x5a,0x82,0x59,0x6c,0xef,0x1c,0x2a,0xc1,0x98,0x96,0x73,0xca,0x4d,0x6b,0x67,0xdb,0xf1,0x4d,0x98,0x5b,0x44,0x38,0x13,0x90,0x0a,0x61,0x4d,0x42,0x64,0x3b,0x20,0x80,0x75,0xa0,0xd8,0x62,0x48,0x8b,0x37,0x8e};
//	const uint8_t other_temp_pri[32];
	const uint8_t other_temp_pub[64] = {0xc3,0xb3,0x54,0xd7,0xc3,0x22,0x24,0xf6,0x69,0x40,0xb1,0xe2,0xeb,0x33,0x3a,0x25,0x7c,0x74,0x60,0x29,0xf0,0xe7,0x1e,0x05,0x74,0xc3,0xfd,0x5e,0xfc,0x25,0xb8,0xf4,0x43,0x35,0xd9,0xac,0x32,0x29,0x4b,0x73,0xde,0x8e,0xcb,0x0a,0x49,0xff,0x8a,0xef,0xa9,0x28,0x4a,0x82,0x3a,0xb8,0xf0,0x6e,0x4c,0x74,0xb7,0x2a,0xb0,0x34,0x87,0x27};

	/**********************SM2 ʼ**************************/
	result = SM2Init(SM2_TEST_BITS);

	if (result != SUCCESS_ALG)
	{
		printf("SM2 init failed!\n");
		__asm volatile("bkpt 0x12");
	}

	/********************** ʹù̶*****************************/

	klen = 16;
	memcpy(cipher, cipher_256, klen+96);
	memcpy(pri_key, pri_key_256, 32);

	result = SM2Decrypt_2(cipher, klen, pri_key, new_plain);
	if (result != SUCCESS_ALG)
	{
		printf("SM2Decrypt_2 failed!\n");
		__asm volatile("bkpt 0x12");
	}
	else
	{
		for(j=0;j<klen;j++)
		{
			if(new_plain[j] != plain_256[j])
			{
				printf("SM2 decrypt failed!\n");
				__asm volatile("bkpt 0x12");
			}
		}
	}

	//ǩ
	entla = 16;
	memcpy(IDA, IDA_256, entla);
	memcpy(pub_key, pub_key_256, 64);

	result = SM2GenerateE_2(IDA, entla, pub_key,(uint8_t *)Message_256,32,res_e);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	else
	{
		for(j=0;j<32;j++)
		{
			if(res_e[j] != E_256[j])
			{
				printf("SM2 GenE failed!\n");
				__asm volatile("bkpt 0x12");
			}
		}
	}

	klen = 32;	//ǩݳ
	memcpy(signatureR, signatureR_256, 32);
	memcpy(signatureS, signatureS_256, 32);
	result = SM2Verification_2(res_e, klen, pub_key, signatureR, signatureS);
	if(result != SUCCESS_ALG)
	{
		printf("SM2 verification failed!\n");
		__asm volatile("bkpt 0x12");
	}

	printf("\nSM2 fixdata test ok!\n");

	/********************** ʹ*****************************/

  	//ѡȡ
   	for(j = 0 ; j < 1024 ; j++)
   	{
   		plain[j] = (uint8_t)GetRandomWord();
   	}

	klen = (uint16_t)GetRandomWord();
	if((klen > 1024) || (klen == 0))
	{
		klen = 1024;
	}

	/******************************** ӽܲ ************************************/
	result = SM2GenerateKeyPair_2(pub_key, pri_key);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}

	EFLASH_PageErase(0x8042400);
	EFLASH_WordsProg(0x8042400,(uint32_t *)pub_key,16);
	EFLASH_WordsProg(0x8042440,(uint32_t *)pri_key,8);

	result = SM2Encrypt_2(plain, klen, pub_key, cipher);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}

	result = SM2Decrypt_2(cipher, klen, pri_key, new_plain);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	else
	{
		for(j=0;j<klen;j++)
		{
			if(new_plain[j] != plain[j])
			{
				printf("SM2 decrypt failed!\n");
				__asm volatile("bkpt 0x12");
			}
		}
	}

	/******************************** ǩǩ ************************************/
	klen = 32;	//ǩݳ
	SM2Signature_2(plain, klen, pri_key, signatureR, signatureS);
	result = SM2Verification_2(plain, klen, pub_key, signatureR, signatureS);
	if(result != SUCCESS_ALG)
   	{
		printf("SM2 verification failed!\n");
        __asm volatile("bkpt 0x12");
   	}
	printf("\nSM2 randomdata test ok!\n");


	/******************************** Կ ************************************/
	sign_2((uint8_t *)ida,8,(uint8_t *)self_pub,za);
	sign_2((uint8_t *)idb,16,(uint8_t *)other_pub,zb);

	//Կ
	result = SM2KeyExchange_2((uint8_t *)self_pri,
			                  (uint8_t *)self_temp_pub,
			                  (uint8_t *)self_temp_pri,
			                  (uint8_t *)other_pub,
			                  (uint8_t *)other_temp_pub,
			                  za,
			                  zb,
			                  exchange_key_buf,
			                  32,
			                  sa,
			                  sb,
			                  1);

	for(i = 0x0;i < sizeof(exchange_cmp_key);i++)
	{
		if(exchange_key_buf[i] != exchange_cmp_key[i])
		{
			__asm volatile("bkpt 0x12");
		}
	}

	printf("\nSM2 eflash test begin\r\n");
  	//ѡȡ
   	for(j = 0 ; j < 1024 ; j++)
   	{
   		plain[j] = (uint8_t)GetRandomWord();
   	}
	result = SM2Encrypt_2(plain, 1024, (uint8_t *)0x8042400, cipher);
	if (result != SUCCESS_ALG)
	{
		__asm volatile("bkpt 0x12");
	}
	printf("\nSM2 eflash SM2Encrypt_2 ok\r\n");
	result = SM2Decrypt_2(cipher, 1024, (uint8_t *)0x8042440, new_plain);
	if (result != SUCCESS_ALG)
	{
		printf("\nSM2 eflash SM2Decrypt_2 fail\r\n");
		__asm volatile("bkpt 0x12");
	}
	else
	{
		printf("\nSM2 eflash SM2Decrypt_2 ok\r\n");
		for(j=0;j<1024;j++)
		{
			if(new_plain[j] != plain[j])
			{
				printf("SM2 decrypt failed!\n");
				__asm volatile("bkpt 0x12");
			}
		}
	}

}

static void RSA_Demo(void)
{
//2048λ
const uint8_t n_addr_2048[256] = {0xB2,0x91,0xB7,0x2E,0xB2,0xFE,0x26,0x63,0x18,0x54,0x27,0x69,0xAC,0xAC,0x8E,0xE7,0x6E,0x03,0xF1,0x5F,0xFC,0xA9,0x10,0x17,0xA5,0xCC,0xAE,0x7D,0x33,0xBE,0x82,0x91,0xF2,0x74,0x79,0xA7,0x12,0x7D,0x9D,0xE5,0xBF,0x8B,0xB8,0x08,0x0F,0xDF,0x48,0x34,0xDD,0x39,0x61,0x3C,0xBB,0x25,0x38,0x7E,0xAB,0xFC,0x3B,0xAE,0x0E,0xF3,0xF9,0xEB,0x02,0x95,0x46,0x36,0x54,0xB5,0x6C,0x35,0xA0,0xE9,0x60,0x95,0xE9,0xFC,0xA2,0x68,0x13,0xA0,0x54,0x81,0x8C,0xC7,0x1E,0x83,0x30,0x14,0x7B,0x94,0xAA,0x2E,0x68,0x93,0x6C,0x7D,0x51,0x03,0xCA,0xB2,0x5C,0xC2,0xFA,0x83,0x37,0x4D,0x00,0xBC,0x7F,0x75,0xC4,0x9E,0x2F,0x2B,0x6A,0xDF,0xFD,0x84,0xD2,0xA6,0x80,0xE6,0x54,0xF4,0x9B,0x03,0x85,0x01,0x82,0xF9,0x0C,0x9C,0xF7,0x43,0xF4,0x14,0xE0,0x46,0xEB,0x8B,0x35,0x73,0x15,0x39,0xBB,0xEF,0x54,0xA1,0x2B,0xAC,0x22,0x30,0x11,0xE0,0xAB,0x82,0x38,0x21,0xF9,0x01,0xA2,0x32,0x00,0x2E,0x7B,0x1E,0x58,0xDE,0xDD,0xDF,0x17,0x87,0xA7,0x20,0xA2,0x13,0xDE,0x64,0x5D,0x2E,0xEA,0x65,0xCA,0xEC,0x66,0x1E,0x15,0xC8,0xC8,0x08,0xC5,0x28,0xBA,0x41,0x95,0x12,0xA6,0x24,0xEF,0x8A,0xB2,0x42,0x4F,0x0A,0x69,0x27,0x7F,0x43,0xA4,0x7D,0x6F,0x8E,0x37,0x1B,0x25,0x34,0x64,0x51,0x27,0x28,0x5A,0x83,0xE9,0x50,0xFF,0x03,0x08,0x93,0x1C,0x9D,0xDF,0x19,0xC5,0x05,0x79,0x0B,0xC4,0x97,0xA6,0xE2,0x7C,0xED,0x7B,0x28,0x5D,0x02,0x97,0x80,0xEB,0x37,0x22,0xCA,0xFB,0xBF};
const uint8_t p_addr_2048[128] = {0xE1,0x4C,0x7C,0x85,0x84,0x15,0x4C,0x29,0x59,0xA1,0x60,0xFE,0xCB,0xFA,0x25,0x74,0x12,0x26,0x27,0xAC,0x93,0x60,0x28,0xC8,0x45,0x7E,0x29,0xED,0xE9,0x4C,0x21,0xFE,0xF6,0x95,0xE0,0x33,0x0B,0x3D,0xFC,0x5C,0x4A,0x71,0x0F,0x52,0x01,0xA7,0xEC,0x92,0x44,0x64,0x37,0x96,0x07,0xFC,0x22,0xF6,0x7B,0x92,0xAA,0x7A,0x31,0x4D,0xA6,0xAF,0xA2,0xC9,0xB5,0x61,0xBE,0x3F,0xE6,0x44,0xC3,0x92,0xAD,0xA6,0x47,0x32,0xED,0x4C,0x8E,0xA7,0xDD,0xF3,0x46,0x58,0x94,0x60,0x04,0xFB,0xBB,0x4C,0xE5,0xE1,0xD7,0x35,0x27,0x92,0x0A,0x82,0x2C,0x2F,0x29,0x29,0xFC,0x37,0x7B,0x46,0x5D,0x1C,0x30,0xBC,0x49,0x80,0xCA,0xA6,0x0C,0xC9,0xF6,0xB5,0x31,0xC4,0x70,0x45,0x7D,0x8B,0xC8,0x35};
const uint8_t q_addr_2048[128] = {0xCA,0xE7,0x13,0x36,0xE4,0x4B,0xF9,0xBF,0x79,0xD2,0x75,0x2E,0x23,0x48,0x18,0xA5,0x24,0x31,0x1D,0x9A,0xBC,0x40,0x77,0x12,0x3C,0x2C,0x9A,0x16,0x7A,0xFB,0xE7,0x54,0x1C,0xC0,0x8A,0xB0,0xE9,0x9F,0xD0,0x8D,0xFD,0x89,0xE0,0xF1,0xBC,0xFE,0x0B,0x01,0x3F,0x62,0x88,0xE5,0x54,0x9B,0x47,0x6E,0xB3,0x79,0x7E,0x90,0x81,0xFA,0xDE,0xAD,0xF9,0x17,0xCB,0xF7,0x40,0x2A,0xB5,0x32,0x37,0x97,0xD8,0x70,0xD4,0x32,0x57,0x7A,0x28,0x2E,0x43,0xD2,0xAA,0x6D,0x0F,0x1B,0x32,0xE6,0x81,0xEE,0x26,0xF9,0xB5,0x53,0xF2,0x28,0xC5,0xC6,0x1C,0x2A,0x9C,0xB9,0x1F,0x8D,0x40,0x20,0xB9,0x4D,0x16,0xF2,0xED,0x25,0x44,0xC1,0x19,0xBE,0xE1,0x77,0x6D,0x66,0xCC,0xB4,0xC8,0x84,0xBA,0xA3};
const uint8_t dp_addr_2048[128] = {0x5C,0x88,0x92,0x98,0x2F,0xE0,0xA3,0x70,0x54,0x4C,0xD0,0xCE,0xB5,0xAE,0x5E,0xD5,0xA6,0x62,0x9F,0x66,0xE4,0xFC,0xD8,0xA3,0x30,0xCF,0x99,0x9F,0x0A,0x73,0xE7,0x7E,0x95,0x7E,0x87,0x1F,0xCF,0xDD,0x3C,0x9A,0x17,0x45,0x0A,0x5A,0xCF,0x2D,0x4E,0x1F,0xE1,0x11,0x1C,0x37,0x75,0xBE,0x1C,0x0A,0x0A,0x44,0xF9,0xD9,0xC8,0x08,0x31,0x8E,0xEF,0x98,0x52,0xF3,0xFB,0x34,0xB9,0x79,0xC2,0xAD,0xAA,0xBE,0xA1,0x7D,0x8C,0x33,0x26,0x60,0x51,0xEB,0x8A,0x17,0xF5,0x90,0xDE,0x5B,0x19,0xD9,0x82,0x8D,0x58,0x5B,0x8F,0x8E,0x0E,0xDC,0xDA,0x12,0xE0,0xA0,0x4A,0xE3,0xEA,0xB0,0xC2,0xAB,0x42,0x65,0x02,0xF7,0x6F,0xC3,0xF5,0x7A,0xB9,0xE6,0x3F,0xB3,0x83,0xBD,0x36,0xCC,0x43,0x85};
const uint8_t dq_addr_2048[128] = {0x84,0xEE,0xD9,0x96,0xD8,0x01,0xB2,0xD1,0xB1,0x05,0xA2,0x82,0x24,0xD9,0x62,0x54,0x27,0x9F,0x0A,0x2F,0x4B,0x70,0xCC,0xD2,0x24,0x9C,0x70,0x23,0x94,0x55,0x9F,0x9C,0x6A,0xED,0xF6,0xAF,0xAB,0x90,0x69,0xF9,0xED,0x07,0x3D,0x5A,0x03,0xA1,0x49,0x22,0x7B,0x1D,0x9A,0x64,0xED,0x86,0x82,0x49,0x53,0xCA,0xA0,0x92,0x1A,0xA6,0x7A,0xE7,0xEE,0x4F,0x99,0xF1,0x16,0x98,0x24,0x78,0x8F,0x15,0xAB,0xD7,0x58,0x1E,0xD7,0x53,0x10,0x2A,0x27,0x83,0x48,0xE7,0x04,0xC3,0xA4,0x18,0x83,0x3D,0xBD,0x49,0x52,0x74,0x7A,0x2E,0x1E,0x4D,0x0A,0x3D,0x1C,0xCA,0xE8,0x92,0x09,0x56,0xA7,0x30,0x8B,0x7D,0x82,0xC3,0x2D,0x05,0x7A,0x51,0xA5,0xB4,0x31,0xF7,0xEC,0xDB,0xF0,0x97,0x8D,0x13};
const uint8_t qinv_addr_2048[128] = {0xCB,0x6F,0xFB,0x0C,0x27,0xA3,0x70,0x41,0x5D,0x73,0xC4,0x30,0x43,0xC8,0x67,0x91,0x20,0xF8,0x6B,0xF4,0x3B,0x9D,0x4F,0x78,0xBC,0x38,0xEB,0xAE,0x9F,0x3F,0xF2,0x3E,0xE9,0xD9,0x6A,0x84,0x02,0xC3,0xC2,0xE6,0xFD,0xFC,0x3A,0xC5,0x13,0xF7,0xF4,0xD3,0x8E,0xDD,0x88,0x13,0x55,0x91,0x24,0xD7,0x3E,0xA0,0xAA,0x50,0x61,0x59,0xB0,0x5C,0x18,0x55,0x46,0x3F,0x28,0x59,0x33,0xA9,0x77,0x9F,0x25,0xBC,0x84,0xF5,0xBB,0x81,0xC5,0xF6,0x82,0xA9,0xAA,0x0B,0xD7,0x3A,0xDB,0x12,0xCE,0x2F,0x69,0xF0,0x6C,0x94,0x9F,0x6D,0x01,0xA6,0x39,0xD9,0x47,0xED,0xED,0x7D,0xE1,0xA6,0x0C,0xCA,0xA3,0x69,0x00,0x7D,0x8A,0x23,0x72,0xEC,0x66,0xBF,0xEC,0x10,0xBE,0x0B,0x2F,0xB5,0xA8,0x9F};
const uint8_t d_addr_2048[256] = {0x1A,0x9C,0x08,0x36,0x17,0x4A,0x34,0x22,0x34,0x2F,0xE6,0x27,0xA3,0x29,0x9B,0xA9,0xF5,0x04,0xF5,0x65,0x1E,0x5B,0x7B,0x20,0x6A,0xFE,0x93,0x49,0xE8,0xFA,0x0C,0xAE,0xFE,0xF8,0x48,0x60,0x93,0x2A,0xD0,0xEA,0xB9,0x9E,0x72,0x70,0x11,0x1D,0x6E,0xBF,0x21,0xF0,0x39,0x03,0x39,0xC8,0x14,0x21,0x1C,0x33,0xDC,0x18,0xD5,0xF5,0x99,0x5A,0x61,0xEA,0x28,0xAA,0x53,0xF9,0x2D,0x04,0xD8,0xD3,0xAE,0x26,0xE8,0xD5,0x52,0xC6,0x3B,0x96,0x7A,0xC1,0x4B,0x5F,0x28,0xB6,0xD7,0xE5,0x55,0x7D,0x13,0xD7,0x12,0x92,0x55,0x6A,0x5F,0x36,0x37,0x70,0x58,0xCE,0x5D,0x52,0x4C,0x5D,0x57,0x2C,0xBF,0xB9,0xA6,0xF1,0x03,0x8A,0x6E,0xC4,0xAE,0x1C,0xAA,0xDF,0x50,0xFA,0x01,0xD2,0xE9,0x7E,0x5E,0xF6,0x61,0xB6,0xB9,0xAA,0x83,0x85,0x56,0xD9,0x68,0x8D,0xF2,0xC0,0x54,0xCB,0xB9,0xA0,0xF9,0x99,0x94,0x15,0x3E,0xC0,0xA0,0x30,0xFD,0x27,0x44,0x1D,0xF1,0x77,0xB7,0x55,0xCA,0x4A,0x00,0xF9,0xA6,0xDB,0xEF,0x60,0x67,0xB9,0xEC,0x86,0xC5,0x08,0x3C,0x69,0xB5,0x79,0x51,0x33,0x42,0x49,0xD4,0xF0,0x97,0x69,0x5A,0x16,0x4E,0xD8,0xFE,0xAF,0xB4,0x55,0x44,0x8E,0x09,0xF9,0x5E,0x1F,0x2E,0xB5,0xC9,0x5E,0x64,0x8B,0x5F,0x92,0xA2,0x16,0x01,0xF8,0x95,0xB7,0x11,0x40,0x5A,0xBE,0xBA,0x70,0x93,0x89,0x3A,0x81,0xE0,0xB8,0xC7,0x88,0x43,0xDA,0x54,0xDD,0x49,0x2F,0xA6,0xF7,0x1B,0xB1,0xEF,0x77,0xB1,0xC2,0x80,0xBD,0xBC,0xA7,0xBD,0xF7,0xD6,0x9D,0x0F,0x2F,0x62,0x71};
const uint8_t plain_2048[256] = {0x11,0x11,0x11,0x11,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x22,0x22,0x22,0x22};
const uint8_t ciper_2048[256] = {0x49,0x1F,0x78,0x86,0xD5,0x40,0x4E,0x8E,0xE6,0x49,0x23,0xC4,0xC5,0x34,0x14,0xCE,0x6E,0x5F,0x04,0xAE,0x5F,0x96,0x09,0x39,0x69,0xEF,0x98,0x42,0x43,0x39,0x7B,0xC0,0x2E,0x80,0x8C,0x7F,0x47,0x40,0xE8,0x1B,0x62,0x70,0x56,0xD4,0x8A,0x4E,0x38,0xDD,0xC6,0x3D,0x57,0x06,0x6C,0xB7,0xA1,0xC6,0x4B,0xB4,0xBE,0x3A,0xDF,0x90,0xA9,0x16,0xFA,0x2F,0x1E,0x3D,0x8E,0x68,0xBD,0xDB,0x77,0xF2,0x0A,0xB7,0x42,0x43,0x8F,0xAF,0x4A,0x43,0x09,0x3C,0xA3,0xD7,0x17,0x4D,0x44,0x55,0x7E,0xBE,0x36,0x39,0x83,0x4B,0x7C,0x34,0xB5,0xC4,0x67,0x0F,0x91,0x33,0x12,0xA4,0x3F,0x09,0x73,0x60,0x71,0x61,0xC5,0x0C,0x83,0xBC,0xFE,0x5A,0x92,0x24,0x00,0x73,0xC6,0x1C,0xC0,0xE7,0xAC,0x94,0xF1,0x25,0x93,0x2B,0x6A,0x11,0xC0,0x42,0x65,0x11,0xB0,0xF3,0x29,0x10,0xFF,0x37,0xD8,0x8A,0x53,0x09,0xB7,0x92,0x6E,0xB5,0x43,0x8B,0xC5,0xFD,0x12,0xE9,0xFD,0x47,0x43,0x8D,0x22,0x02,0xAB,0x68,0x8D,0x6A,0xD2,0x71,0xB8,0x90,0x3D,0x75,0xD1,0xD9,0x9C,0xFB,0x29,0xF2,0x5A,0xBB,0x06,0x2D,0x5D,0x2B,0xAE,0xC6,0xF0,0x58,0x2F,0xAB,0xD9,0xA0,0xB3,0xC6,0xAF,0xF0,0x07,0x1A,0xD5,0xFE,0xE2,0x56,0x72,0x62,0x8D,0xC7,0xAE,0xD7,0x64,0xBE,0xFA,0xCF,0xC1,0x39,0x8A,0xC7,0x18,0xA4,0x19,0x94,0x7C,0xB2,0x65,0xE3,0xC2,0x24,0xC8,0x13,0x6C,0x11,0x36,0xFE,0x26,0xFD,0x67,0x11,0xC4,0x0C,0x8F,0x7E,0x21,0xF6,0xD6,0x33,0xC5,0xD6,0x10,0x0C,0x5A,0x0C,0x3B,0x4F,0x9C,0x59};

//1984λ
const uint8_t n_addr_1984[248] = {0xCA,0x52,0xC0,0x28,0x94,0xA1,0x84,0x48,0x87,0x67,0xC0,0xA4,0x88,0x77,0xED,0xA6,0x90,0x6C,0x13,0xD7,0x53,0x87,0x57,0x35,0x4E,0xC8,0x8C,0x7D,0xDD,0x2D,0x93,0x09,0x5B,0x22,0xDD,0x72,0x85,0x52,0x1E,0x73,0x94,0xE5,0xCF,0xE2,0xB8,0x13,0x96,0x01,0x26,0x4D,0xE3,0x04,0x1F,0x6A,0x25,0x4C,0xE8,0x6A,0x6B,0xE3,0xCD,0xD7,0x25,0xFB,0x5D,0x12,0x2B,0xEF,0x57,0x51,0x8B,0x35,0x8F,0x14,0x00,0xC8,0x1D,0xBB,0xD7,0xBC,0x78,0x98,0xF1,0x56,0x4E,0x66,0xB3,0x22,0x59,0xBF,0xBA,0x60,0x7B,0xE1,0x00,0x7E,0x51,0x94,0x55,0x5C,0x8E,0x39,0x92,0xBD,0x50,0x6D,0x83,0xBB,0x6F,0xB1,0xD4,0x62,0x63,0x9E,0x3E,0x8B,0xC2,0xB5,0x0F,0xBE,0xD3,0x59,0xA7,0x32,0x64,0x52,0x8A,0x33,0xA0,0x61,0xA6,0xE7,0x93,0x63,0xBF,0x16,0x16,0x13,0x78,0x31,0xA2,0xAF,0x96,0xA4,0x7C,0x62,0x64,0x49,0x20,0x71,0x0D,0xF2,0xF8,0xBF,0x46,0xCD,0x22,0xF8,0x27,0xA6,0xDF,0x65,0x1D,0x07,0xBE,0x25,0x92,0x01,0x50,0xED,0xCA,0x1F,0x25,0x72,0xAC,0xB5,0xEE,0x99,0x50,0x17,0xC5,0xDC,0x92,0x28,0xEF,0xBE,0x2F,0xD6,0x73,0xE2,0x67,0xEA,0x3E,0xC5,0xA5,0x46,0x77,0xC3,0xA6,0x01,0x72,0xA1,0x89,0xBC,0x6F,0xAF,0x9D,0xCB,0x7E,0x93,0x08,0xAC,0x97,0xA7,0x46,0xAD,0xB7,0xEC,0x40,0x0E,0x40,0x28,0xFC,0x48,0xB6,0xFD,0x4C,0x35,0x9E,0x5F,0x81,0xEB,0x16,0x8A,0xB3,0x30,0x66,0x91,0x2D,0x88,0xD8,0xFE,0x87,0xC6,0x36,0x9E,0x29,0x3F};
const uint8_t p_addr_1984[124] = {0xFE,0xEC,0xEA,0x4E,0x95,0x76,0xE2,0x0D,0x97,0x9E,0xE7,0x9F,0xA0,0x75,0xE6,0xFF,0x95,0x3F,0x57,0x01,0x5A,0x8B,0x69,0x75,0x38,0xF1,0x19,0x43,0x05,0x09,0xBD,0x2D,0xA6,0xEB,0x1F,0x72,0xFE,0xF4,0x46,0x5E,0x6B,0xF2,0x89,0x99,0x06,0xBE,0xB0,0xCD,0xD2,0x0F,0x12,0x1B,0x3F,0x84,0x65,0xE3,0x71,0x17,0x2E,0x07,0x57,0x14,0xBA,0x68,0x54,0xA5,0x1D,0x99,0xA0,0xF7,0xA6,0x0B,0xF5,0xD6,0x69,0xE9,0xEB,0xE5,0xB0,0x2D,0xA4,0xC4,0xB3,0x26,0xF7,0x66,0x21,0xCB,0xA4,0x3A,0xA7,0xC0,0x69,0x2C,0xA2,0xF4,0xB7,0x95,0xD6,0x14,0xD9,0xD0,0x63,0x1D,0x82,0x21,0xD1,0x15,0x7C,0xEA,0x18,0x3A,0x3B,0xCC,0x93,0x9C,0x40,0xF3,0x67,0x93,0xC2,0x74,0xF1,0xD9};
const uint8_t q_addr_1984[124] = {0xCB,0x2D,0x12,0xCB,0x46,0x40,0x23,0x28,0xD9,0xF7,0xE0,0x19,0x1E,0xFF,0x7C,0x46,0x7B,0x8A,0xF4,0x52,0xF3,0x8C,0x15,0x52,0x82,0xDA,0xD8,0xE3,0x51,0xC0,0xA9,0xB4,0x18,0xC1,0xC7,0xC7,0xEF,0xB8,0x55,0x65,0xA1,0xF8,0xB5,0x38,0x53,0x34,0x79,0xEC,0x10,0x48,0xFC,0x70,0x21,0x58,0xBB,0x29,0x4F,0x50,0x08,0xBC,0x99,0x43,0x27,0xB9,0xFC,0xBA,0xB3,0xA9,0x31,0x55,0x49,0x43,0x15,0x77,0xAD,0xE3,0x84,0x71,0xD8,0xD6,0x80,0x85,0xFD,0x31,0x83,0x79,0xF0,0x2E,0xB6,0xD2,0xFD,0x93,0x15,0x08,0x70,0xA9,0x2E,0x12,0xC2,0xB1,0x27,0xF9,0xBA,0xDB,0x04,0xB2,0x23,0xB8,0xF0,0x2D,0x16,0x10,0x44,0x68,0x7B,0x03,0xA3,0x00,0xD3,0x0E,0x38,0x2B,0xEC,0xD7};
const uint8_t dp_addr_1984[124] = {0x88,0x95,0x14,0xC0,0x7F,0xD2,0x0F,0x31,0x6B,0x1F,0xE7,0x47,0x9E,0x28,0x2D,0x58,0x98,0x75,0x34,0x3F,0x74,0x6C,0xA7,0x56,0xF7,0xE8,0x2D,0x39,0xBC,0x34,0x48,0x98,0x72,0x0B,0x1D,0x71,0x76,0x6A,0x18,0x5D,0xB4,0x86,0x60,0xF4,0x8D,0x29,0x93,0xFE,0xE2,0x61,0xD2,0xB8,0xA8,0xA2,0x5E,0x18,0xAA,0xD9,0xD9,0x7E,0x73,0x48,0x96,0xCB,0x19,0x36,0xD2,0x12,0x22,0xAD,0x2C,0xD8,0xD1,0xA1,0x4C,0x63,0xD9,0x50,0xD9,0xC0,0xCA,0xBB,0xDC,0xA4,0xAE,0xFE,0x98,0x72,0xCC,0x0D,0xE5,0x1C,0xF0,0xFC,0xCA,0x5E,0x45,0x12,0x51,0x7E,0x20,0x69,0x47,0x01,0x63,0x5C,0x8C,0xF2,0x6F,0x57,0xD9,0x1D,0x32,0x36,0xDC,0x8B,0x66,0x3D,0x43,0x2C,0x66,0x8E,0x53,0x99};
const uint8_t dq_addr_1984[124] = {0x44,0x80,0x5D,0xE5,0xCB,0x39,0xB4,0xA1,0x01,0x5C,0x61,0x62,0x16,0xE1,0x6C,0xB5,0x16,0xD2,0x32,0xAE,0x05,0x0F,0x25,0xE1,0x3B,0xDD,0x2D,0x62,0xF7,0x1D,0x4E,0x1A,0x3A,0x7E,0x9B,0x2C,0xFD,0xD5,0xD8,0x74,0xFB,0xB7,0x2E,0xE2,0x5E,0xAB,0x42,0xB0,0x24,0x8D,0x77,0x0F,0x17,0x2F,0x23,0x6B,0x3A,0x22,0x71,0xCF,0xA4,0x9C,0xCF,0xB8,0x15,0x4D,0x9D,0x65,0x5E,0x0C,0xB3,0x36,0xBA,0xF6,0x2E,0xDA,0x96,0xBD,0x0B,0xAE,0xC6,0x86,0x66,0x67,0x5B,0x3C,0xB1,0x8E,0x0E,0x75,0xF4,0xA8,0xB2,0x5E,0xB6,0x1D,0x54,0x3B,0x5F,0x08,0xFB,0xC1,0x67,0x0E,0x90,0xF6,0xBE,0xB4,0x8B,0xC5,0xA7,0xBA,0xB4,0x55,0xC5,0xA3,0xE4,0x41,0x52,0xE7,0x68,0x68,0xE6,0xE1};
const uint8_t qinv_addr_1984[124] = {0x74,0x1D,0x0D,0x2E,0x26,0xD5,0x22,0xA4,0x17,0xD8,0xBC,0x21,0x48,0x96,0xCF,0x6B,0xB2,0x77,0x2B,0x28,0x17,0x64,0x93,0xE5,0x6E,0xB2,0x20,0xAD,0x46,0xC8,0x99,0x11,0xFB,0x8C,0xD8,0x71,0x78,0xD8,0x21,0x9A,0x57,0xFF,0x77,0x97,0x61,0x16,0xFA,0x00,0xE0,0x58,0x2C,0x73,0xFF,0x02,0x04,0x59,0x96,0x6C,0x0E,0xCF,0x11,0x7F,0x29,0x63,0xAB,0x69,0x36,0xF9,0xD7,0x74,0x9D,0x71,0x8B,0xDA,0xD7,0xE1,0x92,0x93,0xB7,0x40,0x21,0x9D,0x35,0xCE,0x7D,0xA7,0x31,0x1E,0xB2,0xAA,0xC3,0x96,0x1C,0x40,0x9A,0xCA,0x99,0xBF,0xCE,0x30,0x78,0x54,0x65,0x27,0x08,0xE8,0x30,0x05,0x7A,0x3A,0xEC,0x3F,0x68,0x96,0xCC,0xF1,0x5E,0x43,0x29,0xC9,0x59,0xEC,0xFF,0x3D};
const uint8_t d_addr_1984[248] = {0x6E,0x32,0x3A,0x05,0x20,0x47,0x04,0x94,0xB8,0x63,0x53,0x32,0x8A,0x3D,0xBF,0xCB,0xBB,0xD7,0x91,0xCA,0xF2,0xEC,0xC1,0x1C,0x00,0xC8,0x0C,0x75,0x35,0x35,0x70,0x63,0x65,0x27,0x0D,0x34,0x25,0xD7,0x3F,0x4C,0xB6,0xA9,0xA0,0xDB,0x9C,0x64,0xD6,0x8B,0xD3,0xC0,0x12,0x48,0x99,0x8F,0xA7,0xB7,0x46,0xD3,0x47,0xE6,0x30,0xA3,0xE1,0x45,0x12,0x41,0x26,0x7A,0xDA,0xB5,0x48,0x3C,0x28,0xAC,0xBD,0x6C,0x41,0x7D,0xA1,0x18,0x3F,0x1B,0x16,0x3F,0x6A,0xBE,0x57,0x0C,0xFB,0x93,0x08,0xC1,0x2A,0x57,0xB7,0x7C,0x15,0x94,0xD4,0x15,0x70,0x45,0x7D,0x5D,0xED,0x63,0x68,0x9F,0x7B,0x4B,0x81,0x21,0x01,0x9F,0x1B,0xF3,0xE5,0x5D,0xD6,0xB0,0x99,0xCE,0xB7,0xD8,0x29,0xF7,0x69,0x2A,0xC2,0xCA,0x28,0xFD,0x20,0x2A,0xD2,0x04,0x1D,0x7C,0x46,0x6A,0xB3,0xF1,0x0E,0x5F,0x22,0x87,0x9A,0x8F,0x2A,0x31,0x1F,0x7E,0x0A,0x2C,0x24,0x95,0xC1,0x64,0x28,0x37,0x62,0x4A,0x2B,0xE5,0xA1,0x23,0x73,0x51,0xA9,0x94,0x81,0xA2,0x96,0xB4,0xF5,0xB6,0xB9,0xB1,0xE8,0x71,0x79,0x4C,0x9D,0x35,0xDA,0x41,0x6F,0x4B,0x10,0x8C,0xCD,0xDF,0x6C,0x9E,0x26,0x86,0x17,0xA5,0xC3,0x89,0x22,0x42,0x0A,0x38,0x56,0x14,0xB8,0x9B,0xAF,0x45,0x17,0x46,0xA6,0xE9,0x0A,0x4F,0xE9,0x25,0x92,0x67,0xB3,0x73,0x40,0x3F,0xDD,0xCF,0x7D,0x7C,0xBA,0xC9,0x40,0x57,0x7F,0x17,0xB3,0x27,0xC0,0x9B,0x26,0x1E,0xBD,0xF0,0x19,0x6A,0x05,0xDE,0x84,0x71};
const uint8_t plain_1984[248] = {0x11,0x11,0x11,0x11,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x22,0x22,0x22,0x22};
const uint8_t ciper_1984[248] = {0xAB,0xB9,0x61,0x08,0xDB,0xB7,0x49,0x53,0x1D,0xA5,0x4A,0x14,0xCE,0x25,0xD4,0x30,0xA3,0x12,0x48,0xC8,0xC6,0x83,0x3D,0x5B,0x46,0x00,0xED,0x9B,0x8F,0xA9,0x93,0x49,0xB5,0x1E,0x9F,0x08,0xF8,0x34,0x69,0xF3,0x5D,0xFD,0x23,0x10,0x97,0x39,0xBD,0x76,0x8A,0x33,0xCE,0x1B,0xDD,0x44,0x2E,0xD9,0x9A,0xA7,0x92,0xD6,0x54,0x6A,0xA3,0x5F,0x2F,0x53,0x19,0x27,0x97,0x41,0x33,0xD3,0xA5,0x29,0x06,0xAB,0x3F,0x0A,0x65,0x27,0xD2,0x17,0x20,0x8D,0x8C,0x08,0x47,0x68,0x44,0x6F,0xD5,0xBC,0xEC,0x4B,0xF7,0x73,0xAD,0x42,0xE9,0x18,0xA1,0x84,0xAB,0xBB,0x17,0x7F,0x92,0x38,0xE6,0xF2,0xBE,0xFD,0x67,0x58,0x54,0x0F,0x35,0xE4,0xC0,0x63,0x78,0x08,0xD6,0xF8,0x21,0x04,0xE0,0xA7,0x76,0xD6,0xE3,0x48,0x2C,0xF5,0x15,0x95,0x15,0x4A,0x4D,0xE2,0x8E,0xA2,0xED,0x0A,0x97,0xF7,0xB3,0x86,0x2E,0xDF,0x2D,0x10,0x4E,0x87,0x43,0x99,0x7A,0x00,0xEA,0x36,0x87,0x03,0x41,0x94,0x5E,0xF3,0x1F,0x82,0x82,0x3D,0x95,0x32,0x63,0x5A,0x45,0x35,0x59,0xE7,0xFE,0xB9,0xB5,0x30,0xDA,0xFA,0x56,0xB6,0x6C,0x04,0xAB,0xB8,0xE9,0x5D,0xD6,0xD3,0x29,0xDB,0x0D,0x1A,0x59,0x6B,0x20,0xCD,0x90,0xAB,0x26,0x82,0xDA,0xC5,0xA3,0x73,0x19,0x2E,0x89,0x28,0x50,0x9D,0x6B,0x0B,0xCD,0x6F,0xE4,0x80,0xD9,0x12,0x74,0xA3,0x94,0xA2,0xBA,0xE4,0xDD,0xA8,0xD8,0x70,0xAB,0x45,0xB0,0x95,0x8C,0x2B,0x0F,0x55,0xBC,0xEC,0xAD,0xBF,0x58,0xF7};

//1024λ
const uint8_t n_addr_1024[128] = {0x9C,0x4D,0x34,0x66,0x88,0x84,0xE8,0xD5,0xC7,0xB6,0x09,0x17,0x9D,0x30,0x64,0x44,0x9D,0xDB,0xCB,0xA8,0x1F,0x1A,0xC2,0x02,0x0A,0xE8,0x55,0x19,0x3E,0x20,0x2F,0x66,0xE0,0x9E,0x5C,0xB7,0x09,0xCA,0x9D,0x04,0xFF,0x1A,0x18,0xF9,0x4D,0xF0,0xD9,0xAE,0xFD,0xC7,0x76,0x82,0xD2,0xFA,0x0E,0x04,0x6B,0x95,0xD8,0x67,0x4D,0x21,0xB6,0x84,0x33,0x0F,0xDA,0x34,0x98,0x91,0x16,0xF1,0xCA,0x16,0x8B,0xD9,0xA8,0x74,0x62,0x6B,0xC7,0x36,0x41,0x8B,0x09,0xA6,0xC1,0x60,0xD0,0x42,0x4E,0x49,0x13,0x70,0x66,0xCD,0xD1,0x8A,0xC1,0x33,0x32,0x42,0xB6,0x81,0x78,0xDC,0x2C,0xC9,0x78,0xAF,0x29,0xEA,0xC8,0x60,0x3C,0x38,0xA1,0x76,0x63,0xDC,0x6E,0xA0,0x39,0x78,0xD6,0x8E,0x26,0x1D};
const uint8_t p_addr_1024[64] = {0xDD,0xB2,0x5C,0x99,0xC0,0xA5,0x99,0xCA,0xE5,0xAE,0x16,0x7E,0x89,0x05,0x17,0xC5,0x63,0x51,0x21,0x4C,0x7C,0xE4,0xC8,0xA7,0x11,0x39,0xAA,0x9F,0x99,0xD3,0xFB,0xC5,0x24,0x89,0x33,0xEF,0x85,0x9D,0x61,0x52,0xEB,0x6D,0x38,0x0C,0xCC,0x69,0xB1,0x53,0xD2,0xA6,0x2E,0x99,0x01,0x8C,0x7C,0x0B,0x07,0x6F,0x29,0x5D,0xEE,0xDC,0xA8,0x2D};
const uint8_t q_addr_1024[64] = {0xB4,0x7C,0x79,0x20,0xA4,0x94,0x8D,0xC5,0x75,0xC4,0xB0,0x0E,0x90,0xCE,0xDA,0x8E,0x6A,0x8E,0x55,0xE0,0xD3,0x48,0x9C,0x5A,0xC6,0x82,0x9B,0x19,0x5A,0x65,0x57,0xD1,0xBB,0xAF,0xB1,0x31,0xC9,0x1A,0xD4,0xA0,0xD9,0xE3,0x40,0x2E,0x3A,0x8A,0x3E,0x68,0xDE,0xAF,0x75,0x81,0xE9,0x61,0x54,0x85,0xD4,0xF4,0x81,0xE1,0x9F,0xD9,0xBB,0xB1};
const uint8_t dp_addr_1024[64] = {0x80,0x27,0x26,0x98,0x4A,0x60,0x6F,0xF2,0x75,0xAA,0x98,0x9E,0x34,0x9E,0x99,0x0B,0x25,0x4A,0x34,0xB1,0x7E,0x50,0xD2,0x1C,0xA1,0x3C,0x70,0x81,0x29,0xEE,0xFC,0x4F,0x0D,0xBB,0xB2,0x25,0xF7,0x5A,0xEE,0x73,0x7C,0x5B,0xFA,0x56,0x8B,0xA3,0x5D,0x3A,0x53,0x3E,0x75,0x19,0x45,0x67,0xEC,0x1C,0x84,0x03,0xA2,0x2A,0x06,0x75,0xCF,0x51};
const uint8_t dq_addr_1024[64] = {0x72,0x94,0xCB,0x39,0x44,0x02,0xE3,0x76,0x46,0x6B,0xD5,0xF1,0x89,0x51,0x29,0x43,0x5C,0xB6,0x7C,0x22,0xBD,0x3F,0xCD,0xB3,0x7B,0x6F,0x13,0x14,0x27,0x65,0x4B,0x39,0x65,0x54,0x06,0xC4,0x3A,0x8E,0x04,0x0B,0x12,0x08,0xC9,0x88,0x0F,0xB6,0x10,0x24,0xF7,0xAA,0xA0,0x89,0x17,0x26,0xA9,0x48,0x45,0x87,0xEC,0xA4,0xD6,0x9C,0x9E,0x21};
const uint8_t qinv_addr_1024[64] = {0x64,0xD4,0xF0,0xA6,0xB2,0xF8,0x6A,0x88,0x93,0x11,0x6D,0x66,0x0C,0xCD,0xF6,0x79,0x01,0x26,0x25,0x3D,0xC4,0x52,0xCD,0x0D,0x92,0xBF,0x8C,0x80,0xC1,0x72,0xE2,0x40,0x7A,0x9F,0x82,0x7B,0x41,0xF5,0x56,0xE1,0xF7,0x8D,0x1B,0xDA,0xAC,0xB2,0x5A,0x82,0x31,0x05,0x5A,0x8E,0xA0,0xAA,0x26,0x5F,0xDB,0x41,0x2A,0x26,0xC2,0x47,0xDF,0x31};
const uint8_t d_addr_1024[128] = {0x44,0x68,0x39,0xD5,0xE2,0x4C,0x21,0x47,0x67,0x47,0xD1,0x84,0xE7,0x44,0x05,0xAE,0x4E,0x54,0xA3,0x36,0xAA,0x9E,0x60,0x68,0xDA,0x73,0x42,0xC3,0x70,0x80,0x4F,0x9E,0xBC,0x12,0x33,0x4B,0xDC,0xDA,0x33,0x8C,0xBB,0x45,0xA5,0xC6,0x7F,0x09,0x39,0x8C,0xAF,0xFF,0x7B,0x6B,0xD8,0x80,0x9E,0x5F,0xEA,0xE2,0x43,0x3B,0x3A,0xF3,0xD5,0x58,0x28,0xA7,0x32,0xF9,0x74,0xBC,0xC8,0xBA,0x20,0xDD,0x46,0x7D,0xB2,0x32,0x9F,0xBC,0xAE,0x61,0x00,0xE2,0xB2,0x49,0x5E,0x57,0x26,0x78,0x2B,0x09,0x40,0xD0,0x2E,0xF5,0xAD,0xFA,0x80,0xD1,0xC7,0x7F,0x97,0xB1,0xEC,0xF1,0xE9,0x0D,0x2A,0xD3,0xA1,0xAC,0x08,0x63,0x97,0x9D,0xF1,0x84,0xA6,0xCA,0xBD,0x6F,0x09,0x64,0x22,0x80,0x58,0xC1};
const uint8_t plain_1024[128] = {0x44,0x68,0x39,0xD5,0xE2,0x4C,0x21,0x47,0x67,0x47,0xD1,0x84,0xE7,0x44,0x05,0xAE,0x4E,0x54,0xA3,0x36,0xAA,0x9E,0x60,0x68,0xDA,0x73,0x42,0xC3,0x70,0x80,0x4F,0x9E,0xBC,0x12,0x33,0x4B,0xDC,0xDA,0x33,0x8C,0xBB,0x45,0xA5,0xC6,0x7F,0x09,0x39,0x8C,0xAF,0xFF,0x7B,0x6B,0xD8,0x80,0x9E,0x5F,0xEA,0xE2,0x43,0x3B,0x3A,0xF3,0xD5,0x58,0x28,0xA7,0x32,0xF9,0x74,0xBC,0xC8,0xBA,0x20,0xDD,0x46,0x7D,0xB2,0x32,0x9F,0xBC,0xAE,0x61,0x00,0xE2,0xB2,0x49,0x5E,0x57,0x26,0x78,0x2B,0x09,0x40,0xD0,0x2E,0xF5,0xAD,0xFA,0x80,0xD1,0xC7,0x7F,0x97,0xB1,0xEC,0xF1,0xE9,0x0D,0x2A,0xD3,0xA1,0xAC,0x08,0x63,0x97,0x9D,0xF1,0x84,0xA6,0xCA,0xBD,0x6F,0x09,0x64,0x22,0x80,0x58,0xC1};
const uint8_t ciper_1024[128] = {0x1E,0xEF,0xCA,0xF1,0x12,0x2A,0x33,0x93,0x7D,0x90,0xEB,0x0E,0x63,0x14,0x12,0x72,0x90,0x05,0xD2,0x76,0x72,0x7E,0x0C,0x61,0x63,0xE8,0xC9,0xC1,0x54,0x80,0x38,0x61,0x51,0xC2,0x02,0x9D,0x3B,0xF8,0x0C,0x45,0x9E,0x1D,0xAF,0x50,0x2A,0x8E,0x40,0x67,0xB0,0x0B,0x4A,0x1A,0xE1,0x7D,0xEA,0x24,0x14,0x82,0x84,0x8C,0xEC,0x04,0x3B,0xCF,0x4C,0xFF,0xA3,0x90,0xED,0xEF,0xAF,0xF1,0x19,0x72,0x0C,0x90,0x52,0xB1,0xF3,0xD4,0x6B,0x32,0xD8,0x4D,0xE1,0x30,0x17,0x74,0xD0,0x98,0x7E,0xEF,0x83,0xAA,0x76,0x99,0xCE,0xE3,0xD8,0xC7,0xB6,0xAD,0x1E,0x73,0x5B,0x62,0x7F,0x92,0x02,0x47,0x3A,0x1F,0xE3,0xD9,0x2F,0xBF,0xB4,0xC4,0x94,0xCB,0xED,0x2C,0x76,0x55,0x1E,0xCA,0xE3,0xA6};

//#define RSA_DATA_376

#ifdef RSA_DATA_376
//736λ
const uint8_t n_addr_736[92] = {0xBA,0xE3,0xE0,0x09,0xC3,0x1B,0xDB,0xBD,0xA8,0x07,0x94,0x80,0xA8,0x23,0x38,0xD2,0x28,0x5A,0x90,0x80,0x62,0x0A,0xB2,0xD0,0xD5,0xE2,0x53,0xDE,0xFC,0x42,0x7B,0x4C,0x92,0x27,0xD2,0x30,0x85,0x97,0x1B,0x2C,0xDE,0x66,0xD2,0xFB,0x0E,0xCA,0xB1,0xF0,0xD7,0xDA,0x18,0x23,0x5D,0x74,0x78,0xAA,0x13,0x59,0x81,0xD3,0xDC,0xB0,0x22,0xFA,0x2E,0x4E,0xD6,0x4D,0xBB,0x21,0xDF,0xCA,0x94,0x41,0xED,0xC7,0xE9,0xE7,0x19,0x2B,0xF1,0x9E,0x71,0x16,0xC5,0x25,0xEF,0x3C,0xEF,0x68,0x36,0x5B};
const uint8_t d_addr_736[92] = {0x34,0xA0,0xAC,0xDB,0x32,0xE5,0x2A,0x68,0xEA,0xE3,0x4F,0x8F,0x37,0x49,0xCB,0xDB,0x6A,0x5F,0xAE,0x67,0x68,0xB4,0x68,0x8C,0x64,0x5E,0x7A,0x8D,0xC5,0x6D,0x97,0x39,0x05,0xC3,0x4E,0xEE,0x39,0x00,0x47,0x37,0xC8,0x5D,0x1E,0x36,0x72,0x80,0x67,0xFC,0xB0,0x39,0x76,0x33,0x65,0xDC,0x0E,0xB3,0x2F,0x04,0xFB,0x96,0x29,0x8F,0xDF,0x7E,0x59,0x6E,0x66,0x7C,0x3D,0x97,0x8E,0x1F,0x8E,0x10,0x7D,0xA2,0x5E,0xDD,0xA0,0xCC,0xE4,0xE2,0x0F,0x62,0xAC,0xB1,0x29,0xC3,0x8E,0x18,0x13,0x41};
const uint8_t p_addr_736[46] = {0xF0,0xF6,0xA1,0x37,0x11,0x4A,0x50,0x90,0x4E,0x9D,0x6B,0xE0,0x19,0xD7,0xA1,0x3E,0x47,0xE8,0xCA,0xC9,0xA5,0x0C,0x37,0x1F,0x06,0x09,0xDB,0x2D,0x11,0xE4,0xB6,0x7F,0x46,0x85,0x27,0x09,0x23,0x31,0xA8,0xEB,0xC4,0x6E,0xE3,0x04,0x98,0xBB};
const uint8_t q_addr_736[46] = {0xC6,0x8D,0x6D,0xF7,0xED,0xC5,0x1D,0xB6,0x0F,0xAD,0x1C,0x53,0x7C,0x9C,0x3D,0x22,0xF7,0xA0,0x5D,0x39,0xDE,0xF2,0x6B,0x39,0xB7,0x75,0xF3,0xDA,0xCF,0x80,0x8A,0x08,0x99,0x5E,0x58,0x2F,0x58,0x2D,0x6F,0x83,0xB1,0xB2,0x2E,0xAF,0x4E,0xE1};
const uint8_t dp_addr_736[46] = {0x30,0xEF,0x14,0xEC,0x36,0xF1,0xAD,0x8C,0xB0,0xBA,0x5D,0x56,0xE4,0x48,0x9A,0xF1,0x27,0xEF,0x49,0x87,0x4B,0xA2,0x40,0x6B,0x67,0x71,0x86,0xF6,0x0F,0x25,0x30,0x3E,0x86,0x96,0xB1,0xC7,0xB4,0x42,0xF8,0x77,0xF0,0xAB,0x48,0x24,0xFD,0xD3};
const uint8_t dq_addr_736[46] = {0x9D,0xE5,0x18,0x9F,0x82,0x39,0x30,0x10,0x79,0x54,0xEB,0xE2,0xC4,0x84,0xA6,0xE5,0xA8,0xD0,0xA1,0x72,0x85,0x06,0x79,0x18,0xB3,0xF9,0x9C,0x0B,0xD4,0xD9,0xDE,0x6B,0x4A,0x33,0xC9,0xA3,0x14,0xD7,0x45,0x08,0x10,0x86,0xA7,0x33,0x88,0x61};
const uint8_t pq_addr_736[46] = {0x8B,0x72,0xE9,0xDB,0x7F,0x26,0x19,0xE4,0xD1,0x3D,0xF2,0x8B,0x02,0x29,0x7B,0xA1,0xF6,0xF2,0x6B,0xDC,0xF6,0x30,0x27,0xFC,0xE7,0xDA,0x38,0xA7,0xAF,0x24,0x45,0xF8,0xF8,0x97,0x49,0xA3,0xE8,0x85,0xED,0x4A,0x8C,0x5C,0xB8,0x72,0xE8,0xF2};

const uint8_t plain_736[92] = {0x11,0x11,0x11,0x11,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x22,0x22,0x22,0x22};
const uint8_t ciper_736[92] = {0x6F,0x79,0x2D,0x43,0x6A,0x7D,0xF8,0xD1,0x19,0x84,0xCD,0xAE,0x91,0x63,0x94,0x68,0x5A,0x9D,0x78,0x1B,0xE0,0x3B,0x9A,0x74,0x63,0x69,0x07,0x16,0xA4,0xCF,0x1B,0x39,0x44,0x4E,0xDD,0x74,0x2F,0x51,0xD8,0x90,0x10,0xB2,0x8E,0xFC,0xA3,0x4B,0x2B,0xCC,0x7F,0xAE,0xBE,0x7D,0x16,0x30,0x0B,0xCC,0xA2,0xD9,0xA9,0x0B,0x6C,0x43,0xF7,0x49,0x62,0x96,0x60,0x71,0xE4,0xBE,0x91,0xB0,0x96,0x72,0x42,0xE0,0xE7,0xEA,0xDA,0x92,0x75,0xAA,0x6C,0xFD,0x90,0x64,0x07,0xC0,0xA4,0xE3,0x64,0x19};
#endif
	uint32_t i;
//	uint32_t uLen;
	uint8_t plain[256];
	uint8_t cipher0[256];
	uint8_t plain0[256];
	uint32_t byte_len;
	uint8_t fixkey;
	uint32_t rsa_bits;

	uint8_t n_addr[256];
	uint8_t p_addr[128];
	uint8_t q_addr[128];
	uint8_t dp_addr[128];
	uint8_t dq_addr[128];
	uint8_t qinv_addr[128];
	uint8_t d_addr[256];
	uint8_t e_addr[256];
	uint32_t out_len;
	int result;
/*
	result = rsa_dpa_ctrl(dpa_high);
	if (result != SUCCESS_ALG)
	{
		return;
	}
*/

#ifdef RSA_DATA_376
	/********************** ʹⳤԿйԿ*****************************/
	rsa_pub_key_t publickey;

	rsa_bits = 736;
	byte_len = rsa_bits / 8;
	memcpy(n_addr, (uint8_t*)n_addr_736, byte_len);
	memcpy(plain, (uint8_t*)plain_736, byte_len);

	publickey.bits = rsa_bits;
	publickey.modulus = n_addr;
	publickey.exponent = e_addr;
	publickey.exponent[0] = 0x01;
	publickey.exponent[1] = 0x00;
	publickey.exponent[2] = 0x01;
	publickey.explen = 3;

	if(rsa_public_func_2(&publickey,cipher0,&out_len,plain, byte_len) != SUCCESS_ALG)
	{
		printf("RSA PUBLIC FUNC FAIL\r\n");
		return;
	}

	for(i = 0 ; i < byte_len ; i++)
	{
		if(cipher0[i] != ciper_736[i])
		{
			printf("RSA pub test failed!\n");
			return;
		}
	}
	printf("RSA EFLASH TEST ok\r\n");
#endif
#if 1
	/********************** ʹù̶*****************************/
#if 1
	// 2048λ
	rsa_bits = 2048;
	fixkey = 1;
	byte_len = rsa_bits / 8;
	memcpy(n_addr, (uint8_t*)n_addr_2048, byte_len);
	memcpy(d_addr, (uint8_t*)d_addr_2048, byte_len);
	memcpy(plain, (uint8_t*)plain_2048, byte_len);
	memcpy(p_addr, (uint8_t*)p_addr_2048, byte_len/2);
	memcpy(q_addr, (uint8_t*)q_addr_2048, byte_len/2);
	memcpy(dp_addr, (uint8_t*)dp_addr_2048, byte_len/2);
	memcpy(dq_addr, (uint8_t*)dq_addr_2048, byte_len/2);
	memcpy(qinv_addr, (uint8_t*)qinv_addr_2048, byte_len/2);

    /******************************** CRTģʽ ************************************/

	result = RsaPubKey_2(fixkey,n_addr,0, plain, byte_len, cipher0, &out_len);
	if (result != SUCCESS_ALG)
	{
		return;
	}

	for(i = 0 ; i < byte_len ; i++)
    {
    	if(cipher0[i] != ciper_2048[i])
    	{
    		printf("RSA pub test failed!\n");
			return;
    	}
    }
/*
	for (i=0; i<byte_len; i++)
	{
		printf(" %02x", cipher0[i]);
	}
*/
	result = RsaPrivKeyCRT_2(p_addr, q_addr,  dp_addr, dq_addr,  qinv_addr, cipher0, out_len, plain0, &out_len);
	if (result != SUCCESS_ALG)
	{
		return;
	}

	for(i = 0 ; i <byte_len ; i++)
    {
    	if(plain0[i] != plain[i])
    	{
    		printf("RSA CRT test failed!\n");
			return;
    	}
    }



    /******************************** CRTģʽ ************************************/

	result = RsaPubKey_2(fixkey,n_addr,0, plain, byte_len, cipher0, &out_len);
	if (result != SUCCESS_ALG)
	{
		return;
	}
	for(i = 0 ; i < byte_len ; i++)
    {
    	if(cipher0[i] !=  ciper_2048[i])
    	{
    		printf("RSA pub test failed!\n");
			return;
    	}
    }
	/*
	for (i=0; i<byte_len; i++)
	{
		printf(" %02x", cipher0[i]);
	}
	*/
//	if(dpa == dpa_high)
//	{
//	memset(e_addr, 0, byte_len);
//	e_addr[byte_len-1] = 0x01;
//	e_addr[byte_len-3] = 0x01;

//		result = RsaPrivKey_3(n_addr, d_addr, e_addr, cipher0, out_len, plain0, &out_len);
//	}
//	else
//	{
		result = RsaPrivKey_2(n_addr, d_addr, cipher0, out_len, plain0, &out_len);
//	}

	if (result != SUCCESS_ALG)
	{
		return;
	}

	for(i = 0 ; i < byte_len ; i++)
    {
    	if(plain0[i] != plain[i])
    	{
    		printf("RSA test failed!\n");
			return;
    	}
    }

	printf("RSA fixdata 2048 bits test ok!\n");
#endif

#if 1
	// 1984λ
	rsa_bits = 1984;
	fixkey = 1;
	byte_len = rsa_bits / 8;
	memcpy(n_addr, (uint8_t*)n_addr_1984, byte_len);
	memcpy(d_addr, (uint8_t*)d_addr_1984, byte_len);
	memcpy(plain, (uint8_t*)plain_1984, byte_len);
	memcpy(p_addr, (uint8_t*)p_addr_1984, byte_len/2);
	memcpy(q_addr, (uint8_t*)q_addr_1984, byte_len/2);
	memcpy(dp_addr, (uint8_t*)dp_addr_1984, byte_len/2);
	memcpy(dq_addr, (uint8_t*)dq_addr_1984, byte_len/2);
	memcpy(qinv_addr, (uint8_t*)qinv_addr_1984, byte_len/2);

    /******************************** CRTģʽ ************************************/

	result = RsaPubKey_2(fixkey,n_addr,0, plain, byte_len, cipher0, &out_len);
	if (result != SUCCESS_ALG)
	{
		return;
	}

	for(i = 0 ; i < byte_len ; i++)
    {
    	if(cipher0[i] != ciper_1984[i])
    	{
    		printf("RSA pub test failed!\n");
			return;
    	}
    }
/*
	for (i=0; i<byte_len; i++)
	{
		printf(" %02x", cipher0[i]);
	}
*/
	result = RsaPrivKeyCRT_2(p_addr, q_addr,  dp_addr, dq_addr,  qinv_addr, cipher0, out_len, plain0, &out_len);
	if (result != SUCCESS_ALG)
	{
		return;
	}

	for(i = 0 ; i <byte_len ; i++)
    {
    	if(plain0[i] != plain[i])
    	{
    		printf("RSA CRT test failed!\n");
			return;
    	}
    }



    /******************************** CRTģʽ ************************************/

	result = RsaPubKey_2(fixkey,n_addr,0, plain, byte_len, cipher0, &out_len);
	if (result != SUCCESS_ALG)
	{
		return;
	}
	for(i = 0 ; i < byte_len ; i++)
    {
    	if(cipher0[i] !=  ciper_1984[i])
    	{
    		printf("RSA pub test failed!\n");
			return;
    	}
    }
	/*
	for (i=0; i<byte_len; i++)
	{
		printf(" %02x", cipher0[i]);
	}
	*/
//	if(dpa == dpa_high)
//	{
//	memset(e_addr, 0, byte_len);
//	e_addr[byte_len-1] = 0x01;
//	e_addr[byte_len-3] = 0x01;
//		result = RsaPrivKey_3(n_addr, d_addr, e_addr, cipher0, out_len, plain0, &out_len);
//	}
//	else
//	{
		result = RsaPrivKey_2(n_addr, d_addr, cipher0, out_len, plain0, &out_len);
//	}
	if (result != SUCCESS_ALG)
	{
		return;
	}

	for(i = 0 ; i < byte_len ; i++)
    {
    	if(plain0[i] != plain[i])
    	{
    		printf("RSA test failed!\n");
			return;
    	}
    }

	printf("RSA fixdata 1984 bits test ok!\n");
#endif

#if 1
	// 1024λ
	rsa_bits = 1024;
	fixkey = 1;
	byte_len = rsa_bits / 8;
	memcpy(n_addr, (uint8_t*)n_addr_1024, byte_len);
	memcpy(d_addr, (uint8_t*)d_addr_1024, byte_len);
	memcpy(plain, (uint8_t*)plain_1024, byte_len);
	memcpy(p_addr, (uint8_t*)p_addr_1024, byte_len/2);
	memcpy(q_addr, (uint8_t*)q_addr_1024, byte_len/2);
	memcpy(dp_addr, (uint8_t*)dp_addr_1024, byte_len/2);
	memcpy(dq_addr, (uint8_t*)dq_addr_1024, byte_len/2);
	memcpy(qinv_addr, (uint8_t*)qinv_addr_1024, byte_len/2);

    /******************************** CRTģʽ ************************************/

	result = RsaPubKey_2(fixkey,n_addr,0, plain, byte_len, cipher0, &out_len);
	if (result != SUCCESS_ALG)
	{
		return;
	}

	for(i = 0 ; i < byte_len ; i++)
    {
    	if(cipher0[i] != ciper_1024[i])
    	{
    		printf("RSA pub test failed!\n");
			return;
    	}
    }
/*
	for (i=0; i<byte_len; i++)
	{
		printf(" %02x", cipher0[i]);
	}
*/
	result = RsaPrivKeyCRT_2(p_addr, q_addr,  dp_addr, dq_addr,  qinv_addr, cipher0, out_len, plain0, &out_len);
	if (result != SUCCESS_ALG)
	{
		return;
	}

	for(i = 0 ; i <byte_len ; i++)
    {
    	if(plain0[i] != plain[i])
    	{
    		printf("RSA CRT test failed!\n");
			return;
    	}
    }



    /******************************** CRTģʽ ************************************/

	result = RsaPubKey_2(fixkey,n_addr,0, plain, byte_len, cipher0, &out_len);
	if (result != SUCCESS_ALG)
	{
		return;
	}
	for(i = 0 ; i < byte_len ; i++)
    {
    	if(cipher0[i] !=  ciper_1024[i])
    	{
    		printf("RSA pub test failed!\n");
			return;
    	}
    }
	/*
	for (i=0; i<byte_len; i++)
	{
		printf(" %02x", cipher0[i]);
	}
	*/

//	if(dpa == dpa_high)
//	{
//	memset(e_addr, 0, byte_len);
//	e_addr[byte_len-1] = 0x01;
//	e_addr[byte_len-3] = 0x01;
//		result = RsaPrivKey_3(n_addr, d_addr, e_addr, cipher0, out_len, plain0, &out_len);
//	}
//	else
//	{
		result = RsaPrivKey_2(n_addr, d_addr, cipher0, out_len, plain0, &out_len);
//	}	
	
	if (result != SUCCESS_ALG)
	{
		return;
	}

	for(i = 0 ; i < byte_len ; i++)
    {
    	if(plain0[i] != plain[i])
    	{
    		printf("RSA test failed!\n");
			return;
    	}
    }

	printf("RSA fixdata 1024 bits test ok!\n");
#endif

#ifdef RSA_DATA_376
	// 736λ
	rsa_bits = 736;
	fixkey = 1;
	byte_len = rsa_bits / 8;
	memset(p_addr,0x00,sizeof(p_addr));
	memset(q_addr,0x00,sizeof(q_addr));
	memset(dp_addr,0x00,sizeof(dp_addr));
	memset(dq_addr,0x00,sizeof(dq_addr));
	memset(qinv_addr,0x00,sizeof(qinv_addr));
	memcpy(n_addr, (uint8_t*)n_addr_736, byte_len);
	memcpy(d_addr, (uint8_t*)d_addr_736, byte_len);
	memcpy(plain, (uint8_t*)plain_736, byte_len);
	memcpy(p_addr, (uint8_t*)p_addr_736, byte_len/2);
	memcpy(q_addr, (uint8_t*)q_addr_736, byte_len/2);
	memcpy(dp_addr, (uint8_t*)dp_addr_736, byte_len/2);
	memcpy(dq_addr, (uint8_t*)dq_addr_736, byte_len/2);
	memcpy(qinv_addr, (uint8_t*)pq_addr_736, byte_len/2);

    /******************************** CRTģʽ ************************************/
	result = RsaPubKey_2(fixkey,n_addr,0, plain, byte_len, cipher0, &out_len);
	if (result != SUCCESS_ALG)
	{
		return;
	}

	for(i = 0 ; i < byte_len ; i++)
    {
    	if(cipher0[i] !=  (uint8_t)ciper_736[i])
    	{
    		printf("RSA Pub test failed!\n");
			return;
    	}
    }



//	for (i=0; i<byte_len; i++)
//	{
//		printf(" %02x", cipher0[i]);
//	}

	result = RsaPrivKey_2(n_addr, d_addr, cipher0, out_len, plain0, &out_len);
	if (result != SUCCESS_ALG)
	{
		return;
	}

	for(i = 0 ; i < byte_len ; i++)
    {
    	if(plain0[i] != plain[i])
    	{
    		printf("RSA PrivKey test failed!\n");
			return;
    	}
    }
    /******************************** CRTģʽ ************************************/

	result = RsaPubKey_2(fixkey,n_addr,0, plain, byte_len, cipher0, &out_len);
	if (result != SUCCESS_ALG)
	{
		return;
	}

	for(i = 0 ; i < byte_len ; i++)
    {
    	if(cipher0[i] != *((uint8_t*)ciper_736+i))
    	{
    		printf("RSA Pub test failed!\n");
			return;
    	}
    }


//	for (i=0; i<byte_len; i++)
//	{
//		printf(" %02x", cipher0[i]);
//	}
//	printf("\r\n");
	result = RsaPrivKeyCRT_2(p_addr, q_addr,  dp_addr, dq_addr,  qinv_addr, cipher0, out_len, plain0, &out_len);
	if (result != SUCCESS_ALG)
	{
		return;
	}
//	for (i=0; i<byte_len; i++)
//	{
//		printf(" %02x", plain0[i]);
//	}
//	printf(" \r\n");
	for(i = 0 ; i <byte_len ; i++)
    {
    	if(plain0[i] != plain[i])
    	{
    		printf("RSA PrivKey crt test failed!\n");
			return;
    	}
    }

	printf("RSA fixdata 736 bits test ok!\n");
#endif

#endif
	/********************** ʹ*****************************/
#if 1

	fixkey = 1;
	for (rsa_bits=512; rsa_bits<=2048; rsa_bits+=64)		//ѭ64λ
	{

	byte_len = rsa_bits / 8;

	result = rsa_keypair_gen(rsa_bits,fixkey, n_addr,0, d_addr, p_addr, q_addr, dp_addr, dq_addr, qinv_addr);
	printf(" %02x", result);
	if (result != SUCCESS_ALG)
	{
		return;
	}

    for(i = 0 ; i < byte_len ; i++)
    {
    	plain[i] = (uint8_t)GetRandomWord();
    }
	plain[0] = plain[1] = 0;

	result = RsaPubKey_2(fixkey,n_addr,0, plain, byte_len, cipher0, &out_len);
	printf(" %02x", result);
	if (result != SUCCESS_ALG)
	{
		return;
	}
	result = RsaPrivKeyCRT_2(p_addr, q_addr,  dp_addr, dq_addr,  qinv_addr, cipher0, byte_len, plain0, &out_len);
	printf(" %02x", result);
	if (result != SUCCESS_ALG)
	{
		return;
	}

	for(i = 0 ; i < rsa_bits / 8 ; i++)
    {
    	if(plain0[i] != plain[i])
    	{
    		printf("RSA CRT test failed!\n");
			return;
    	}
    }

//	if(dpa == dpa_high)
//	{
//	memset(e_addr, 0, byte_len);
//	e_addr[byte_len-1] = 0x01;
//	e_addr[byte_len-3] = 0x01;
//		result = RsaPrivKey_3(n_addr, d_addr, e_addr, cipher0, out_len, plain0, &out_len);
//	}
//	else
//	{
		result = RsaPrivKey_2(n_addr, d_addr, cipher0, out_len, plain0, &out_len);
//	}
	printf(" %02x", result);
	if (result != SUCCESS_ALG)
	{
		return;
	}

	for(i = 0 ; i < rsa_bits / 8 ; i++)
    {
    	if(plain0[i] != plain[i])
    	{
    		printf("RSA test failed!\n");
			return;
    	}
    }

	printf("\nRSA fixkey test ok %d bit!\n", rsa_bits);
	}

	printf("RSA EFLASH TEST\r\n");

	 for(i = 0 ; i < 128 ; i++)
	{
		plain[i] = (uint8_t)GetRandomWord();
	}
	plain[0] = plain[1] = 0;
	result = rsa_keypair_gen(1024,1, n_addr,0, d_addr, p_addr, q_addr, dp_addr, dq_addr, qinv_addr);
	printf(" %02x", result);
	if (result != SUCCESS_ALG)
	{
		return;
	}

	memset(e_addr, 0, 128);
	e_addr[128-1] = 0x01;
	e_addr[128-3] = 0x01;

	EFLASH_PageErase(0x8042200);
	EFLASH_PageErase(0x8042400);
	EFLASH_WordsProg(0x8042200,(uint32_t *)n_addr,32);
	EFLASH_WordsProg(0x8042280,(uint32_t *)d_addr,32);
	EFLASH_WordsProg(0x8042300,(uint32_t *)p_addr,16);
	EFLASH_WordsProg(0x8042340,(uint32_t *)q_addr,16);
	EFLASH_WordsProg(0x8042380,(uint32_t *)dp_addr,16);
	EFLASH_WordsProg(0x80423C0,(uint32_t *)dq_addr,16);
	EFLASH_WordsProg(0x8042400,(uint32_t *)qinv_addr,16);
	EFLASH_WordsProg(0x8042440,(uint32_t *)plain,32);
	EFLASH_WordsProg(0x80424c0,(uint32_t *)e_addr,32);


	result = RsaPubKey_2(1,(uint8_t *)0x8042200,0, (uint8_t *)0x8042440, 128, cipher0, &out_len);
	printf(" %02x", result);
	if (result != SUCCESS_ALG)
	{
		return;
	}

//	if(dpa == dpa_high)
//	{
//		result = RsaPrivKey_3((uint8_t *)0x442200,(uint8_t *)0x442280, (uint8_t *)0x4424C0, cipher0, 128, plain0, &out_len);
//	}
//	else
//	{
		result = RsaPrivKey_2((uint8_t *)0x8042200,(uint8_t *)0x8042280, cipher0, 128, plain0, &out_len);
//	}
	printf(" %02x", result);
	if (result != SUCCESS_ALG)
	{
		return;
	}
	for(i = 0 ; i < 128 ; i++)
	{
		if(plain0[i] != plain[i])
		{
			printf("RSA test failed!\n");
			return;
		}
	}

	result = RsaPrivKeyCRT_2((uint8_t *)0x8042300, (uint8_t *)0x8042340,  (uint8_t *)0x8042380, (uint8_t *)0x80423C0,  (uint8_t *)0x8042400, cipher0, 128, plain0, &out_len);
	printf(" %02x", result);
	if (result != SUCCESS_ALG)
	{
		return;
	}

	for(i = 0 ; i < 128 ; i++)
	{
		if(plain0[i] != plain[i])
		{
			printf("RSA CRT test failed!\n");
			return;
		}
	}
	printf("RSA EFLASH TEST ok\r\n");

#endif

#if 0
	fixkey = 0;
	for (rsa_bits=512; rsa_bits<=2048; rsa_bits+=64)		//ѭ64λ
	{

	byte_len = rsa_bits / 8;


	result = rsa_keypair_gen(rsa_bits,fixkey, n_addr,e_addr, d_addr, p_addr, q_addr, dp_addr, dq_addr, qinv_addr);
	printf(" %02x", result);
	if (result != SUCCESS_ALG)
	{
		return;
	}

    for(i = 0 ; i < byte_len ; i++)
    {
    	plain[i] = (uint8_t)GetRandomWord();
    }
	plain[0] = plain[1] = 0;

	result = RsaPubKey_2(fixkey,n_addr,e_addr, plain, byte_len, cipher0, &out_len);
	printf(" %02x", result);
	if (result != SUCCESS_ALG)
	{
		return;
	}
	result = RsaPrivKeyCRT_2(p_addr, q_addr,  dp_addr, dq_addr,  qinv_addr, cipher0, out_len, plain0, &out_len);
	printf(" %02x", result);
	if (result != SUCCESS_ALG)
	{
		return;
	}

	for(i = 0 ; i < rsa_bits / 8 ; i++)
    {
    	if(plain0[i] != plain[i])
    	{
    		printf("RSA CRT test failed!\n");
			return;
    	}
    }

	result = RsaPrivKey_2(n_addr, d_addr, cipher0, out_len, plain0, &out_len);
	printf(" %02x", result);
	if (result != SUCCESS_ALG)
	{
		return;
	}

	for(i = 0 ; i < rsa_bits / 8 ; i++)
    {
    	if(plain0[i] != plain[i])
    	{
    		printf("RSA test failed!\n");
			return;
    	}
    }

	printf("\nRSA randomkey test ok %d bit!\n", rsa_bits);
	}
#endif

}

static void TRNG_Demo(void)
{
	uint32_t i;

	for (i=0; i<0x200; i++)
	{
		 printf(" %08x\t", GetRandomWord());
		 
		 if((i&0x1F) == 0)
		 {
				printf("\n");
		 }
	}
}


extern void Crc_Demo(void);

//ջȫֱ0x20000000֮󣬼IRAMStart0x20000000,size0x38000
void Algo_Demo(void)
{
	unsigned char Alg_version[100];
	dpa_level_t rsa_dpa = dpa_disable;
	int i;
	
	rsa_dpa = rsa_dpa;
	Get_AlgLib_Version(Alg_version);
	printf("the version of the AlgLib is %s!\n", Alg_version);

	//ʼ
	Init_Trng();
	//EFLASHݶдԣҪEFLASHдʹ
	EFLASH_Init(g_sys_clk/1000);
	EFLASH_SetWritePermission();
	
	for (i=0;i<5;i++)
	{
		if (i==0)
		{
			//Ĭϲʹdpa
			printf("\n\t\no dpa level!\n");
		}
		if (i==1)
		{
			aes_dpa_ctrl(dpa_disable);
			des_dpa_ctrl(dpa_disable);
			sm4_dpa_ctrl(dpa_disable);
			printf("\n\t\tdpa level disable!\n");
		}
		if (i==2)
		{
			aes_dpa_ctrl(dpa_low);
			des_dpa_ctrl(dpa_low);
			sm4_dpa_ctrl(dpa_low);
			printf("\n\tdpa level low!\n");
		}
		if (i==3)
		{
			aes_dpa_ctrl(dpa_middle);
			des_dpa_ctrl(dpa_middle);
			sm4_dpa_ctrl(dpa_middle);
			printf("\n\tdpa level middle!\n");
		}
		if (i==4)
		{
			aes_dpa_ctrl(dpa_high);
			des_dpa_ctrl(dpa_high);
			sm4_dpa_ctrl(dpa_high);
			printf("\n\t\tdpa level high!\n");
		}
		printf("\n\t\tbegin test trng!\n");
		TRNG_Demo();
		printf("\n\t\ttrng test OK!\n");

		printf("\n\t\tbegin test crc!\n");
		Crc_Demo();
		printf("\n\t\tcrc test OK!\n");		
		
		printf("\n\t\tbegin test aes!\n");
		AES_Demo();
		printf("\n\t\taes test OK!\n");

		printf("\n\t\tbegin test sm4!\n");
		SMS4_Demo();
		printf("\n\t\tsm4 test OK!\n");

		printf("\n\t\tbegin test des!\n");
		DES_Demo();
		printf("\n\t\tdes test OK!\n");

		printf("\n\t\tbegin test sha!\n");
		SHA_Demo();
		printf("\n\t\tsha test OK!\n");
		
		printf("\n\t\tbegin test sm2!\n");
		SM2_Demo();
		printf("\n\t\tsm2 test OK!\n");

		printf("\n\t\tbegin test rsa!\n");
		RSA_Demo();
		printf("\n\t\trsa test OK!\n");
	}
}
