// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// File name    : spi_demo.c
// Version      : V0.1
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#include <string.h>
#include "memmap.h"
#include "spi_demo.h"
#include "spi_drv.h"
#include "spi_reg.h"
#include "dmac_drv.h"
#include "debug.h"
#include "delay.h"
#include "ccm_drv.h"
#include "ccm_reg.h"

#define SPI_MODE_TEST		1

#define SPI_MASTER_MODE

#define SPI_CPU_MODE
//#define SPI_DMAC_MODE		//ջȫֱ0x20000000֮󣬼IRAMStart0x20000000,size0x38000
//#define SPI_EDMAC_MODE	//ջȫֱ0x20000000֮󣬼IRAMStart0x20000000,size0x38000

void SPI_GPIO_Test(SPI_TypeDef* SPIx)
{
	
#if 1
	SPI_ConfigGpio(SPIx, SPI_MISO, GPIO_OUTPUT);
	SPI_ConfigGpio(SPIx, SPI_MOSI, GPIO_OUTPUT);
	SPI_ConfigGpio(SPIx, SPI_SCK, GPIO_OUTPUT);
	SPI_ConfigGpio(SPIx, SPI_SS, GPIO_OUTPUT);
	
	while(1)
	{
		SPI_WriteGpioData(SPIx, SPI_MISO, Bit_SET);
		SPI_WriteGpioData(SPIx, SPI_MOSI, Bit_SET);
		SPI_WriteGpioData(SPIx, SPI_SCK, Bit_SET);
		SPI_WriteGpioData(SPIx, SPI_SS, Bit_SET);
		DelayMS(500);
		SPI_WriteGpioData(SPIx, SPI_MISO, Bit_RESET);
		SPI_WriteGpioData(SPIx, SPI_MOSI, Bit_RESET);
		SPI_WriteGpioData(SPIx, SPI_SCK, Bit_RESET);
		SPI_WriteGpioData(SPIx, SPI_SS, Bit_RESET);
		DelayMS(500);
	}
#else
	SPI_ConfigGpio(SPIx, SPI_MISO, GPIO_INPUT);
	SPI_ConfigGpio(SPIx, SPI_MOSI, GPIO_INPUT);
	SPI_ConfigGpio(SPIx, SPI_SCK, GPIO_INPUT);
	SPI_ConfigGpio(SPIx, SPI_SS, GPIO_INPUT);
	
	while(1)
	{
		printf("SPI_MISO:%02x\r\n",SPI_ReadGpioData(SPIx, SPI_MISO));
		printf("SPI_MOSI:%02x\r\n",SPI_ReadGpioData(SPIx, SPI_MOSI));
		printf("SPI_SCK:%02x\r\n",SPI_ReadGpioData(SPIx, SPI_SCK));
		printf("SPI_SS:%02x\r\n",SPI_ReadGpioData(SPIx, SPI_SS));
		printf("*********************************************\r\n");
		DelayMS(1000);
	}
#endif
}

void SPI_Demo(void)
{
	uint16_t i;
	uint32_t len;
	uint8_t spi_id;
	uint32_t dma_base_addr;
	//	uint8_t send[4] = {0x9F,0x5A,0x5A,0x5A};
//	uint8_t receive[4];
	uint8_t send[256] = {0};
	uint8_t receive[256];
	SPI_TypeDef *spi_base_addr;
	
	spi_base_addr = SPI1;
	spi_id = spi_id;
	spi_id = 0;		//SPI1:0; SPI2:1; SPI3:2
	dma_base_addr = DMA1_BASE_ADDR;  //SPI1 AND SPI2 :DMA1_BASE_ADDR;  SPI3:DMA2_BASE_ADDR
	len = 0x100;
	
#if SPI_MODE_TEST
	
#ifdef SPI_MASTER_MODE
	
	printf("SPI test begin\r\n");

	SPI_InitTypeDef SPI_InitStruct;
	SPI_StructInit(SPI_Mode_Master,&SPI_InitStruct);
	SPI_Init(spi_base_addr,&SPI_InitStruct);
	
	DMA_Init(dma_base_addr);

	memset(receive,0x00,len);
	for(i = 0;i<len;i++)
	{
		send[i] = i;
	}
	SPI_CS_L(spi_base_addr);
#ifdef SPI_CPU_MODE
	SPI_MasterSendData(spi_base_addr,send,len);
	SPI_MasterReceiveData(spi_base_addr,receive,len);
#endif
#ifdef SPI_DMAC_MODE
	SPI_EnableDMA(spi_base_addr,TRUE);
	dma_spitran(spi_id,send,receive,len,FALSE);
	SPI_EnableDMA(spi_base_addr,FALSE);
#endif
#ifdef SPI_EDMAC_MODE
	SPI_MasterOnlySendDataByEDMA(spi_base_addr,(uint32_t)send,len);
	SPI_MasterReceiveDataByEDMA(spi_base_addr,(uint32_t)receive,len);
#endif
	
	SPI_CS_H(spi_base_addr);
	
	printf("receive = ");
	for(i = 0;i <len;i++)
	{
		printf("%02x",receive[i]);
	}
	printf("\r\n");
	printf("SPI test end\r\n");

#else
	
	SPI_InitTypeDef SPI_InitStruct;
	SPI_StructInit(SPI_Mode_Slave,&SPI_InitStruct);
	SPI_Init(spi_base_addr,&SPI_InitStruct);
	DMA_Init(dma_base_addr);

	for(i = 0;i<len;i++)
	{
		send[i] = i&0xFF;
	}

	while(1)
	{
		memset(receive,0,len);
#ifdef SPI_CPU_MODE           //cpuѯģʽ
		SPI_SlaveReceiveData(spi_base_addr,receive,len);
		SPI_SlaveSendData(spi_base_addr,send,len);
#endif

#ifdef SPI_DMAC_MODE                         //damģʽ
		SPI_EnableDMA(spi_base_addr,TRUE);
		dma_spitran(spi_id,send,receive,len,FALSE);
		SPI_EnableDMA(spi_base_addr,FALSE);
#endif
#ifdef SPI_EDMAC_MODE
	SPI_MasterOnlyReceiveDataByEDMA(spi_base_addr,(uint32_t)receive,len);
	SPI_MasterOnlySendDataByEDMA(spi_base_addr,(uint32_t)send,len);
#endif
	}

#endif

#else	//SPI GPIO test
	SPI_GPIO_Test(spi_base_addr);
#endif
}
