// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// File name    : adc_demo.c
// Version      : V0.1
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#include "tsi_demo.h"
#include "tsi_drv.h"
#include "sys.h"
#include "uart_drv.h"
#include "eflash_drv.h"
#include "wdt_drv.h"
#include "tc_drv.h"
#include "cpm_drv.h"
#include "debug.h"
#include "delay.h"
#include "pci_drv.h"

#define TSI_KEY_TEST
//#define TSI_WAKEUP_TEST

//#define TSI_WAKEUP_SECOND_JUDGE_TEST

void TSI_Demo(void)
{
	unsigned char key_data;
	
	PCI_Init(EXTERNAL_CLK_SEL);
	
#ifdef TSI_WAKEUP_SECOND_JUDGE_TEST	
//step1:жǷΪTSI	
	if((TSI_ISR&0x00000080)==0x00000080)
	{	//Wakeup From TSI
			printf("TSI_NFC_Conflict Judge\n");
			//step2:ѯCPM statusжǷΪһϵ
			if((CPM->CPM_SLPCFGR&0xc0000000)!=0)
			{
				NVIC_Init(3, 3, TSI_IRQn, 2);	
				//step3:ȡǰTSI_dataĴֵжǷΪ
				if(Get_Channel_Data(TSI_EN_CHANNEL))
				{//direct into lowpower	
					printf("direct into lowpower!\n");
				}	
			}
	}
#endif

	INIT_SENS_PARA;
	//ѯCPM statusжǷΪ͹Ļ
	if((CPM->CPM_SLPCFGR&0xc0000000)==0)
	{
/***************************************************************/  //PCI NVram INIT
		//PCI־λ޷дnvsram
		PCI_Clear_Status();
		Nvram_Write();
/***************************************************************/
		TSI_Init(TSI_EN_CHANNEL);
	}else{
		TSI_Wakeup_Re_init(TSI_EN_CHANNEL);
		printf("TSI_RE_INIT!/r/n");	
	}	
	
#ifdef TSI_KEY_TEST  //test key_scanf
	while(1)
	{
		key_data = TSI_Key_Data();
		if((key_data != 0xff)&&(key_data != 0xaa))
		{
			printf("CH:%d\r\n",key_data);
		}
	}
#endif	
	
#ifdef TSI_WAKEUP_TEST
	delay(5000000);
	Config_TSI_Lowpower_Wakeup(TSI_WAKEUP_CHANNEL);	
	printf("TSI Wakeup Config Ready!\r\n");
//	CPM_Sleep();
//	CPM_PowerOff_1();
	CPM_PowerOff_1p5();
	WDT_Close(); //رCLK
	TC_ResetInit(TC_WDP_0_5, 0xffff, FALSE); //رTC
	Sys_Init();
	UART_Debug_Init(SCI1,g_ips_clk, 115200);
	printf("TSI Wakeup!\r\n");
#endif 	
}


