/*
 * alg_drv.h
 *
 *  Created on: 201769
 *      Author: 
 */

#ifndef ALG_DRV_H_
#define ALG_DRV_H_
#include "type.h"
#include "memmap.h"

#define SRAM_BEGIN    (uint32_t)(0x20000000)
#define SRAM_END      (uint32_t)(0x20038000)

#define EFLASH_BEGIN  (uint32_t)(0x8000000)
#define EFLASH_END    (uint32_t)(0x807F000)

typedef enum
{
	TYPE_ERROR = 0,
	TYPE_SRAM  = 1,
	TYPE_EFLASH= 2,
}TYPE_ADDR;

/*******Hash㷨ͱ********/
#define	HASH_SM3				0
#define	HASH_SHA0				1
#define	HASH_SHA1				2
#define	HASH_SHA224				3
#define HASH_SHA256				4
#define HASH_SHA384				5
#define HASH_SHA512				6

/*******Hash㷨ݽṹ********/
typedef	struct Hash_tx
{
	unsigned int  hash_len[4];	   //δݳȣ
	unsigned int  DataBuf[16];     //
	unsigned char HASHMode;	       //Hash㷨ͱ
	unsigned char fb_flag[1];      //һݱ־,1 - һݴ;0 - δ

}Hash_tx;

#define SHA0_R_Len				20
#define SHA1_R_Len  			20
#define SHA224_R_Len 			28
#define SHA256_R_Len 			32
#define SM3_R_Len				32
#define SHA384_R_Len 			48
#define SHA512_R_Len 			64

//sm2
#define	SM2_TEST_BITS       	256
//صݽṹ㺯
#define ECC_BIGINT32_MAXLEN 	12

/*******32λṹ********/
typedef struct
{
 	uint16_t   uLen;                         //32λʵʳ
	uint32_t   auValue[ECC_BIGINT32_MAXLEN]; //32λֵĵ32λַŴĵ32λЧ32λַŴĸ32λЧ
}ECC_STU_BIGINT32;

/*******SM2ݽṹ********/
typedef struct
{
    uint16_t uBits;                               // ģPλ
	ECC_STU_BIGINT32  stuPrimeP;				// ģP
	ECC_STU_BIGINT32  stuCoefficientA;			// ԲϵA
	ECC_STU_BIGINT32  stuCoefficientB;			// ԲϵB
	ECC_STU_BIGINT32  stuGx;				    // ԲGx
	ECC_STU_BIGINT32  stuGy;				    // ԲGy
	ECC_STU_BIGINT32  stuPrimeN;				// ԲGĽ
} SM2_STU_PRAMS;

/******SM2Կṹ********/
typedef struct
{
	ECC_STU_BIGINT32  stuQx;			        // ԿQx
	ECC_STU_BIGINT32  stuQy;				    // ԿQy
} SM2_STU_PUBKEY;


extern SM2_STU_PRAMS stuEccPrams;
extern SM2_STU_PUBKEY stuPubKey;
extern ECC_STU_BIGINT32 stuPrivKey;
extern ECC_STU_BIGINT32 stuSignatureR;
extern ECC_STU_BIGINT32 stuSignatureS;


//rsa
//#define		RSA_TEST_BITS	512
//#define		RSA_TEST_BITS	1024
#define		RSA_TEST_BITS	2048

//#define MAX_RSA_MODULUS_BITS 512
//#define MAX_RSA_MODULUS_BITS 1024
#define MAX_RSA_MODULUS_BITS 2048

#define MAX_RSA_MODULUS_LEN ((MAX_RSA_MODULUS_BITS + 31) / 32)
#define MAX_RSA_PRIME_BITS	((MAX_RSA_MODULUS_BITS +  1) / 2 )
#define MAX_RSA_PRIME_LEN	((MAX_RSA_PRIME_BITS   + 31) / 32)

/******RSAԿṹ********/
typedef struct
{
	unsigned int bits;                                /* length in bits of modulus */
	unsigned int modulus[MAX_RSA_MODULUS_LEN];        /* modulus */
	unsigned int exponent[MAX_RSA_MODULUS_LEN];       /* public exponent */
} STU_RSA_PUBKEY;

/******RSA˽Կṹ********/
typedef struct
{
	unsigned int bits;                                  /* length in bits of modulus */
	unsigned int modulus[MAX_RSA_MODULUS_LEN];          /* modulus */
	unsigned int publicExponent[MAX_RSA_MODULUS_LEN];   /* public exponent */
	unsigned int exponent[MAX_RSA_MODULUS_LEN];         /* private exponent */
	unsigned int prime[2][MAX_RSA_PRIME_LEN];           /* prime factors */
	unsigned int primeExponent[2][MAX_RSA_PRIME_LEN];   /* exponents for CRT */
	unsigned int coefficient[MAX_RSA_PRIME_LEN];        /* CRT coefficient */
} STU_RSA_PRIVKEY;

typedef struct
{
	unsigned int  bits;               /*length in bits of modulus*/
	unsigned char *modulus;           /* modulus */
	unsigned char *exponent;          /* public exponent */
	unsigned int  explen;             /* exponent bytes  */
}rsa_pub_key_t;

extern STU_RSA_PUBKEY  publicKeyRSA;
extern STU_RSA_PRIVKEY privateKeyRSA;

/*******************************************************************************
* Function Name  : AES_Enable
* Description    : ʹAESģ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
extern void AES_Enable(void);

/*******************************************************************************
* Function Name  : AES_Enable
* Description    : AESģ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
extern void AES_Disable(void);

/*******************************************************************************
* Function Name  : AES_EnDecrypt
* Description    : ͨAES (128bits192bits256bits)мӽ
*
*                 ע
*                 1ԭĿ˺ڲ֮ǰEDMACʱӣ˳֮ǰرEDMACʱ;걾֮ʹEDMACģ飬ҪEDMACģʱӣ
*                 2ԭ¿˳ͬ
*                 3ڲEDMACʱδκβ
*
* Input          : EncDe_Mode - ӽѡ
*                      0 - ʾ;
*                      1 - ʾ.
*                  CTR_ECB_MODE - ģʽѡ
*                      0 - ECBģʽ;
*                      1 - CTRģʽ.
*                  Key  -  ӽԿ
*                  cntIV -  CTRģʽʼֵ
*                  key_mode - AES㷨Կ
*                      0 - 128bit;
*                      1 - 192bit;
*                      2 - 256bit.
*                  srcbuffer - ӽݵַ
*                  Output - ӽַܽ
*                  datalen - ӽݳȣ16ֽڵ
* Output         : None
* Return         : None
******************************************************************************/
extern void AES_EnDecrypt(uint8_t EncDe_Mode, uint8_t CTR_ECB_MODE,uint32_t *Key, uint32_t *cntIV,uint32_t key_mode, uint32_t *srcbuffer, uint32_t *Output, uint32_t datalen);

/*******************************************************************************
* Function Name  : DES_Enable
* Description    : ʹDESģ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
extern void DES_Enable(void);

/*******************************************************************************
* Function Name  : DES_Disable
* Description    : DESģ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
extern void DES_Disable(void);

/*******************************************************************************
* Function Name  : AES_EnDecrypt
* Description    : ͨdes/3des (64bits128bits192bits) мӽ
*
*                 ע
*                 1ԭĿ˺ڲ֮ǰEDMACʱӣ˳֮ǰرEDMACʱ;걾֮ʹEDMACģ飬ҪEDMACģʱӣ
*                 2ڲEDMACʱδκβ
*
* Input          : EncDe_Mode - ӽѡ
*                      0 - ʾ;
*                      1 - ʾ.
*                  ECB_CBC_Mode - ģʽѡ
*                      0 - ECBģʽ;
*                      1 - CBCģʽ
*                  Key  -  ӽԿ
*                  KeyLen - ӽԿȣλΪֽ
*                      8  - 64bitdesӽ;
*                      16 - 128bit3desӽ;
*                      24 - 192bit3desӽ.
*                  ivbuffer - ʼ̶ֵΪ8ֽڳȵֵ
*                  srcbuffer - ӽݵַ
*                  Output - ӽַܽ
*                  datalen - ӽݳȣ8ֽڵ
*                  check_paritykeyǷҪУ飬У򷵻keyУټӽ
*                      1 - 򿪴˹;
*                      0 - ô˹.
* Output         : None
* Return         : None
******************************************************************************/
extern void DES_EnDecrypt(uint8_t EncDe_Mode, uint8_t ECB_CBC_Mode, uint32_t *Key, uint32_t KeyLen, uint32_t *ivbuffer, uint32_t *srcbuffer, uint32_t *Output,uint32_t datalen, uint8_t check_parity);

/*******************************************************************************
* Function Name  : SMS4_Enable
* Description    : ʹSMS4ģ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
extern void SMS4_Enable(void);

/*******************************************************************************
* Function Name  : SMS4_Disable
* Description    : SMS4ģ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
extern void SMS4_Disable(void);

/*******************************************************************************
* Function Name  : SMS4_EnDecrypt
* Description    : ͨSMS4ģݼӽ
*
*                 ע
*                 1ԭĿ˺ڲ֮ǰEDMACʱӣ˳֮ǰرEDMACʱ;걾֮ʹEDMACģ飬ҪEDMACģʱӣ
*                 2ڲEDMACʱδκβ
*
* Input          : EncDe_Mode - ӽѡ
*                      0 - ʾ;
*                      1 - ʾ.
*                  ECB_CBC_Mode - ģʽѡ
*                      0 - ECBģʽ;
*                      1 - CBCģʽ
*                  KEY - 128λӽԿ
*                  IV - 128λʼ
*                  ivbuffer - ʼ̶ֵΪ8ֽڳȵֵ
*                  srcbuffer - ӽݵַ
*                  Output - ӽַܽ
*                  datalen - ӽݳȣ16ֽڵ
* Output         : None
* Return         : None
******************************************************************************/
extern void SMS4_EnDecrypt (unsigned char EncDe_Mode, unsigned char ECB_CBC_Mode, unsigned int *KEY, unsigned int*IV, unsigned int *srcbuffer, unsigned int *Output, unsigned int datalen);

/*******************************************************************************
* Function Name  : SHA_Init
* Description    : SHA㷨ģʼ
*
*                 ע
*                 1ʹSHAģ麯֮ǰSHAEDAMCģʱ;
*                 2ԭ汾ȽHash_tx *phash_tx
*
* Input          : phash_tx - ϣ㷨ݽṹ
*                  HashModeNum - ϣ㷨ţȡֵΧ0~4
* Output         : None
* Return         : None
******************************************************************************/
extern void SHA_Init(Hash_tx *phash_tx, unsigned char HashModeNum);

/*******************************************************************************
* Function Name  : SHA_Update
* Description    : ҪSHA
*
*                 ע
*                 1ʹSHAģ麯֮ǰSHAEDAMCģʱӣ
*                 2ԭ汾ȽHash_tx *phash_tx
*
* Input          : phash_tx - ϣ㷨ݽṹ
*                  pMessageBlock C ָ򱾴δݣַ4ֽڶ
*                  DataLen C δݳȣΪ4
* Output         : None
* Return         : None
******************************************************************************/
extern void SHA_Update(Hash_tx *phash_tx, unsigned char *pMessageBlock, unsigned int DataLen);

/*******************************************************************************
* Function Name  : SHA_Final
* Description    : SHAȡ
*
*                 ע
*                 1ʹSHAģ麯֮ǰSHAEDAMCģʱӣ
*                 2ԭ汾ȽHash_tx *phash_tx
*
* Input          : phash_tx - ϣ㷨ݽṹ
*                  pRes C ϣ
* Output         : None
* Return         : SHAֽڳ
******************************************************************************/
extern unsigned int SHA_Final(Hash_tx *phash_tx, unsigned int *pRes);

/*******************************************************************************
* Function Name  : SM2_Enable
* Description    : SM2ģʹ
*
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
extern void SM2_Enable(void);

/*******************************************************************************
* Function Name  : SM2_Disable
* Description    : SM2ģ
*
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
extern void SM2_Disable(void);

/*******************************************************************************
* Function Name  : SM2Init
* Description    : SM2ģʼ
*
*                 ע
*                 ԭ⺯ΪECCInit(unsigned short bits);
*
* Input          : bits - SM2λ
* Output         : None
* Return         : None
******************************************************************************/
//extern void SM2Init(unsigned short bits);

/*******************************************************************************
* Function Name  : SM2GenerateKeyPair
* Description    : SM2ɵԿ
*
*                 ע
*                 1˺ڲʹģ飬ģʱӲInitTrng
*                 2ڲʹEDMACҪEDMACģʱӣ
*                 3ڲʹCRYPTOģ飬ҪCRYPTOģʱӣ
*
* Input          : pstuSM2Prams->uBits			           ģPλ
*                  pstuSM2Prams->stuCoefficientA	ԲϵA
*                  pstuSM2Prams->stuCoefficientA	ԲϵB
*                  pstuSM2Prams->stuGx			           ԲGx
*                  pstuSM2Prams->stuGy			           ԲGy
*                  pstuSM2Prams->stuPrimeN		           ԲGĽ
*                  pstuPrivKey		                                           ɵ˽Կ
*                  pstuPbuKey					           ɵĹԿ
* Output         : None
* Return         : 1 - ԿԲȷ
*                  0 - ԿԲʧ
******************************************************************************/
extern char SM2GenerateKeyPair(SM2_STU_PRAMS *pstuSM2Prams, ECC_STU_BIGINT32 *pstuPrivKey,SM2_STU_PUBKEY *pstuPbuKey);

/*******************************************************************************
* Function Name  : SM2Encrypt_V2
* Description    : ʹùԿļܣĳ = ĳ + 96ֽ
*                  SM2Encrypt_V2ʹùԿļܣĴ洢ʽΪC1|C3|C2
*
*                 ע
*                 1.ڲʹEDMACҪEDMACģʱӣ
*                 2.ڲʹSHAģ飬ҪSHAģʱӣ
*                 3.ڲʹCRYPTOģ飬ҪCRYPTOģʱӣ
*
* Input          : mes	ģֽں󣬵ֽǰ˽ṹmes[0]Ϊֽڣһֽڲ32λڸֽڵĩβ0ֱ32λ;
*                       mesΪ48bit123456789abcmes[0]Ϊ0x12345678mes[1]Ϊ0x9abc0000
*                  klen       		ֽڳ
*                  pstuPubKey		Կ
*                  pstuEccPrams   	Բ߲
*                  cipher		          ģ洢ʽͬ
* Output         : None
* Return         : None
******************************************************************************/
extern void SM2Encrypt_V2(unsigned char *mes, unsigned short klen, SM2_STU_PUBKEY *pstuPubKey,SM2_STU_PRAMS *pstuEccPrams, unsigned char *cipher);

/*******************************************************************************
* Function Name  : SM2Decrypt_V2
* Description    : ʹ˽ԿĽ
*                  SM2Decrypt_V2ʹ˽ԿԴ洢ʽΪC1|C3|C2Ľнܣ
*
*                 ע
*                 1.ڲʹEDMACҪEDMACģʱӣ
*                 2.ڲʹSHAģ飬ҪSHAģʱӣ
*                 3.ڲʹCRYPTOģ飬ҪCRYPTOģʱӣ
*                 4.ԭ⣺ʹ˽ԿԴ洢ʽΪC1|C3|C2Ľн
*
* Input          : cipher		  	 ģ˽ṹ
*                  klen         	 ֽڳ
*                  stuPrivKey		 ˽Կ
*                  pstuEccPrams     Բ߲
*                  plain		           ģ˽ṹ
* Output         : None
* Return         : 1 - ɹ
*                  0 - ʧ
******************************************************************************/
extern uint8_t SM2Decrypt_V2(unsigned char *cipher, unsigned short klen, ECC_STU_BIGINT32 *stuPrivKey, SM2_STU_PRAMS *pstuEccPrams, unsigned char *plain);

/*******************************************************************************
* Function Name  : SM2Signature
* Description    : ʹ˽ԿĽǩ
*
*                 ע
*                 1.˺ڲʹģ飬Ҫģʱ;
*                 2.˺ڲʹEDAMCģ飬Ҫģʱ;
*                 3.˺ڲʹCRYPTOģ飬Ҫģʱ;
*
* Input          : mes				  
*                  klen			             ֽڳ
*                  pstuEccPrams	             Բ߲
*                  pstuPubKey		  Կ
*                  pSignatureR	             ĵǩϢR
*                  pSignatureS	             ĵǩϢS
* Output         : None
* Return         : None
******************************************************************************/
extern void SM2Signature(unsigned char *mes, unsigned short klen, SM2_STU_PRAMS *pstuEccPrams, ECC_STU_BIGINT32 *pstuPrivKey, ECC_STU_BIGINT32 *pSignatureR, ECC_STU_BIGINT32 *pSignatureS);

/*******************************************************************************
* Function Name  : SM2SignatureWithIDA
* Description    : ʹ˽ԿϢĽǩ
*
*                 ע
*                 1.˺ڲʹģ飬Ҫģʱ;
*                 2.˺ڲʹSHAģ飬Ҫģʱ;
*                 3.˺ڲʹEDMACģ飬Ҫģʱ;
*                 4.˺ڲʹCRYPTOģ飬Ҫģʱ;
*
* Input          : mes				  
*                  klen			             ֽڳ
*                  IDA				  ǩϢ
*                  entla		             ǩϢֽڳ
*                  pstuEccPrams	             Բ߲
*                  pstuPubKey		  Կ
*                  pstuPrivKey	             ˽Կ
*                  pSignatureR	             ĵǩϢR
*                  pSignatureS	             ĵǩϢS
* Output         : None
* Return         : None
******************************************************************************/
extern void SM2SignatureWithIDA(unsigned char *mes, unsigned short klen, unsigned char *IDA, unsigned short entla, SM2_STU_PRAMS *pstuEccPrams, SM2_STU_PUBKEY *pstuPubKey, ECC_STU_BIGINT32 *pstuPrivKey, ECC_STU_BIGINT32 *pSignatureR,ECC_STU_BIGINT32 *pSignatureS);

/*******************************************************************************
* Function Name  : SM2Verification
* Description    : ʹùԿĺǩ֤
*
*                 ע
*                 1.˺ڲʹEDAMCģ飬Ҫģʱ;
*                 2.˺ڲʹCRYPTOģ飬Ҫģʱ;
*
* Input          : mes				    
*                  klen				    ֽڳ
*                  IDA			              ǩϢ
*                  entla			   ǩϢֽڳȣעԭΪǩϢbitȣ
*                  pstuEccPrams		   Բ߲
*                  pstuPubKey		   Կ
*                  pSignatureR		   ĵǩϢR
*                  pSignatureS		   ĵǩϢS
* Output         : None
* Return         : 1 - ֤ͨ
*                  0 - ֤ʧ
******************************************************************************/
extern uint8_t SM2Verification(unsigned char *mes, unsigned short klen, SM2_STU_PRAMS *pstuEccPrams, SM2_STU_PUBKEY *pstuPubKey, ECC_STU_BIGINT32 *pSignatureR, ECC_STU_BIGINT32 *pSignatureS);

/*******************************************************************************
* Function Name  : SM2VerificationWithIDA
* Description    : ʹùԿϢĺǩ֤
*
*                 ע
*                 1.˺ڲʹCRYPTOģ飬Ҫģʱ;
*                 2.˺ڲʹSHAģ飬Ҫģʱ;
*                 3.˺ڲʹEDMACģ飬Ҫģʱ;
*                 4.˺ڲʹCRYPTOģ飬Ҫģʱ;
*
* Input          : mes				    
*                  klen				    ֽڳ
*                  IDA			              ǩϢ
*                  entla			   ǩϢֽڳȣעԭΪǩϢbitȣ
*                  pstuEccPrams		   Բ߲
*                  pstuPubKey		   Կ
*                  pSignatureR		   ĵǩϢR
*                  pSignatureS		   ĵǩϢS
* Output         : None
* Return         : 1 - ֤ͨ
*                  0 - ֤ʧ
******************************************************************************/
extern uint8_t SM2VerificationWithIDA(unsigned char *mes, unsigned short klen, unsigned char *IDA, unsigned short entla, SM2_STU_PRAMS *pstuEccPrams, SM2_STU_PUBKEY *pstuPubKey, ECC_STU_BIGINT32 *pSignatureR, ECC_STU_BIGINT32 *pSignatureS);

/*******************************************************************************
* Function Name  : sign
* Description    : ûϢ
*
*                 ע
*                 1.˺ڲʹSHASM3ģ飬Ҫģʱ;
*                 2.˺ڲʹEDMACģ飬Ҫģʱ;
*
* Input          : IDA				           ǩϢ
*                  Entla                ǩϢֽڳȣעԭΪǩϢbitȣ
*                  pstuPubKey			Կ
*                  pstuEccPrams		          Բ߲
*                  za				          ûϢ
* Output         : None
* Return         : None
******************************************************************************/
extern void sign(unsigned char *IDA, unsigned short entla, SM2_STU_PUBKEY *pstuPubKey, SM2_STU_PRAMS *pstuEccPrams, unsigned int *za);

/*******************************************************************************
* Function Name  : SM2KeyExchange
* Description    : ûAûBԿ
*
*                 ע
*                 1.˺ڲʹSHASM3ģ飬Ҫģʱ;
*                 2.˺ڲʹEDMACģ飬Ҫģʱ;
*                 3.˺ڲʹCRYPTOģ飬Ҫģʱ;
*
* Input          : pstuEccPrams			Բ߲
*                  pSelfPrikey			ѷ˽Կ
*                  pSelfTempPubkey		ѷʱԿ
*                  pSelfTempPrikey		ѷʱ˽Կ
*                  pOtherPubkey			ԷԿ
*                  pOtherTempPubkey		ԷʱԿ
*                  za				          ѷZֵ
*                  zb					ԷZֵ
*                  pAgreedKey			ЭԿ
*                  AgreedKeyLen			ЭԿ
*                  sA					SAS2
*                  sB					SBS1
*                  Mode					0ʾѷΪA1ʾѷΪB
*
* Output         : None
* Return         : 1 - ֤ͨ
*                  0 - ֤ʧ
******************************************************************************/
extern uint8_t SM2KeyExchange(SM2_STU_PRAMS *pstuEccPrams, ECC_STU_BIGINT32 *pSelfPrikey, SM2_STU_PUBKEY *pSelfTempPubkey, ECC_STU_BIGINT32 *pSelfTempPrikey, SM2_STU_PUBKEY*pOtherPubkey,
		SM2_STU_PUBKEY *pOtherTempPubkey, uint32_t *za, uint32_t *zb, uint32_t *pAgreedKey, uint32_t AgreedKeyLen, uint32_t *sA, uint32_t *sB, uint32_t Mode);

/*******************************************************************************
* Function Name  : EccBig32Initial
* Description    : ĳʼֵȫֵΪ0鳤ȼΪ1
*
*
* Input          : None
*
* Output         : pstuA            ָṹECC_STU_BIGINTָ룬ʼpstuA
* Return         : None
******************************************************************************/
extern void EccBig32Initial(ECC_STU_BIGINT32 *pstuA);

/*******************************************************************************
* Function Name  : EccCharToHex
* Description    : ַתΪHexʽ
*
*
* Input          : pChar            ָҪתַݴ洢ַ
*                  uLen             תݵĳȣpCharݵֽ
* Output         : pHex             ָתHexʽݵĴ洢ַ
* Return         : None
******************************************************************************/
extern void EccCharToHex(uint8_t *pChar, uint8_t *pHex, uint16_t uLen);

/*******************************************************************************
* Function Name  : EccByBufToBigInt32
* Description    : ޷8λתΪṹECC_STU_BIGINT32Ĵʽ
*                  磺Ϊ8ݣ
*                             pbyOutBuf[0]=0x55;
*							  pbyOutBuf[1]=0x66;
*							  pbyOutBuf[2]=0x77;
*							  pbyOutBuf[3]=0x88;
*                             pbyOutBuf[4]=0x11;
*							  pbyOutBuf[5]=0x22;
*							  pbyOutBuf[6]=0x33;
*							  pbyOutBuf[7]=0x44;
*                        תΪ Ϊ2Ĵ 
*                             pstuInBigInt->auValue[0]=0x11223344;
*  				              pstuInBigInt->auValue[1]=0x55667788;
*
* Input          : pbyInBuf         ָ޷8λַ׵ַ
*                  uInLen           ޷8λַĳ
* Output         : pstuOutBigInt    ָṹECC_STU_BIGINT32ĵַתĶӦ
* Return         : None
******************************************************************************/
void EccByBufToBigInt32(uint8_t *pbyInBuf,uint16_t uInLen, ECC_STU_BIGINT32 *pstuOutBigInt);

/*******************************************************************************
* Function Name  : TestKeyChange
* Description    : SM2ԿԺ
*
* Input          : pstuPrivKey_A      ˽Կ
*                  pstuPubKey_A       Կ
*                  pstuPrivKey_B      Է˽Կ
*                  pstuPubKey_B       ԷԿ
*                  pstuEccPrams       ECC
*                  za                 zֵ
*                  zb                 Էzֵ
*
* Output         : None
* Return         : 1 - ɹ
*                  0 - ʧ
******************************************************************************/
uint8_t TestKeyChange(ECC_STU_BIGINT32 *pstuPrivKey_A,SM2_STU_PUBKEY *pstuPubKey_A,ECC_STU_BIGINT32 *pstuPrivKey_B,SM2_STU_PUBKEY *pstuPubKey_B,SM2_STU_PRAMS *pstuEccPrams,unsigned int *za,unsigned int *zb);

/*******************************************************************************
* Function Name  : AB_Check
* Description    : û֮
*
* Input          : s1
*                  sB
*                  sA
*                  s2
*                  pstuEccPrams     Ecc
*
* Output         : None
* Return         : 1 - ɹ
*                  0 - ʧ
******************************************************************************/
extern uint8_t AB_Check(uint32_t *s1, uint32_t *sB, uint32_t *sA, uint32_t *s2, SM2_STU_PRAMS *pstuEccPrams);

/*******************************************************************************
* Function Name  : SM2VerifySA
* Description    : USER_B verification USER_A
*
* Input          : s2
*                  sA
*                  pstuEccPrams     Ecc
*
* Output         : None
* Return         : 1 - ɹ
*                  0 - ʧ
******************************************************************************/
extern uint8_t SM2VerifySA(uint32_t *s2, uint32_t *sA, SM2_STU_PRAMS *pstuEccPrams);

/*******************************************************************************
* Function Name  : SM2GenerateKA
* Description    : USER_A verification USER_B , then Send choice(SA) to USER_B
*
* Input          : pstuEccPrams
*                  pstuPubKey_B
*                  pstuPrivKey_A
*                  za
*                  zb
*                  rA
*                  sB
*                  sA
*                  RA_x1
*                  RA_y1
*                  RB_x2
*                  RB_y2
*                  kA
*
* Output         : None
* Return         : 1 - ɹ
*                  0 - ʧ
******************************************************************************/
extern uint8_t SM2GenerateKA(SM2_STU_PRAMS *pstuEccPrams, SM2_STU_PUBKEY *pstuPubKey_B, ECC_STU_BIGINT32 *pstuPrivKey_A, uint32_t *za, uint32_t *zb,
		ECC_STU_BIGINT32 *rA, uint32_t *sB, uint32_t *sA, ECC_STU_BIGINT32 *RA_x1, ECC_STU_BIGINT32 *RA_y1, ECC_STU_BIGINT32 *RB_x2, ECC_STU_BIGINT32 *RB_y2, uint32_t *kA);

/*******************************************************************************
* Function Name  : SM2GenerateRBKB
* Description    : USER_B response USER_A, then Send RB and choice(SB) to USER_A
*
* Input          : pstuEccPrams
*                  pstuPubKey_A
*                  pstuPrivKey_B
*                  sB
*                  s2
*                  za
*                  zb
*                  RA_x1
*                  RA_y1
*                  RB_x2
*                  RB_y2
*                  kB
*
* Output         : None
* Return         : None
******************************************************************************/
extern void SM2GenerateRBKB(SM2_STU_PRAMS *pstuEccPrams, SM2_STU_PUBKEY *pstuPubKey_A, ECC_STU_BIGINT32 *pstuPrivKey_B, uint32_t *sB, uint32_t *s2, uint32_t *za, uint32_t *zb,
		ECC_STU_BIGINT32 *RA_x1, ECC_STU_BIGINT32 *RA_y1, ECC_STU_BIGINT32 *RB_x2, ECC_STU_BIGINT32 *RB_y2, uint32_t *kB);

/*******************************************************************************
* Function Name  : SM2GenerateRBKB
* Description    : USER_B response USER_A, then Send RB and choice(SB) to USER_A
*
* Input          : pstuEccPrams
*                  RA_x1
*                  RA_y1
*                  rA
*
* Output         : None
* Return         : None
******************************************************************************/
extern void SM2GenerateRA(SM2_STU_PRAMS *pstuEccPrams, ECC_STU_BIGINT32 *RA_x1, ECC_STU_BIGINT32 *RA_y1, ECC_STU_BIGINT32 *rA);

/*******************************************************************************
* Function Name  : RsaModuleEnable
* Description    : ʹRSAģ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
extern void RsaModuleEnable(void);

/*******************************************************************************
* Function Name  : RsaModuleDisable
* Description    : RSAģ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
extern void RsaModuleDisable(void);

/*******************************************************************************
* Function Name  : RsaGenerateKeyPair
* Description    : RSA Կ
* Input          : mode       RSA㷨λӦдֵΪ10242048ȡ
*                  fixkey     Կʽ
*                      0 - Կ̶
*                      1 - Կ̶Ϊ0x10001
*                      2 - Կⲿ
*                  crt        RSAԿʽ
*                      0 - ԿʽΪͨʽ
*                      1 - ԿʽΪCRTʽ
* Output         : pub_key    Կַ
*                  prv_key    ˽Կַ
* Return         : 0 - ɹ
*                  1 - ʧ
******************************************************************************/
extern unsigned char RsaGenerateKeyPair( unsigned int mode, STU_RSA_PUBKEY * pub_key, STU_RSA_PRIVKEY * prv_key,unsigned char fixkey, unsigned char crt);

/*******************************************************************************
* Function Name  : RsaPubKey
* Description    : RSA Կ
* Input          : input        ݵַ
*                  inputLen     ݳ
*                  publicKey    RSAԿַ
*
* Output         : output       ݵַ
*                  outputLen    ݳ

* Return         : 0   - ɹ
*                  0 - ʧ(0x0401)
******************************************************************************/
extern int RsaPubKey(unsigned int *output, unsigned int *outputLen, unsigned int *input, unsigned int  inputLen, STU_RSA_PUBKEY *publicKey);

/*******************************************************************************
* Function Name  : RsaPubKey
* Description    : RSA Կ
* Input          : input        ݵַ
*                  inputLen     ݳ
*                  privateKey   RSA˽Կַ
*
* Output         : output       ݵַ
*                  outputLen    ݳ

* Return         : 0   - ɹ
*                  0 - ʧ(0x0401)
******************************************************************************/
extern int RsaPrivKey(unsigned int *output, unsigned int *outputLen, unsigned int *input, unsigned int inputLen, STU_RSA_PRIVKEY * privateKey, ...);

/*******************************************************************************
* Function Name  : RsaPubKey
* Description    : RSA Կ
* Input          : input         ݵַ
*                  inputLen      ݳ
*                  pprivateKey   RSA˽ԿַԿʽΪCRTʽ
*
* Output         : output        ݵַ
*                  outputLen     ݳ

* Return         : 0   - ɹ
*                  0 - ʧ(0x0401)
******************************************************************************/
extern int RsaPrivKeyCRT(unsigned int *output, unsigned int *outputLen, unsigned int *input, unsigned int inputLen, STU_RSA_PRIVKEY * pprivateKey);

/****************************************************************************** 
***                            ΪӦõýӿ,ûԵ             ****
*******************************************************************************/

//㷨ķȼȼ
typedef enum {
    dpa_middle,	//еȷȼ
    dpa_high,	//߷ȼ
    dpa_low,	//ͷȼ
    dpa_disable,//ûз
}dpa_level_t;


#define SUCCESS_ALG			1
#define FAIL_ALG					0
#define ERROR_DATA_LENGTH	-1
#define ERROR_KEY_LENGTH	-2
#define ERROR_KEY_MODE		-3
#define ERROR_ENDE_MODE		-4
#define ERROR_ECBCBC_MODE		-5
#define ERROR_DATA_BUF		-6
#define ERROR_OTHER_PARA	-7

/*******************************************************************************
* Function Name  : Get_AlgLib_Version
* Description    : 㷨汾
* Input          : -NONE
* Output         : -version:㷨汾
* Return         : return 1: success, 0: fail
******************************************************************************/
extern int Get_AlgLib_Version(uint8_t*version);

/*******************************************************************************
* Function Name  : des_dpa_ctrl
* Description    : DES
* Input          : -levelȼmiddle high low disable
* Output         : None
* Return         : return 1: success, 0: fail
******************************************************************************/
extern int des_dpa_ctrl(dpa_level_t level);

/*******************************************************************************
* Function Name  : des_dpa_ctrl
* Description    : DES
* Input          : -levelȼmiddle high low disable
* Output         : None
* Return         : return 1: success, 0: fail
******************************************************************************/
extern int aes_dpa_ctrl(dpa_level_t level);

/*******************************************************************************
* Function Name  : des_dpa_ctrl
* Description    : DES
* Input          : -levelȼmiddle high low disable
* Output         : None
* Return         : return 1: success, 0: fail
******************************************************************************/
extern int sm4_dpa_ctrl(dpa_level_t level);

/*******************************************************************************
* Function Name  : AES_EnDecrypt_2
* Description    : AESӽ
* 				         ע⣺
* 				    None
* Input          : -EncDe_Mode      ӽģʽ
* 				   -CBC_ECB_MODE    ECB  CBCģʽ
* 				   -key             :Կ
* 				   -cbc_iv          :CBCʼ
* 				   -key_mode        Կģʽ
* 				   -src_buf         :Դbuf
* 				   -data_len        :Դݳ
* Output         : -out_buf         :buf
*
* Return         : 
******************************************************************************/
extern int AES_EnDecrypt_2(uint8_t EncDe_Mode, 
													 uint8_t CTR_ECB_MODE,uint8_t *key, 
													uint8_t *ctr_iv,
													uint32_t key_mode, 
													uint8_t *src_buf, 
													uint8_t *out_buf, 
													uint32_t data_len);

/*******************************************************************************
* Function Name  : DES_EnDecrypt_2
* Description    : DESӽ
* 				         ע⣺
* 				    None
* Input          : -EncDe_Mode      ӽģʽ
* 				   -CBC_ECB_MODE    ECB  CBCģʽ
* 				   -key             :Կ
* 				   -key_len         :Կ
* 				   -iv              ʼ
* 				   -src_buf         :Դbuf
* 				   -data_len        :Դݳ
* 				   -check_parity    :keyǷҪУ飬У򷵻keyУټӽ
* Output         : -out_buf         :buf
*
* Return         : 
******************************************************************************/
extern int DES_EnDecrypt_2(uint8_t EncDe_Mode, 
													 uint8_t ECB_CBC_Mode, 
													 uint8_t *key, 
													 uint32_t key_len, 
													 uint8_t *iv, 
													 uint8_t *src_buf, 
													 uint8_t *out_buf,
													 uint32_t data_len, 
													 uint8_t check_parity);

/*******************************************************************************
* Function Name  : SMS4_EnDecrypt_2
* Description    : SMS4ӽ
* 				         ע⣺
* 				    None
* Input          : -EncDe_Mode      ӽģʽ
* 				   -CBC_ECB_MODE    ECB  CBCģʽ
* 				   -key             :Կ
* 				   -iv              ʼ
* 				   -src_buf         :Դbuf
* 				   -data_len        :ݳ
* Output         : -out_buf         :buf
*
* Return         : 
******************************************************************************/
extern int SMS4_EnDecrypt_2(uint8_t EncDe_Mode,
														uint8_t ECB_CBC_Mode,
														uint8_t *key,
														uint8_t *iv,
														uint8_t *src_buf,
														uint8_t *out_buf,
														uint32_t data_len);

/*******************************************************************************
* Function Name  : SHA_Init_2
* Description    : HASHʼ
* 				         ע⣺
* 				    None
* Input          : -phash_tx        ϣ㷨ݽṹģʽ
* 				   -HashModeNum    ϣ㷨ţȡֵΧ0~4
* Output         : None
* Return         : 
******************************************************************************/
extern int SHA_Init_2(Hash_tx *phash_tx, unsigned char HashModeNum);

/*******************************************************************************
* Function Name  : SHA_Update_2
* Description    : ҪHASH
* 				         ע⣺
* 				    None
* Input          : -phash_tx         ϣ㷨ݽṹģʽ
* 				   -pMessageBlock    Ϣ
* 				   -DataLen          Ϣ鳤
* Output         : None
* Return         : ִн
******************************************************************************/
extern int SHA_Update_2(Hash_tx *phash_tx, unsigned char *pMessageBlock, unsigned int DataLen);

/*******************************************************************************
* Function Name  : SHA_Final_2
* Description    :  HASHȡ
* 				         ע⣺
* 				    None
* Input          : -phash_tx         ϣ㷨ݽṹģʽ
* Output         : -pRes             HASH
* Return         : ִн
******************************************************************************/
extern int SHA_Final_2(Hash_tx *phash_tx, unsigned char *pRes);

/*******************************************************************************
* Function Name  : SM2Init
* Description    : SM2ģʼ
* Input          : testbits  SM2λ
* Output         : None
* Return         : None
******************************************************************************/
extern int SM2Init(uint16_t testbits);

/*******************************************************************************
* Function Name  : SM2GenerateKeyPair_2
* Description    : SM2Կ
* Input          : None
* Output         : -pub_key         Կ
*                  -pri_key         ˽Կ
* Return         : 
******************************************************************************/
extern int SM2GenerateKeyPair_2(uint8_t *pub_key,uint8_t *pri_key);

/*******************************************************************************
* Function Name  : SM2Encrypt_2
* Description    : SM2
* Input          : -mes             
*                  -len             :ĳ
*                  -pub_key         :Կ
* Output         : -cipher          
* Return         : 
******************************************************************************/
extern int SM2Encrypt_2(uint8_t *mes,uint16_t len,uint8_t *pub_key,uint8_t *cipher);

/*******************************************************************************
* Function Name  : SM2Decrypt_2
* Description    : SM2
* Input          : -cipher          
*                  -len             :ĳ
*                  -pri_key         :˽Կ
* Output         : -mes             
* Return         : 
******************************************************************************/
extern int SM2Decrypt_2(uint8_t *cipher,uint16_t len,uint8_t *pri_key,uint8_t *mes);

/*******************************************************************************
* Function Name  : SM2Signature_2
* Description    : SM2ǩ
* Input          : -mes             
*                  -len             :ĳ
*                  -pri_key         :˽Կ
* Output         : -r               ǩֵR
*                  -s               :ǩֵS
* Return         : 
******************************************************************************/
extern int SM2Signature_2(uint8_t *mes,uint16_t len,uint8_t *pri_key,uint8_t *r,uint8_t *s);

/*******************************************************************************
* Function Name  : SM2Verification_2
* Description    : SM2ǩ
* Input          : -mes             
*                  -len             :ĳ
*                  -pri_key         :˽Կ
*                  -r               ǩֵR
*                  -s               :ǩֵS
* Output         : None
* Return         : ǩ
******************************************************************************/
extern int SM2Verification_2(uint8_t *mes,uint16_t len,uint8_t *pub_key,uint8_t *r,uint8_t *s);

/*******************************************************************************
* Function Name  : SM2GenerateE_2
* Description    : SM2Eֵ
* Input          : -IDA             ûID
*                  -ida_len         :ûID
*                  -pub_key         :Կ
*                  -pMessage        Ϣ
*                  -mesLen          :Ϣ
* Output         : -res_E           :Eֵ
* Return         : ִн
******************************************************************************/
extern int SM2GenerateE_2(uint8_t *IDA,uint16_t ida_len,uint8_t *pub_key,uint8_t *pMessage,uint32_t mesLen,uint8_t *res_E);

/*******************************************************************************
* Function Name  : SM2KeyExchange_2
* Description    : SM2Կ
* Input          : -self_pri        ˽Կ
*                  -self_temp_pub   :ʱԿ
*                  -self_temp_pri   :ʱ˽Կ
*                  -other_pub       ԷԿ
*                  -other_temp_pub  :ԷʱԿ
*                  -za              Zֵ
*                  -zb              :ԷZֵ
*                  -AgreedKeyLen    ЭԿĳ
*                  -Mode			Կ𷽡0ʾѷΪA1ʾѷΪB
* Output         : -agree_key       :ЭԿ
*                  -sA              Sֵ
*                  -sB              :ԷSֵ
* Return         : 
******************************************************************************/
extern int SM2KeyExchange_2(uint8_t*self_pri,
														uint8_t*self_temp_pub,
														uint8_t *self_temp_pri,
														uint8_t*other_pub,
														uint8_t*other_temp_pub,
														uint8_t*za,
														uint8_t*zb,
														uint8_t*agree_key,
														uint32_t AgreedKeyLen,
														uint8_t*sA,
														uint8_t*sB,
														uint32_t Mode);

/*******************************************************************************
* Function Name  : sign_2
* Description    : SM2Zֵ
* Input          : -IDA             ûID
*                  -entla           :ûID
*                  -pub_key         :Կ
* Output         : -za              Zֵ
* Return         : ִн
******************************************************************************/
extern int sign_2(uint8_t *IDA, uint16_t entla, uint8_t *pub_key,uint8_t*za);

/*******************************************************************************
* Function Name  : rsa_keypair_gen
* Description    : RSAԿ
* Input          : -rsa_bit_len     RSA㷨λ
*                  -fixkey          :EֵǷ̶
* Output         : -n_addr          N
*                  -e_addr          :E
*                  -d_addr          :D
*                  -p_addr          :P
*                  -q_addr          :Q
*                  -dp_addr         :dP
*                  -dq_addr         :dQ
*                  -qinv_addr       :PQ
* Return         : ִн
******************************************************************************/
extern int rsa_keypair_gen(uint32_t rsa_bit_len, 
													 uint8_t fixkey, 
													 uint8_t* n_addr, 
													 uint8_t* e_addr, 
													 uint8_t *d_addr, 
													 uint8_t* p_addr, 
													 uint8_t* q_addr, 
													 uint8_t* dp_addr, 
													 uint8_t* dq_addr, 
													 uint8_t* qinv_addr);

/*******************************************************************************
* Function Name  : RsaPubKey_2
* Description    : RSAԿ
* Input          : -fixkey          :EֵǷ̶
*                  -n_addr          N
*                  -e_addr          :E
*                  -in              :
*                  -in_len          :ݳ
* Output         : -out             
*                  -out_len         ݳ
* Return         : ִн
******************************************************************************/
extern int RsaPubKey_2(uint8_t fixkey, 
											 uint8_t *n_addr,
											 uint8_t* e_addr, 
											 uint8_t *in,uint32_t in_len,
											 uint8_t *out,
											 uint32_t *out_len);

/*******************************************************************************
* Function Name  : RsaPrivKey_2
* Description    : RSA˽Կ
* Input          :-n_addr          N
*                 -d_addr          :D
*                  -in              :
*                  -in_len          :ݳ
* Output         : -out             
*                  -out_len         ݳ
* Return         : ִн
******************************************************************************/
extern int RsaPrivKey_2(uint8_t*n_addr,uint8_t *d_addr,uint8_t *in,uint32_t in_len,uint8_t *out,uint32_t *out_len);

/*******************************************************************************
* Function Name  : RsaPrivKey_3
* Description    : RSA˽Կ(DPA = High)
* Input          :-n_addr          N
*                 -d_addr          :D
*                  -in              :
*                  -in_len          :ݳ
* Output         : -out             
*                  -out_len         ݳ
* Return         : ִн
******************************************************************************/
extern int RsaPrivKey_3(uint8_t *n_addr,
												uint8_t *d_addr,
												uint8_t *e_addr,
												uint8_t *in,
												uint32_t in_len,
												uint8_t *out,
												uint32_t *out_len);

/*******************************************************************************
* Function Name  : RsaPrivKeyCRT_2
* Description    : RSA CRTģʽ
* Input          : -p_addr          :P
*                  -q_addr          :Q
*                  -dp_addr         :dP
*                  -dq_addr         :dQ
*                  -qinv_addr       :PQ
*                  -in              :
*                  -in_len          :ݳ
* Output         : -out             
*                  -out_len         :ݳ
* Return         : ִн
******************************************************************************/
extern int RsaPrivKeyCRT_2(uint8_t*p_addr,
													 uint8_t*q_addr,
													 uint8_t*dp_addr,
													 uint8_t*dq_addr,
													 uint8_t*qinv_addr,
													 uint8_t *in,
													 uint32_t in_len,
													 uint8_t *out,
													 uint32_t *out_len);

/*******************************************************************************
* Function Name  : GetRandomWord
* Description    : ɺ
* Input          : None
* Output         : None
* Return         : 1uint32_t
******************************************************************************/
uint32_t GetRandomWord(void);

/*******************************************************************************
* Function Name  : Get_Random_Word
* Description    : ɺ
* Input          : None
* Output         : None
* Return         : 1uint32_t
******************************************************************************/
uint32_t Get_Random_Word(void);

/*******************************************************************************
* Function Name  : Init_Trng
* Description    : ܳʼ
*                  ģʱӣģʱƵΪϵͳʱƵʵ1/8
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void Init_Trng(void);

/*******************************************************************************
* Function Name  : Trng_Disable
* Description    : رģʱ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void Trng_Disable(void);
#endif /* ALG_DRV_H_ */
