// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// File name    : crc_drv.c
// Version      : V0.1
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#include "crc_drv.h"


#define CRC           CRC1

/*******************************************************************************
* Function Name  : CRC_Config
* Description    : CRC.
* Input          :  - CRC_InitTypeDef : CRC_InitTypeDefṹָ룬£
*                    CRC_InitStruct->CRC_Mode:CRCģʽȡֵΪCRC_MODE_CRC_xxȡֵ8,16,32
*                    CRC_InitStruct->CRC_SourceSel: CRCԴѡȡֵCRC_SOURCE_SEL_FROM_DMACRC_SOURCE_SEL_FROM_CPU
*                    CRC_InitStruct->CRC_DataFormatCRCݸʽģʽСģʽCRC_MODE_CRC_32£Ч
*
*
* Output         : None
* Return         : None
*******************************************************************************/
void CRC_Config(CRC_InitTypeDef *CRC_InitStruct)
{
	if(CRC_InitStruct->CRC_Mode == CRC_MODE_CRC_32)
	{
		CRC->CRC_CR = ((CRC_InitStruct->CRC_Mode<<29) \
					  |(CRC_InitStruct->CRC_DataFormat<<26) \
					  |(CRC_InitStruct->CRC_SourceSel<<27));
	}
	else
	{
		CRC->CRC_CR = ((CRC_InitStruct->CRC_Mode<<29) \
					  |(CRC_InitStruct->CRC_SourceSel<<27));
	}

}

/*******************************************************************************
* Function Name  : CRC_SetInitValue
* Description    : CRCʼֵ
* Input          : - InitValue : õCRCʼֵ
*
* Output         : None
* Return         : None
*******************************************************************************/
void CRC_SetInitValue(uint32_t InitValue)
{
	CRC->CRC_IDR = InitValue;
	CRC->CRC_CR |= CRC_UPDATA_MASK;
}

/*******************************************************************************
* Function Name  : CRC_CalcCRC32
* Description    : CRC 32 
* Input          : - pBuffer : ҪCRCݻ
*                  - BufferLen : ҪCRCݻĳ
*
* Output         : CRC
* Return         : None
*******************************************************************************/
uint32_t CRC_CalcCRC32(uint8_t *pBuffer, uint32_t BufferLen)
{
	uint32_t i;
	uint32_t aSize = BufferLen;
	uint8_t *point = pBuffer;

	if(aSize%4 == 0)
	{
		for(i = 0; i < aSize; i = i+4)
		{
			CRC->CRC_DR =(*(point+i)<<24)|(*(point+i+1)<<16)|(*(point+i+2)<<8)|(*(point+i+3));  //ݵڴ֯ʽλڵ͵ַ
		}
	}
	else if(aSize%4 == 1)
	{
		for(i = 0; i < aSize-1; i = i+4)
		{
			CRC->CRC_DR =(*(point+i)<<24)|(*(point+i+1)<<16)|(*(point+i+2)<<8)|(*(point+i+3));
		}
		CRC->CRC_DR =(*(point+i)<<24);

	}
	else if(aSize%4 == 2)
	{
		for(i=0;i<aSize-2;i=i+4)
		{
			CRC->CRC_DR =(*(point+i)<<24)|(*(point+i+1)<<16)|(*(point+i+2)<<8)|(*(point+i+3));
		}
		CRC->CRC_DR =(*(point+i)<<24)|(*(point+i+1)<<16);
	}
	else
	{
		for(i = 0; i < aSize-3; i = i+4)
		{
			CRC->CRC_DR =(*(point+i)<<24)|(*(point+i+1)<<16)|(*(point+i+2)<<8)|(*(point+i+3));
		}
		CRC->CRC_DR =(*(point+i)<<24)|(*(point+i+1)<<16)|(*(point+i+2)<<8);
	}

	return (CRC->CRC_RR);
}


/*******************************************************************************
* Function Name  : CRC_CalcCRC16
* Description    : CRC 16 
* Input          : - pBuffer : ҪCRCݻ
*                  - BufferLen : ҪCRCݻĳ
*
* Output         : CRC
* Return         : None
*******************************************************************************/
uint16_t CRC_CalcCRC16(uint8_t *pBuffer, uint32_t BufferLen)
{
	uint32_t i;

	if(BufferLen%2 == 0)
	{
		for(i = 0; i < BufferLen; i = i+2)
		{
			CRC->CRC_DR = (*(pBuffer+i)<<8)|(*(pBuffer+i+1));
		}
	}
	else
	{
		for(i = 0; i < BufferLen-1; i = i+2)
		{
			CRC->CRC_DR =(*(pBuffer+i)<<24)|(*(pBuffer+i+1)<<16);
		}
		CRC->CRC_DR =(*(pBuffer+i)<<24);
	}
	return ((uint16_t)(CRC->CRC_RR));
}




/*******************************************************************************
* Function Name  : CRC_CalcCRC8
* Description    : CRC 8 
* Input          : - pBuffer : ҪCRCݻ
*                  - BufferLen : ҪCRCݻĳ
*
* Output         : CRC
* Return         : None
*******************************************************************************/
uint8_t CRC_CalcCRC8(uint8_t *pBuffer, uint32_t BufferLen)
{
	uint32_t i;

	for(i = 0; i < BufferLen; i++)
	{
		CRC->CRC_DR = *(pBuffer+i);
	}
	return ((uint8_t)(CRC->CRC_RR));
}

