// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// File name    : dmac_drv.c
// Version      : V0.1
//NOTE          :MCCʹDMAC1жϣʹMCCֻʹDMAC1ĲѯʽDMAC2ڸ
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#include "memmap.h"
#include "dmac_drv.h"
#include "spi_drv.h"
#include "debug.h"
#include "test_demo.h"

#ifdef MCC_DEMO
#include "mcc_drv.h"
#endif
#ifdef SSI_DEMO
#include "ssi_drv.h"
#endif
#ifdef DAC_DEMO
#include "dac_drv.h"
#endif

extern void MCC_DMA_ISR(void);

/*DMA channel base address*/
DMA_CHANNEL_REG *m_dma_channel[DMAC_CHNUM] = {(DMA_CHANNEL_REG *)(DMA1_BASE_ADDR        ),(DMA_CHANNEL_REG *)(DMA1_BASE_ADDR + 0x58 ),\
													  (DMA_CHANNEL_REG *)(DMA1_BASE_ADDR + 0xB0 ),(DMA_CHANNEL_REG *)(DMA1_BASE_ADDR + 0x108)};//global struct variable for for Channel registers
DMA_CHANNEL_REG *m_dma2_channel[DMAC_CHNUM] = {(DMA_CHANNEL_REG *)(DMA2_BASE_ADDR        ),(DMA_CHANNEL_REG *)(DMA2_BASE_ADDR + 0x58 ),\
													  (DMA_CHANNEL_REG *)(DMA2_BASE_ADDR + 0xB0 ),(DMA_CHANNEL_REG *)(DMA2_BASE_ADDR + 0x108)};//global struct variable for for Channel registers
													  
/*DMA config base address */
DMA_CONTROL_REG *m_dma_control = (DMA_CONTROL_REG*)(DMA1_BASE_ADDR+0x2C0);//global struct variable for for DMAC registers
DMA_CONTROL_REG *m_dma2_control = (DMA_CONTROL_REG*)(DMA2_BASE_ADDR+0x2C0);//global struct variable for for DMAC registers

//DMA_CHANNEL_REG *m_dma_channel[4];//global struct variable for for Channel registers
//DMA_CONTROL_REG *m_dma_control;//global struct variable for for DMAC registers
volatile uint32_t dma_isr_flag =0;
volatile uint32_t dma_isr_errflag = 0;
static DMA_LLI g_dma_lli_rx;
														
/*******************************************************************************
* Function Name  : DMA1_IRQHandler
* Description    : dma2жϴ
* Input          : None
*
* Output         : None
* Return         : None
******************************************************************************/
void DMA1_IRQHandler(void)
{
#ifdef MCC_DMA_INT
		MCC_DMA_ISR();
#endif
	
	//complet int
	if(m_dma_control->DMA_STATTFR & 0x0f)//dma done
	{
#ifdef SSI_DMA_INT
		SSI_DMA_ISR();
#endif
	}
	
	if(m_dma_control->DMA_STATERR & 0x0f)//dma error
	{
		dma_isr_errflag = m_dma_control->DMA_STATERR & 0x0f;
		m_dma_control->DMA_CLRERR = dma_isr_errflag;
	}
	
  m_dma_control->DMA_CLRTFR = m_dma_control->DMA_STATTFR;
	m_dma_control->DMA_CLRBLOCK=m_dma_control->DMA_STATBLOCK;
	m_dma_control->DMA_CLRSRC=m_dma_control->DMA_STATSRC;
	m_dma_control->DMA_CLRDST=m_dma_control->DMA_STATDST;
	m_dma_control->DMA_CLRERR=m_dma_control->DMA_STATERR;
}
//#endif														
/*******************************************************************************
* Function Name  : DMA2_IRQHandler
* Description    : dma2жϴ
* Input          : None
*
* Output         : None
* Return         : None
******************************************************************************/
#if (0)
    
void DMA2_IRQHandler(void)
{
	//complet int
	if(m_dma_control->DMA_STATTFR & 0x0f)//dma done
	{
#ifdef SSI_DMA_INT
		SSI_DMA_ISR();
#endif
		dma_isr_flag |= m_dma_control->DMA_STATTFR & 0x0f;
		m_dma_control->DMA_CLRTFR = dma_isr_flag;
#ifdef DAC_DMA_INT	
		DAC_DMA_ISR();
#endif
		
#ifdef DAC_AUDIO_DMA_INT	
		Audio_ISR();
#endif

	}

	if(m_dma_control->DMA_STATERR & 0x0f)//dma error
	{
		dma_isr_errflag = m_dma_control->DMA_STATERR & 0x0f;
		m_dma_control->DMA_CLRERR = dma_isr_errflag;
	}
	
  m_dma_control->DMA_CLRTFR = m_dma_control->DMA_STATTFR;
	m_dma_control->DMA_CLRBLOCK=m_dma_control->DMA_STATBLOCK;
	m_dma_control->DMA_CLRSRC=m_dma_control->DMA_STATSRC;
	m_dma_control->DMA_CLRDST=m_dma_control->DMA_STATDST;
	m_dma_control->DMA_CLRERR=m_dma_control->DMA_STATERR;
}
#endif


/*******************************************************************************
* Function Name  : DMA_REG_Init
* Description    : DMAĴʼ
* Input          : - dmac_base_addr: DMAַ
*
* Output         : None
* Return         : None
******************************************************************************/
void DMA_REG_Init(uint32_t dmac_base_addr)
{
	m_dma_control    = (DMA_CONTROL_REG*)(dmac_base_addr+0x2c0);
	m_dma_channel[0] = (DMA_CHANNEL_REG*)(dmac_base_addr);
	m_dma_channel[1] = (DMA_CHANNEL_REG*)(dmac_base_addr+0x58);
	m_dma_channel[2] = (DMA_CHANNEL_REG*)(dmac_base_addr+0xB0);
	m_dma_channel[3] = (DMA_CHANNEL_REG*)(dmac_base_addr+0x108);

	//m_dma_control->DMA_MASKBLOCK = 0xf0f;
	//interrupt_setup(0x24, isr_dma);
	m_dma_control->DMA_CONFIG = 0x01;
}

void DMA_ADC_Tran(uint8_t channel, uint32_t dest,uint32_t length)
{
	m_dma_control->DMA_CONFIG = 1;
	m_dma_channel[channel]->DMA_SADDR = 0x4002004c;
	m_dma_channel[channel]->DMA_DADDR = dest;
	m_dma_channel[channel]->DMA_CTRL = SNOCHG|DIEC|P2M_DMA|DWIDTH_W|SWIDTH_W;
	m_dma_channel[channel]->DMA_CTRL_HIGH = length;
	
	m_dma_channel[channel]->DMA_CFG = 0;
	m_dma_channel[channel]->DMA_CFG_HIGH = 6<<7;
	
	m_dma_control->DMA_MASKTFR = CHANNEL_UMASK(channel);
	m_dma_control->DMA_CHEN = CHANNEL_ENABLE(channel);
}

void DMA_DAC_Tran(uint8_t channel, uint32_t src,uint32_t length)
{
	//m_dma_control->DMA_CONFIG = 1;
	m_dma_channel[channel]->DMA_SADDR = src;
	m_dma_channel[channel]->DMA_DADDR = 0x40021004;
	m_dma_channel[channel]->DMA_CTRL = SIEC|DNOCHG|M2P_DMA|DWIDTH_B|SWIDTH_B|INTEN;
	m_dma_channel[channel]->DMA_CTRL_HIGH = length;
	
	m_dma_channel[channel]->DMA_CFG = 0;
	m_dma_channel[channel]->DMA_CFG_HIGH = DST_PER_DAC;
	
	m_dma_control->DMA_MASKTFR = CHANNEL_UMASK(channel);
	m_dma_control->DMA_CHEN = CHANNEL_WRITE_ENABLE(channel)|CHANNEL_ENABLE(channel);
}
void DMA_dis(uint8_t n)
{
	m_dma_channel[n]->DMA_CFG|=1<<8;
	m_dma_control->DMA_CHEN |=CHANNEL_WRITE_ENABLE(n);
	m_dma_control->DMA_CHEN &=~CHANNEL_ENABLE(n);
	m_dma_channel[n]->DMA_CFG&=~(1<<8);
	m_dma_control->DMA_CONFIG=~1;	
}
void dma_lli_reg_init(uint8_t n,DMA_LLI *dma_lli)
{
	m_dma_control->DMA_CONFIG = 1;
	
	m_dma_channel[n]->DMA_SADDR = dma_lli->src_addr;
	m_dma_channel[n]->DMA_DADDR = dma_lli->dst_addr;
	m_dma_channel[n]->DMA_LLP = (unsigned int)dma_lli;
	m_dma_channel[n]->DMA_CTRL = dma_lli->control0;
	m_dma_channel[n]->DMA_CTRL_HIGH =  dma_lli->len ;
	
	m_dma_channel[n]->DMA_CFG = 0;
	m_dma_channel[n]->DMA_CFG_HIGH = 8<<11;
	
	m_dma_control->DMA_MASKTFR = CHANNEL_UMASK(n);
	m_dma_control->DMA_CHEN =CHANNEL_WRITE_ENABLE(n)|CHANNEL_ENABLE(n);

}

/*******************************************************************************
* Function Name  : dma_m2mtran
* Description    : dmaͺ
* Input          : - channel: ͨ
*				   - width: ݿ
*				   - src  ʼַ
*				   - dest  Ŀĵַ
*				   - length  ݳ
*
* Output         : None
* Return         : FALSE - ʧ
*                  TRUE  - ɹ
******************************************************************************/
bool dma_m2mtran(uint8_t channel,uint8_t width,uint32_t src, uint32_t dest,uint32_t length)
{
	uint32_t bitwidth = 0;
	if(width == WIDTH_BYTE)
	{
		bitwidth = DWIDTH_B|SWIDTH_B;
	}
	else if(width == WIDTH_HALFWORD)
	{
		bitwidth = DWIDTH_HW|SWIDTH_HW;
		if(length & 1)
		{
			return FALSE;
		}
		length >>= 1;
	}
	else
	{
		bitwidth = DWIDTH_W|SWIDTH_W;
		if(length & 3)
		{
			return FALSE;
		}
		length >>= 2;
	}
	if(length > 0xFFF)
	{
		return FALSE;
	}
	m_dma_control->DMA_CONFIG = 1;

	m_dma_channel[channel]->DMA_SADDR = src;
	m_dma_channel[channel]->DMA_DADDR = dest;
	m_dma_channel[channel]->DMA_CTRL = DIEC|SIEC|bitwidth|DBSIZE_4|SBSIZE_4;
	m_dma_channel[channel]->DMA_CTRL_HIGH = (length&0x00000FFF) ;  //󳤶Ϊ0x0FFF

	//enable dma channel
	m_dma_control->DMA_MASKTFR = CHANNEL_UMASK(channel);
	m_dma_control->DMA_CHEN |= CHANNEL_WRITE_ENABLE(channel)|CHANNEL_ENABLE(channel);

	while((m_dma_control->DMA_RAWTFR & CHANNEL_STAT(channel)) != CHANNEL_STAT(channel));

	m_dma_control->DMA_CLRTFR = CHANNEL_STAT(channel);

	m_dma_control->DMA_CHEN = 0;
	m_dma_control->DMA_CONFIG = 0;

	return TRUE;
}

/*******************************************************************************
* Function Name  : dma_spitran
* Description    : spi dmaͺ
* Input          : - spiid: SPI ID
*				   - psend: ݵַ
*				   - precv ݵַ
*				   - length  ݳ
*				   - binten : Ƿжģʽ
*
* Output         : None
* Return         : None
******************************************************************************/
void dma_spitran(uint8_t spiid, uint8_t* psend, uint8_t* precv, uint32_t length, BOOL binten)
{
	binten = FALSE;
//	uint32_t addr;
	
	if(spiid > 2)
	{
		return;
	}

	m_dma_control->DMA_CONFIG = 1;
	//Tx
	m_dma_channel[DMACCH0]->DMA_SADDR = (uint32_t)psend;
	m_dma_channel[DMACCH0]->DMA_DADDR = SPI1_BASE_ADDR+(spiid<<12) + 0x12;
	if(binten == TRUE)
	{
		m_dma_channel[DMACCH0]->DMA_CTRL = INTEN|DNOCHG|SIEC|M2P_DMA;
	}
	else
	{
		m_dma_channel[DMACCH0]->DMA_CTRL = DNOCHG|SIEC|M2P_DMA;
	}
	m_dma_channel[DMACCH0]->DMA_CTRL_HIGH = length ;  //󳤶Ϊ0x0FFF
	m_dma_channel[DMACCH0]->DMA_CFG = (HS_SEL_SRC_SOFT);
	if(spiid == 2)
	{
		m_dma_channel[DMACCH0]->DMA_CFG_HIGH = DST_PER_SPI_TX(5);
	}
	else
	{
		m_dma_channel[DMACCH0]->DMA_CFG_HIGH = DST_PER_SPI_TX(spiid);
	}
	

	//Rx
	m_dma_channel[DMACCH1]->DMA_SADDR = SPI1_BASE_ADDR+(spiid<<12) + 0x12;
	m_dma_channel[DMACCH1]->DMA_DADDR = (uint32_t)precv;
	if(binten == TRUE)
	{
		m_dma_channel[DMACCH1]->DMA_CTRL = INTEN|SNOCHG|DIEC|P2M_DMA;
	}
	else
	{
		m_dma_channel[DMACCH1]->DMA_CTRL = SNOCHG|DIEC|P2M_DMA;
	}
	m_dma_channel[DMACCH1]->DMA_CTRL_HIGH = length ;  //󳤶Ϊ0x0FFF
	m_dma_channel[DMACCH1]->DMA_CFG = (HS_SEL_DST_SOFT);
	if(spiid == 2)
	{
		m_dma_channel[DMACCH1]->DMA_CFG_HIGH = SRC_PER_SPI_RX(4);
	}
	else
	{
		m_dma_channel[DMACCH1]->DMA_CFG_HIGH = SRC_PER_SPI_RX(spiid+3);
	}

	//enable dma channel
	m_dma_control->DMA_MASKTFR = CHANNEL_UMASK(DMACCH0)|CHANNEL_UMASK(DMACCH1);
	m_dma_control->DMA_CHEN = CHANNEL_WRITE_ENABLE(DMACCH0)|CHANNEL_ENABLE(DMACCH0)|CHANNEL_WRITE_ENABLE(DMACCH1)|CHANNEL_ENABLE(DMACCH1);
	if(binten == TRUE)
	{
		while(1)
		{
			if(dma_isr_flag == (CHANNEL_STAT(DMACCH0)|CHANNEL_STAT(DMACCH1)) )
			{
				dma_isr_flag = 0;
				break;
			}
		}
	}
	else
	{
		while((m_dma_control->DMA_RAWTFR & (CHANNEL_STAT(DMACCH0) | CHANNEL_STAT(DMACCH1))) != (CHANNEL_STAT(DMACCH0) | CHANNEL_STAT(DMACCH1)));

		m_dma_control->DMA_CLRTFR = (CHANNEL_STAT(DMACCH0) | CHANNEL_STAT(DMACCH1));

	}

	m_dma_control->DMA_CHEN = 0;
	m_dma_control->DMA_CONFIG = 0;
}

/*******************************************************************************
* Function Name  : dma_spi_LLIReceive
* Description    : spi dmaպ
* Input          : -n     dmaͨ
* 				   - spiid: SPI ID
*				   - precv ݵַ
*				   - length  ݳ
*
* Output         : None
* Return         : None
******************************************************************************/
void dma_spi_LLIReceive(DMA_CHANNEL n,uint8_t spiid, uint8_t *dest,uint32_t length)
{
	//init
	g_dma_lli_rx.src_addr = SPI1_BASE_ADDR+(spiid<<12) + 0x12;
	g_dma_lli_rx.dst_addr = (uint32_t)dest;
	g_dma_lli_rx.len = length;
#ifdef MCC_DMA_LLI_INT_EN
	g_dma_lli_rx.control0 = DMA_IE | SNC | DI | LLP_DST_EN | LLP_SRC_EN | P2M_DMA;
#else
	g_dma_lli_rx.control0 = SNC | DI | LLP_DST_EN | LLP_SRC_EN | P2M_DMA;
#endif
	g_dma_lli_rx.next_lli = (uint32_t)&g_dma_lli_rx;

	m_dma_control->DMA_CONFIG = DMACEN;

	m_dma_channel[n]->DMA_SADDR = g_dma_lli_rx.src_addr;
	m_dma_channel[n]->DMA_DADDR = g_dma_lli_rx.dst_addr;

	m_dma_channel[n]->DMA_CTRL =  g_dma_lli_rx.control0;
	m_dma_channel[n]->DMA_CTRL_HIGH = g_dma_lli_rx.len;

	m_dma_channel[n]->DMA_LLP = (uint32_t)&g_dma_lli_rx;//++

	m_dma_channel[n]->DMA_CFG &= HS_SEL_DST_SOFT;
	m_dma_channel[n]->DMA_CFG_HIGH = SRC_PER_SPI_RX(spiid);

#ifdef MCC_DMA_LLI_INT_EN
	m_dma_control->DMA_MASKBLOCK |=  CHANNEL_UMASK(n);
#endif
	m_dma_control->DMA_MASKTFR |= CHANNEL_UMASK(n);
	m_dma_control->DMA_CHEN |= CHANNEL_WRITE_ENABLE(n)|CHANNEL_ENABLE(n);//DMA enable
}

/*******************************************************************************
* Function Name  : dma_channle_stop
* Description    : ֹͣDMAͨ
* Input          : -n     dmaͨ
*
* Output         : None
* Return         : None
******************************************************************************/
void dma_channle_stop(DMA_CHANNEL n)
{
	/*suspend channel*/
	m_dma_channel[n]->DMA_CFG |= (1<<8);
	/*waite FIFO empty*/
	while(((m_dma_channel[n]->DMA_CFG) & (1 << 9)) == 0);
	/*disable channel*/
	m_dma_control->DMA_CHEN =(( m_dma_control->DMA_CHEN|CHANNEL_WRITE_ENABLE(n))&(~CHANNEL_ENABLE(n)));
	/*clear suspend channel*/
	m_dma_channel[n]->DMA_CFG &= ~(1<<8);
}

/*******************************************************************************
* Function Name  : dma_getLength
* Description    : ȡDMAݳ
* Input          : -n     dmaͨ
*
* Output         : None
* Return         : ǰݳ
******************************************************************************/
uint32_t  dma_getLength(DMA_CHANNEL n)
{
	uint32_t addr;

	addr = m_dma_channel[n]->DMA_DADDR;

	return (addr - g_dma_lli_rx.dst_addr);
}


static void dma_reg_init(uint32_t dma_base_addr)
{
	uint8_t n = 0;
	uint32_t ch_addr[4] = {0x0000, 0x0058, 0x00b0, 0x0108};

	m_dma_control = (DMA_CONTROL_REG*)(dma_base_addr+0x2c0);

	for(n =0; n<4; n++)
	{
		m_dma_channel[n] = (DMA_CHANNEL_REG*)(dma_base_addr+ch_addr[n]);
	}
}

/*******************************************************************************
* Function Name  : DMA_Init
* Description    : DMAʼ
* Input          : uint32_t dma_base_addr 
*
* Output         : None
* Return         : None
******************************************************************************/
void DMA_Init(uint32_t dma_base_addr)
{
	dma_reg_init(dma_base_addr);
	//NVIC_Init(3, 3, DMA1_IRQn, 2);//ڴdmaж
}

