// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// File name    : dmac_drv.h
// Version      : V0.1
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#ifndef __DMAC_DRV_H__
#define __DMAC_DRV_H__

#include "type.h"
#include "dmac_reg.h"

#define DMAC_HWNUM				(1)
#define DMAC_CHNUM				(4)

#define DMACCH0					(0)
#define DMACCH1					(1)
#define DMACCH2					(2)
#define DMACCH3					(3)

enum
{
	WIDTH_BYTE = 0,
	WIDTH_HALFWORD,
	WIDTH_WORD,
};

typedef enum
{
	dma_channel_1 = 0,
	dma_channel_2,
	dma_channel_3,
	dma_channel_4 ,
}DMA_CHANNEL;

#define CHANNEL_UMASK(n)         (((1<<n)<<8) | (1<<n))
#define CHANNEL_WRITE_ENABLE(n)  ((1<<n)<<8)
#define CHANNEL_ENABLE(n)        (1<<n)
#define CHANNEL_STAT(n)          (1<<n)

extern DMA_CHANNEL_REG *m_dma_channel[];//global struct variable for for Channel registers
extern DMA_CONTROL_REG *m_dma_control;//global struct variable for for DMAC registers

extern DMA_CHANNEL_REG *m_dma2_channel[];//global struct variable for for Channel registers
extern DMA_CONTROL_REG *m_dma2_control;//global struct variable for for DMAC registers
/*******************************************************************************
* Function Name  : dma_m2mtran
* Description    : dmaͺ
* Input          : - channel: ͨ
*				   - width: ݿ
*				   - src  ʼַ
*				   - dest  Ŀĵַ
*				   - length  ݳ
*
* Output         : None
* Return         : FALSE - ʧ
*                  TRUE  - ɹ
******************************************************************************/
extern bool dma_m2mtran(uint8_t channel,uint8_t width,uint32_t src, uint32_t dest,uint32_t length);

/*******************************************************************************
* Function Name  : dma_spitran
* Description    : spi dmaͺ
* Input          : - spiid: SPI ID
*				   - psend: ݵַ
*				   - precv ݵַ
*				   - length  ݳ
*				   - binten : Ƿжģʽ
*
* Output         : None
* Return         : None
******************************************************************************/
extern void dma_spitran(uint8_t spiid,uint8_t* psend,uint8_t* precv,uint32_t length,BOOL binten);

/*******************************************************************************
* Function Name  : dma_spi_LLIReceive
* Description    : spi dmaպ
* Input          : -n     dmaͨ
* 				   - spiid: SPI ID
*				   - precv ݵַ
*				   - length  ݳ
*
* Output         : None
* Return         : None
******************************************************************************/
extern void dma_spi_LLIReceive(DMA_CHANNEL n,uint8_t spiid, uint8_t *dest,uint32_t length);

/*******************************************************************************
* Function Name  : dma_channle_stop
* Description    : ֹͣDMAͨ
* Input          : -n     dmaͨ
*
* Output         : None
* Return         : None
******************************************************************************/
extern void dma_channle_stop(DMA_CHANNEL n);

/*******************************************************************************
* Function Name  : dma_getLength
* Description    : ȡDMAݳ
* Input          : -n     dmaͨ
*
* Output         : None
* Return         : ǰݳ
******************************************************************************/
extern uint32_t  dma_getLength(DMA_CHANNEL n);

 /*******************************************************************************
 * Function Name  : DMA_Init
 * Description    : DMAʼ
 * Input          : None
 *
 * Output         : None
 * Return         : None
 ******************************************************************************/
extern void DMA_Init(uint32_t dma_base_addr);

/*******************************************************************************
* Function Name  : DMA_REG_Init
* Description    : DMAĴʼ
* Input          : - dmac_base_addr: DMAַ
*
* Output         : None
* Return         : None
******************************************************************************/
extern void DMA_REG_Init(uint32_t dmac_base_addr);

extern void dma_lli_reg_init(uint8_t n,DMA_LLI *dma_lli);
extern void DMA_DAC_Tran(uint8_t channel, uint32_t src,uint32_t length);
extern void DMA_dis(uint8_t n);

#endif /* __DMAC_DRV_H__ */
