/*
 * iccemv.h
 *
 *  Created on: 2017526
 *      Author: YangWenfeng
 */

#ifndef ICCEMV_H_
#define ICCEMV_H_

#include "usi_drv.h"
#include "icc_conf.h"
//#include "main.h"

#ifdef BCTC_DEMO
#define USI_PIT
#endif


/*******************************************
             IC״̬
 *******************************************/
#define ICC_SUCCESS                   0
#define ICC_VCCMODEERR            (-2500)       /* ѹģʽ*/
#define ICC_INPUTSLOTERR          (-2501)       /* ѡͨڴ*/
#define ICC_VCCOPENERR            (-2502)       /* */
#define ICC_ICCMESERR             (-2503)       /* ͨѶʧ*/

#define ICC_T0_TIMEOUT            (-2200)       /* ȴƬӦʱ  */
#define ICC_T0_MORESENDERR        (-2201)       /* ط*/
#define ICC_T0_MORERECEERR        (-2202)       /* մ*/
#define ICC_T0_PARERR             (-2203)       /* ַż*/
#define ICC_T0_INVALIDSW          (-2204)       /* ״ֽ̬Ч*/

#define ICC_DATA_LENTHERR         (-2400)       /* ݳȴ  */
#define ICC_PARERR                (-2401)       /* ż      */
#define ICC_PARAMETERERR          (-2402)       /* ֵΪ*/
#define ICC_SLOTERR               (-2403)       /* ͨ   */
#define ICC_PROTOCALERR           (-2404)       /* Э     */
#define ICC_CARD_OUT              (-2405)       /*        */
#define ICC_NO_INITERR            (-2406)       /* ûгʼ   */
#define ICC_ICCMESSOVERTIME       (-2407)       /* ͨѶʱ*/

#define ICC_ATR_TSERR             (-2100)       /* Լ,TS*/
#define ICC_ATR_TCKERR            (-2101)       /* λУ(T=1,TCK)    */
#define ICC_ATR_TIMEOUT           (-2102)       /* λȴʱ    */
#define ICC_TS_TIMEOUT            (-2115)       /* ַʱ    */
#define ICC_ATR_TA1ERR            (-2103)       /* TA1         */
#define ICC_ATR_TA2ERR            (-2104)       /* TA2         */
#define ICC_ATR_TA3ERR            (-2105)       /* TA3         */
#define ICC_ATR_TB1ERR            (-2106)       /* TB1         */
#define ICC_ATR_TB2ERR            (-2107)       /* TB2         */
#define ICC_ATR_TB3ERR            (-2108)       /* TB3         */
#define ICC_ATR_TC1ERR            (-2109)       /* TC1         */
#define ICC_ATR_TC2ERR            (-2110)       /* TC2         */
#define ICC_ATR_TC3ERR            (-2111)       /* TC3         */
#define ICC_ATR_TD1ERR            (-2112)       /* TD1         */
#define ICC_ATR_TD2ERR            (-2113)       /* TD2         */
#define ICC_ATR_LENGTHERR         (-2114)       /* ATRݳȴ  */

#define ICC_T1_BWTERR             (-2300)       /* T=1ȴʱ  */
#define ICC_T1_CWTERR             (-2301)       /* T=1ַȴʱ  */
#define ICC_T1_ABORTERR           (-2302)       /* 쳣(ABORT)ͨŴ */
#define ICC_T1_EDCERR             (-2303)       /* У(EDC) */
#define ICC_T1_SYNCHERR           (-2304)       /* ͬͨŴ*/
#define ICC_T1_EGTERR             (-2305)       /* ַʱ    */
#define ICC_T1_BGTERR             (-2306)       /* 鱣ʱ    */
#define ICC_T1_NADERR             (-2307)       /* NAD       */
#define ICC_T1_PCBERR             (-2308)       /* PCB         */
#define ICC_T1_LENGTHERR          (-2309)       /* LEN         */
#define ICC_T1_IFSCERR            (-2310)       /* IFSC            */
#define ICC_T1_IFSDERR            (-2311)       /* IFSD            */
#define ICC_T1_MOREERR            (-2312)       /* δʹ󲢷  */
#define ICC_T1_PARITYERR          (-2313)       /* ַż*/
#define ICC_T1_INVALIDBLOCK       (-2314)       /* Ч*/



#define   IC_MAXSLOT       1   //define the 7816_x
#define   USER_CARD        0

//#define debug_print
#define ISO7816_AUTO_RETRANSMIT
#define ISO7816_PBOC_CARD	// 7816 PBOC,Level1Ҫ
//#define JTAG_MODE

#define   ICMAXBUF         512

typedef struct
{
	uint8_t   	    Command[ 4 ]; // CLA INS  P1 P2
	uint16_t  	    Lc;
	uint8_t   	    DataIn[512];
	uint16_t  	    Le;
} APDU_SEND;

typedef struct
{
	uint16_t       LenOut;    // length of dataout
	uint8_t 	    DataOut[512];
	uint8_t        SWA;
	uint8_t        SWB;
} APDU_RESP;


typedef struct
{
	uint8_t open;         /* 0 ر 1   */
	uint8_t existent;     /* 0 ޿ 1 п  */
	uint8_t resetstatus;  /* 0-ûиλ1-临λ2-ȸλ */
	uint8_t autoresp;     /* ԶӦã0=ԶӦ  1=ԶӦ  */
#ifndef ISO7816_PBOC_CARD
	uint16_t F;
#endif	
	uint8_t D;            /* ޸첽ͨŲʱ   */
	uint8_t T;            /* ƬЭ  ֵΪ01 */
	uint8_t TS;           /* Լ  3B= 3F= */
	uint8_t ATR_len;      /*ƬλӦ𳤶 */
	uint8_t ATR[40];      /*ƬλӦ */
	uint8_t TA;       /* 4λЧӦTA1TA2TA3,TA4Ĵ   */
	uint8_t TA1;      /* Ƭλӿַ   */
	uint8_t TA2;      /* Ƭλӿַ   */
	uint8_t TA3;      /* Ƭλӿַ   */
	uint8_t TA4;      /* Ƭλӿַ   */
	uint8_t TB;       /* 4λЧӦTB1TB2TB3,TB4Ĵ   */
	uint8_t TB1;      /* Ƭλӿַ    */
	uint8_t TB2;      /* Ƭλӿַ   */
	uint8_t TB3;      /* Ƭλӿַ   */
	uint8_t TB4;      /* Ƭλӿַ   */
	uint8_t TC;       /* 4λЧӦTC1TC2TC3,TC4Ĵ   */
	uint8_t TC1;      /* Ƭλӿַ   */
	uint8_t TC2;      /* Ƭλӿַ   */
	uint8_t TC3;      /* Ƭλӿַ   */
	uint8_t TC4;      /* Ƭλӿַ   */
	uint8_t TD;       /* 4λЧӦTD1TD2TD3,TD4Ĵ   */
	uint8_t TD1;      /* Ƭλӿַ   */
	uint8_t TD2;      /* Ƭλӿַ   */
	uint8_t TD3;      /* Ƭλӿַ   */
	uint8_t IFSC;     /* ƬϢ   */
	uint8_t IFSD;     /* նϢ   */
	uint8_t term_pcb; /* T=1Эն˷¸ֶθʽк  */
	uint8_t card_pcb; /* T=1Э¿¸ֶθʽк    */
	uint8_t sw1;      /* ״ֽ̬1  */
	uint8_t sw2;      /* ״ֽ̬2  */
}ASYNCARD_INFO;


extern volatile uint32_t          k_Ic_TotalTimeCount;         //ַܳʱм
extern volatile uint32_t          k_Ic_TimeCount;              //ַʱм
extern volatile uint32_t          k_IcMax_TotalTimeCount;      //ܳʱֵ
extern volatile uint32_t          k_IcMax_TimeCount;           //ַʱֵ
extern volatile int             k_timeover,k_total_timeover; //ַʱܳʱ־
extern volatile uint32_t          k_IcMax_EtuCount;           //ַʱֵλETU

//static   uint8_t                  card_Outputdata[ICMAXBUF];
//static   uint8_t                  rstbuf[40];
volatile static uint8_t           WTX;
volatile static uint32_t          WWT,CWT,BWT;
extern volatile uint8_t           current_slot;
extern volatile  uint8_t          Parity_Check_Enable; /* żУ󵥸ַط־  */
extern volatile  uint8_t          k_IccErrPar;       /* żУ    */
extern ASYNCARD_INFO            asyncard_info[IC_MAXSLOT];
extern SC_ATR                   SC_A2R;
extern SC_ADPU_Commands         SC_ADPU;
extern SC_ADPU_Responce         SC_Responce;
extern SC_State                 *locState;
extern SC_READER_SET            SC_Slot_Default;
extern SC_READER_SET            *SC_Slot_Active;
extern volatile uint8_t           SC_ATR_Table[40];
extern volatile uint8_t           SC_ATR_Len;
extern volatile uint8_t           guc_hotrstFlag;
extern volatile uint8_t           guc_Leflag;
extern volatile uint8_t           SC_T0_T1_Status;
extern volatile uint8_t           changeTa1;          //20110729
extern volatile uint8_t           guc_AdjustETU;		//ַETUҪ11
extern volatile uint8_t           guc_GuardTime;		//20131220Ϊint(ԭֵƥ)GTĴΪĬ12ETU
extern volatile uint16_t          respLength;
extern volatile uint8_t           guc_Class;
extern volatile uint8_t           ICCardResetOK;      //ʾICλɹ
extern volatile uint8_t           ICCardInsert;       //ʾѾ
extern volatile uint8_t           ICCardInfoSent;      //icϢͣ00 ʼ״̬   01    02 Ƴ
extern volatile uint8_t           g_usbCommOK;

//icc_hardware.c

/*******************************************************************************
* Function Name  : delayETU
* Description    : Delay a ETU
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void delay1ETU(void);

/*******************************************************************************
* Function Name  : DelayNETU
* Description    : Delay N ETUs
* Input          : count: Delay Parame
* Output         : None
* Return         : None
*******************************************************************************/
void DelayNETU(uint16_t count);

/*******************************************************************************
* Function Name  : SC_VoltageConfig
* Description    : Configures the card power voltage.
* Input          : - SC_Voltage: specifies the card power voltage.
*                    This parameter can be one of the following values:
*                        - MB525 SC_Voltage_5V: 5V cards.
*                        - MB525 SC_Voltage_3V: 3V cards.
*                        - NCN6001 0x01 1.8V
*                        - NCN6001 0x02 3V
*                        - NCN6001 0x03 5V
* Output         : None
* Return         : None
*******************************************************************************/
void SC_VoltageConfig(uint32_t SC_Voltage);

/*******************************************************************************
* Function Name  : Open_ICCard_Vcc_3V
* Description    : open ic card vcc = 5V
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Open_ICCard_Vcc_5V(void);

/*******************************************************************************
* Function Name  : Open_ICCard_Vcc_3V
* Description    : open ic card vcc = 3V
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Open_ICCard_Vcc_3V(void);

/*******************************************************************************
* Function Name  : Open_ICCard_Vcc_1V8
* Description    : open ic card vcc = 1V8
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Open_ICCard_Vcc_1V8(void);

/*******************************************************************************
* Function Name  : Close_ICCard_Vcc
* Description    : close ic card vcc
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Close_ICCard_Vcc(void);

/*******************************************************************************
* Function Name  : Open_ICCard_VCC
* Description    : open ic card vcc
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Open_ICCard_VCC(void);

/*******************************************************************************
* Function Name  : SC_Init
* Description    : Initializes all peripheral used for Smartcard interface.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SC_Init(void);

/*******************************************************************************
* Function Name  : SC_HotInit
* Description    : Smart card ȸλʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SC_HotInit(void);

/*******************************************************************************
* Function Name  : SC_DeInit
* Description    : Deinitializes all ressources used by the Smartcard interface.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SC_DeInit(void);

/*******************************************************************************
* Function Name  : SC_Reset
* Description    : SIM Card λ
* Input          : mode  λʽȸλ临λ
*
* Output         : None
* Return         : ظλ״̬  0λɹ   -1λʧ
******************************************************************************/
char SC_Reset(uint8_t mode);

/*******************************************************************************
* Function Name  : SC_RSTSET
* Description    : Sets or clears the Smartcard reset pin.
* Input          : - ResetState: this parameter specifies the state of the Smartcard
*                    reset pin.
*                    BitVal must be one of the BitAction enum values:
*                       - Bit_RESET: to clear the port pin.
*                       - Bit_SET: to set the port pin.
* Output         : None
* Return         : None
*******************************************************************************/
void SC_RSTSET(uint8_t ResetState);

/*******************************************************************************
* Function Name  : SC_Init
* Description    : Initializes all peripheral used for Smartcard interface.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SC_RegInit(USI_TypeDef* USIx);


//iccemv.c
/*******************************************************************************
* Function Name  : USART_ByteReceive
* Description    : Receives a new data while the time out not elapsed.
* Input          : None
* Output         : None
* Return         : An ErrorStatus enumuration value:
*                         - SUCCESS: New data has been received
*                         - ERROR: time out was elapsed and no further data is
*                                  received
*******************************************************************************/
ErrorStatus USART_ByteReceive(uint8_t *Data, uint32_t TimeOut);

/*******************************************************************************
* Function Name  : USART_TsReceive
* Description    : Receives a new data while the time out not elapsed.
* Input          : None
* Output         : None
* Return         : An ErrorStatus enumuration value:
*                         - SUCCESS: New data has been received
*                         - ERROR: time out was elapsed and no further data is
*                                  received
*******************************************************************************/
ErrorStatus USART_TsReceive(uint8_t *Data, uint32_t TimeOut);

/*******************************************************************************
* Function Name  : SC_GetByte
* Description    : Get byte from IO
* Input          : Data pointer
* Output         : None
* Return         : None
*******************************************************************************/

ErrorStatus SC_GetByte(uint8_t *Data);

/*******************************************************************************
* Function Name  : SC_PutByte
* Description    : Put byte
* Input          : Data to send
* Output         : None
* Return         : None
*******************************************************************************/
uint8_t SC_PutByte(uint8_t Data);

/*******************************************************************************
* Function Name  : SC_Command
* Description    : Handles all Smartcard states and serves to send and receive all
*                  communication data between Smartcard and reader.
* Input          : - locadpu: pointer to an adpu buffer.
*                : adpulen : adpu'length
* Output         : - locresp: pointer to a Responce buffer.
*                : resplen : response's length which includes SW1&SW2
* Return         : SW1 & SW2
*******************************************************************************/
uint16_t SC_Command(uint16_t adpulen, uint8_t * adpubuf, uint16_t * resplen, uint8_t * respbuf);

/*******************************************************************************
* Function Name  : SC_Handler
* Description    : Handles all Smartcard states and serves to send and receive all
*                  communication data between Smartcard and reader.
* Input          : - SCState: pointer to an SC_State enumeration that will contain
*                    the Smartcard state.
*                  - SC_ADPU: pointer to an SC_ADPU_Commands structure that will be
*                    initialized.
*                  - SC_Response: pointer to a SC_ADPU_Responce structure which will
*                    be initialized.
* Output         : None
* Return         : None
*******************************************************************************/
void SC_Handler(SC_ADPU_Commands *SC_ADPU, SC_ADPU_Responce *SC_Response);
/*******************************************************************************
* Function Name  : Icc_Reset
* Description    :ʼSLOTͨICԿϵ磬λжϿЭͣ
*                 T=1T=0ATRλӦ𣩶*ATRָ⡣
* Input          : slot Ҫʼͨ
*                  ATR  ATRBUF
*
* Output         : None
* Return         : None
******************************************************************************/
int Icc_Reset(uint8_t slot,uint8_t *ATR);
/*******************************************************************************
* Function Name  : exp2_n
* Description    :2Nη
* Input          :en : 
*
* Output         : None
* Return         : ز
******************************************************************************/
uint16_t exp2_n(uint8_t en);
/*******************************************************************************
* Function Name  : GetAtr
* Description    :ȡICĸλӦźATR
* Input          :Buff : ATRĴBUFF
*
* Output         : None
* Return         : ز0x00ɹ
******************************************************************************/
int GetAtr(uint8_t *Buff);
/*******************************************************************************
* Function Name  : ClearAtr
* Description    :ATR BUF
* Input          :Channel : ҪATRbuf߼
*
* Output         : None
* Return         : None
******************************************************************************/
void ClearAtr(uint8_t Channel);
/*******************************************************************************
* Function Name  : Icc_Command
* Description    :
*                 ֧T0ЭT1Э
*                 ֧CASE2͵
* Input          : slot     ˿
*                  ApduSend APDU
*                  ApduResp Ӧ
*
* Output         : None
* Return         : ز
******************************************************************************/
int Icc_Command(uint8_t slot,SC_ADPU_Commands * ApduSend,SC_ADPU_Responce * ApduResp);

/*******************************************************************************
* Function Name  : IccSendCommand
* Description    :ֱT=1T=0Э齫CLA+INS+P1+P2+LCLE+INDATAݰʽ
*                  תӦĸʽICн״̬OUTDATA
*                 T=1ʱ OUTDATA LEN2+DATA+SW12
*                 T=0ʱ OUTDATA LEN2+DATA SW浽ȫֱ
* Input          :cla : CLA
*                 ins : INS
*                 p1  : P1
*                 p2  : P2
*                 p3  : P3
*                 indata:data
*                 le   :Le
*                 outdata:BUF
* Output         : None
* Return         : ִн0x00ɹ  ʧ
******************************************************************************/
int IccSendCommand(uint8_t cla, 
									 uint8_t ins,
									 uint8_t p1,
									 uint8_t p2,
									 uint16_t p3,
									 uint8_t *indata,
									 uint16_t le,
									 uint8_t *outdata);

/*******************************************************************************
* Function Name  : T0_send_command
* Description    :T=0Э·ͷCLA+INS+P1+P2+P3ݰDATABUFȡICӦݣOUTBUF״ֽ̬ڣRSLT
* Input          :Class : CLA
*                 Ins : INS
*                 p1  : P1
*                 p2  : P2
*                 p3  : P3
*                 databufն˷ݰ䳤ΪP3
*                 outbuf:ICݣ[0]Ϊݳȣ
*                 relt:CASEţ1234
* Output         : None
* Return         : ִн0x00ɹ  ʧ       ʱSW1SW2״ֽ̬ڡ
******************************************************************************/
int T0_send_command(uint8_t cla,
	                  uint8_t ins,
                    uint8_t p1,
                    uint8_t p2,
                    uint8_t p3,
                    uint8_t *databuf,
                    uint8_t *outbuf,
                    uint8_t *rslt);

/*******************************************************************************
* Function Name  : T1_send_command
* Description    :T=1ЭµݷӦݡ
*                   ע: T1֧չָҪ֧Ҫ޸
* Input          :NAD : ַΪ0X00
*                 INBUF : ͵ϢֶLEN+INFINBUF[0]Ϊȣ
*                 OUTBUF: ӦݵԪʽNAD+LEN2ֽڣ+DATA+SW1+SW2
* Output         : None
* Return         : ִн0x00ɹ  ʧ
******************************************************************************/
int T1_send_command(uint8_t nad,uint8_t *inbuf,uint8_t *outbuf);
/*******************************************************************************
* Function Name  : T1_Send_Block
* Description    :T=1Э·һ
* Input          :Inbuf : buf
*
* Output         : None
* Return         : ִн0x00ɹ  ʧ
******************************************************************************/
int  T1_Send_Block(uint8_t *Inbuf);
/*******************************************************************************
* Function Name  : T1_Rece_Block
* Description    :T=1Э½һ
* Input          :Outbuf : ݻbuf
*
* Output         : None
* Return         : ִн0x00ɹ  ʧ
******************************************************************************/
int  T1_Rece_Block(uint8_t *Outbuf);
/*******************************************************************************
* Function Name  : T1_IFSD_command
* Description    :յȷĸλӦ󣬶T=1Ƭ뷢һIFSDָʾնȡ鳤ȡ
* Input          :slot : ߼
*
* Output         : None
* Return         : ִн0x00ɹ  ʧ
******************************************************************************/
int  T1_IFSD_command(uint8_t slot);
/*******************************************************************************
* Function Name  : SC_PollCard_Init
* Description    : SIM card insertion init detection
* Input          : None
*
* Output         : None
* Return         : None
*******************************************************************************/
void SC_PollCard(void);

#endif /* ICCEMV_H_ */
