/*
 * pit32_drv.h
 *
 *  Created on: 20171129
 *      Author: nltao
 */

#ifndef PIT32_DRV_H_
#define PIT32_DRV_H_

#include "type.h"
#include "pit32_reg.h"

#define PIT32_ADDR        (PIT1_BASE_ADDR)
//#define PIT32_ADDR        (PIT2_BASE_ADDR)

#define PIT32             ((PIT32_TypeDef *)PIT32_ADDR)   

#define PIT1             ((PIT32_TypeDef *)PIT1_BASE_ADDR)    
#define PIT2             ((PIT32_TypeDef *)PIT2_BASE_ADDR) 

typedef enum
{
	PIT32_CLK_DIV_1,//1Ƶ
	PIT32_CLK_DIV_2,//2Ƶ
	PIT32_CLK_DIV_4,//4Ƶ
	PIT32_CLK_DIV_8,//8Ƶ
	PIT32_CLK_DIV_16,//16Ƶ
	PIT32_CLK_DIV_32,//32Ƶ
	PIT32_CLK_DIV_64,//64Ƶ
	PIT32_CLK_DIV_128,//128Ƶ
	PIT32_CLK_DIV_256,//256Ƶ
	PIT32_CLK_DIV_512,//512Ƶ
	PIT32_CLK_DIV_1024,//1024Ƶ
	PIT32_CLK_DIV_2048,//2048Ƶ
	PIT32_CLK_DIV_4096,//4096Ƶ
	PIT32_CLK_DIV_8192,//8192Ƶ
	PIT32_CLK_DIV_16384,//16384Ƶ
	PIT32_CLK_DIV_32768,//32768Ƶ
}PIT32_CLKDIV;


/*******************************************************************************
* Function Name  : PIT32_Init
* Description    : PITʼ
* Input          : - PrescalerPITʱӷƵֵ
*                  - PMRReloadCounterVal:PITʼֵ
*                  - pitINT :ʹPITжϷʽ
*
* Output         : None
* Return         : None
******************************************************************************/
extern void PIT32_Init(PIT32_CLKDIV Prescaler, uint32_t PMRReloadCounterVal,BOOL pitINT);

/*******************************************************************************
* Function Name  : PIT32_Start
* Description    : PIT
* Input          : None
*
* Output         : None
* Return         : None
******************************************************************************/
extern void PIT32_Start(void);


/*******************************************************************************
* Function Name  : PIT32_Stop
* Description    : PITر
* Input          : None
*
* Output         : None
* Return         : None
******************************************************************************/
extern void PIT32_Stop(void);



/*******************************************************************************
* Function Name  : PIT32_Cmd
* Description    : PITʹܿ
* Input          : - NewStatenew state of the specified PIT.
*                              This parameter can be: ENABLE or DISABLE.
*
* Output         : None
* Return         : None
******************************************************************************/
extern void PIT32_Cmd(FunctionalState NewState);



/*******************************************************************************
* Function Name  : PIT32_CmdPIT_ITConfig
* Description    : PITжʹܿ
* Input          : - NewStatenew state of the specified PIT interrupts.
*                              This parameter can be: ENABLE or DISABLE.
*
* Output         : None
* Return         : None
******************************************************************************/
extern void PIT32_ITConfig(FunctionalState NewState);


/*******************************************************************************
* Function Name  : PIT32_ReadCNTR
* Description    : ȡPITֵ
* Input          : -None
*
* Output         : ֵ
* Return         : ֵ
******************************************************************************/
extern uint32_t PIT32_ReadCNTR(void);

/*******************************************************************************
* Function Name  : PIT32_ISR
* Description    : PIT32жϴ
* Input          : None
*
* Output         : None
* Return         : None
******************************************************************************/
void PIT_dis(void);

#endif /* PIT32_DRV_H_ */
