// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// File name    : tc_drv.c
// Version      : V0.1
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#include "debug.h"
#include "tc_drv.h"


/*******************************************************************************
* Function Name  : TC_ISR
* Description    : TC жϴ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void TC_ISR(void)
{
	TC->TCCR |= TC_IF;
	while(TC->TCCR&TC_IS);
	printf("tc int\r\n");
}

void TC_IRQHandler(void)
{
	TC_ISR();
}

/*******************************************************************************
* Function Name  : TC_Init
* Description    : TCʼ
* Input          : - tc_wdp: TCԤƵֵ
*                  - Countervaltimeʼֵ
*
* Output         : None
* Return         : None
******************************************************************************/
void TC_Init(TC_TIMER_PRESCALER tc_wdp, uint16_t Counterval)
{
	TC->TCMR = Counterval;
	TC->TCCR = (tc_wdp<<4) | TC_IE;
	TC->TCCR |= TC_CU;
}

/*******************************************************************************
* Function Name  : TC_Close
* Description    : رTC
* Input          : None
*
* Output         : None
* Return         : None
******************************************************************************/
void TC_Close(void)
{
	TC->TCCR &= ~TC_RN;
	TC->TCCR &= ~TC_IE;
}	

/*******************************************************************************
* Function Name  : TC_FeedWatchDog
* Description    : TCιTC watchdogֹtc time outϵͳж
* Input          : None
*
* Output         : None
* Return         : None
******************************************************************************/
void TC_FeedWatchDog(void)
{
	TC->TCSR = 0x5555;
	TC->TCSR = 0xAAAA;
}

/*******************************************************************************
* Function Name  : TC_GetCount
* Description    : ȡTC counterֵ
* Input          : None
*
* Output         : TC counter
* Return         : None
******************************************************************************/
uint32_t TC_GetCount(void)
{
	return (TC->TCCNTR);
}

/*******************************************************************************
* Function Name  : TC_ResetInit
* Description    : TC resetܳʼ
* Input          : -wdpTCƵϵ
*                  -tcmrTCʼֵ
*                  -reset_enǷTC reset
* Output         : None
* Return         : None
******************************************************************************/
void TC_ResetInit(TC_TIMER_PRESCALER wdp, uint16_t tcmr, BOOL reset_en)
{
	uint16_t temp;
	
	if (FALSE == reset_en) //close reset
	{
		TC->TCCR &= ~TC_RN;
        TC->TCMR = tcmr;
        temp = TC->TCCR;
        temp &= (~0x7f);
        NVIC_Init(3, 3, TC_IRQn, 2);
        TC->TCCR = temp|TC_IE|(wdp<<TC_WDP_SHIFT);
	}
    else
    {
        TC->TCMR = tcmr;
        temp = TC->TCCR;
        temp &= (~0x7f);
        TC->TCCR = temp|TC_RN|(wdp<<TC_WDP_SHIFT);
    }
    TC->TCCR |= TC_CU; // update WDP & WMR
}

/*******************************************************************************
* Function Name  : TC_IntInit
* Description    : TC жϹܳʼ
* Input          : -wdpTCƵϵ
*                  -tcmrTCʼֵ
*                  -int_enǷTC int
* Output         : None
* Return         : None
******************************************************************************/
void TC_IntInit(TC_TIMER_PRESCALER wdp, uint16_t tcmr, BOOL int_en)
{
	uint16_t temp;

	TC->TCMR = tcmr;
	temp = TC->TCCR;
	temp &= (~0x7f);
	
	if (TRUE == int_en)
	{
		NVIC_Init(3, 3, TC_IRQn, 2);
		TC->TCCR = temp|TC_IE|(wdp<<TC_WDP_SHIFT);
	}
	else
		TC->TCCR = temp|(wdp<<TC_WDP_SHIFT);
	
	TC->TCCR |= TC_CU;
}
