// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// File name    : usb_cdc_config.c
// Version      : V0.1
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#include "type.h"
#include "usb_const.h"

const uint8_t USB_cdc_Device_Descriptor[18] =   //USB豸
{
	0x12,                       //bLength: 0x12 ֽ
	DT_DEVICE,                  //bDescriptorType: 豸

	0x00, 0x02,				    //bcdUSB: version2.0
	0x02,                       //bDeviceClassֶΡ豸豸ָ豸ͣ
    							//üӿڣͻᱻϵͳΪһUSB豸Ӷ豸0x02Ϊͨ豸롣
	0x00,                       //bDeviceSubClass: 0Ϊ0
	0x00,                       //bDeviceProtocol: Э0Ϊ0
	0x40,                       //bMaxPacketSize0: 64ֽڣ˵0
	0x88, 0x88,                 //idVendor:   ID
	0x07, 0x00,                 //idProduct: Ʒ ID
	0x00, 0x01,                 //bcdDevice: 豸汾
	0x01,                       //iManufacturer: ַ
	0x02,                       //iProduct: ַ
	0x03,                       //iSerialNumber: ַ
	0x01,                       //bNumConfigurations:ֵ֧1
};
//Device Qualifier Descriptor
const uint8_t USB_cdc_Device_Qualifier_Descriptor[10] =
{
	//Device Qualifier(0x0A bytes)
	0x0A,                   //bLength: 0x12 bytes
	0x06,                   //bDescriptorType: DEVICE
	0x00, 0x02,             //bcdUSB_cdc: version 2.0
	0x00,                   //bDeviceClass: independent interfaces
	0x00,                   //bDeviceSubClass: 0
	0x00,                   //bDeviceProtocol: class specific protocols NOT used on device basis
	0x40,                   //bMaxPacketSize0 for other speed
	0x01,                   //bNumConfigurations for other-speed configuration
	0x00,                   //Reserved,must be 0        
};
const uint8_t USB_cdc_Configuration_Descriptor[] =  //USB
{                                 //USB
	0x09,                         //bLength  
	DT_CONFIGURATION,             //bDescriptor   
	0x43,						  //wTotalLength  üϵܳ  ֽ
	0x00, 						  //wTotalLength  üϵܳ  ֽ
	0x02,                         //bNumInterface  õĽӿΪ2
	0x01,                         //bConfiguration Value   õֵΪ1
	0x00,                         //iConfiguration    ûַ
	0xa0,                         //bmAttributes
	0x32,                         //bMaxPower   豸100mA

	/*******************CDCӿ*********************/
	0x09,                         //bLength:    ӿ
	INTERFACE_TYPE,                         //bDescriptorType   ӿ
	0x00,                         //bInterfaceNumber   ӿڱ
	0x00,                         //bAlternateSetting   ӿڱñ
	0x01,                         //bNumEndpoints     0˵,CDCӿֻʹһж
	0x02,                         //bInterfaceClass:   ýӿʹõࡣCDCΪ0x02
	0x02,                         //bInterfaceSubClass  ýӿʹõࡣҪʵUSBתڣ
 							      //ͱʹAbstract Control ModelģͣࡣıΪ0x02
	0x01,                         //bInterfaceProtocol ʹCommon AT CommandsͨATЭ顣ЭıΪ0x01
	0x00,                         //iInterface   ýӿڵֵַûУΪ0
    /***************Ϊ****************/
 	/********* Header Functional Descriptor ********/
	0x05,						  //bFunctionLengthֶΡΪ5ֽ
 	0x24,						  //bDescriptorTypeֶΡΪӿڣCS_INTERFACEΪ0x24
	0x00,						  //bDescriptorSubtypeֶΡΪHeader Functional DescriptorΪ0x00
	0x10,0x01,					  //bcdCDCֶΡCDC汾ţΪ0x0110ֽȣ
	 /**** Call Management Functional Descriptor ****/
	0x05,						  //bFunctionLengthֶΡΪ5ֽ
 	0x24,						  //bDescriptorTypeֶΡΪӿڣCS_INTERFACEΪ0x24
	0x01,						  //bDescriptorSubtypeֶΡΪCall Management functional descriptorΪ0x01
	0x00,						  //bmCapabilitiesֶΡ豸Լcall management
 	0x00,						  //bDataInterfaceֶΡûӿcall management
	/*** Abstract Control Management Functional Descriptor ***/
	0x04,						  //bFunctionLengthֶΡΪ4ֽ
	0x24,						  //bDescriptorTypeֶΡΪӿڣCS_INTERFACEΪ0x24
	0x02,						  //bDescriptorSubtypeֶΡΪAbstract Control Management functional descriptorΪ0x02
	0x02,						  //bmCapabilitiesֶΡ֧Set_Line_CodingSet_Control_Line_StateGet_Line_CodingSerial_State֪ͨ
	/***  Union Functional Descriptor  **/
	0x05,						  //bFunctionLengthֶΡΪ5ֽڡ
	0x24,						  //bDescriptorTypeֶΡΪӿڣCS_INTERFACEΪ0x24
	0x06,						  //bDescriptorSubtypeֶΡΪUnion functional descriptorΪ0x06
	0x00,						  //MasterInterfaceֶΡΪǰΪ0CDCӿڡ
	0x01,						  //SlaveInterfaceֶΣΪΪ1ӿڡ
	/***********  Ϊӿ0Ķ˵  *******/
	0x07,						  //bLengthֶΡ˵Ϊ7ֽڡ
	DT_ENDPOINT,				  //bDescriptorTypeֶΡ˵Ϊ0x05
	0x80+INDEX_EP3,				  //bEndpointAddressֶΡ˵ĵַʹ˵1D7λʾݷ˵D7Ϊ1˵1ĵַΪ0x81
	0x03,						  //bmAttributesֶΡD1~D0Ϊ˵㴫ѡ񡣸ö˵Ϊж϶˵㡣ж϶˵ıΪ3λΪ0
	0x00,0x02,					  //wMaxPacketSizeֶΡö˵512ֽ
	0xFF,						  //bIntervalֶΡ˵ѯʱ䣬Ϊ10֡ʱ䣬10ms
	/*********  Ϊӿ1ݽӿڣĽӿ  *********/
	0x09,						  //bLengthֶΡӿĳΪ9ֽڡ
	INTERFACE_TYPE,						  //bDescriptorTypeֶΡӿıΪ0x04
	0x01,						  //bInterfaceNumberֶΡýӿڵıţڶӿڣΪ1
 	0x00,						  //bAlternateSettingֶΡýӿڵıñţΪ0
	0x02,						  //bNumEndpointsֶΡ0˵Ŀ豸Ҫʹһ˵㣬Ϊ2
	0x0A,						  //bInterfaceClassֶΡýӿʹõࡣӿڵĴΪ0x0A
	0x00,						  //bInterfaceSubClassֶΡýӿʹõΪ0
	0x00,						  //bInterfaceProtocolֶΡýӿʹõЭΪ0
	0x00, 						  //iConfigurationֶΡýӿڵֵַûУΪ0
	/*****  Ϊӿ1ӿڣĶ˵  *****/
	/*************** ˵2 ******************/
	0x07,						  //bLengthֶΡ˵Ϊ7ֽڡ
	DT_ENDPOINT,				  //bDescriptorTypeֶΡ˵Ϊ0x05
	0x80+INDEX_EP1,				  //bEndpointAddressֶΡ˵ĵַʹ˵2D7λʾݷ˵D7Ϊ1˵2ĵַΪ0x82
	0x02,						  //bmAttributesֶΡD1~D0Ϊ˵㴫ѡ񡣸ö˵Ϊ˵㣬˵ıΪ0x02λΪ0
	0x00,0x02,					  //wMaxPacketSizeֶΡö˵˵2Ϊ512ֽڡעֽȡ
	0x00,						  //bIntervalֶΡ˵ѯʱ䣬˵Ч
	/*************** ˵2 ******************/
	0x07,						  //bLengthֶΡ˵Ϊ7ֽڡ
	DT_ENDPOINT,			      //bDescriptorTypeֶΡ˵Ϊ0x05
	INDEX_EP2,					  //bEndpointAddressֶΡ˵ĵַʹ˵2D7λʾݷ˵D7Ϊ1˵2ĵַΪ0x82
	0x02,						  //bmAttributesֶΡD1~D0Ϊ˵㴫ѡ񡣸ö˵Ϊ˵㣬˵ıΪ0x02λΪ0
	0x00,0x02,					  //wMaxPacketSizeֶΡö˵˵2Ϊ512ֽڡעֽȡ
	0x00,						  //bIntervalֶΡ˵ѯʱ䣬˵Ч
};


//standard string Descriptor,serial number
const uint8_t USB_cdc_String_Descriptor[] =
{
	//Device (0x1a bytes)
	0x1a,                   //bLength: 0x1A bytes
	0x03,                   //bDescriptorType: STRING
	0x33,
	0x00,

	0x35,
	0x00,
	0x35,
	0x00,

	0x34,
	0x00,
	0x39,
	0x00,

	0x39,
	0x00,
	0x34,
	0x00,

	0x34,
	0x00,
	0x31,
	0x00,

	0x34,
	0x00,
	0x39,
	0x00,

	0x34,
	0x00
};
//USB Language ID
const uint8_t UsbLanguageID[4] =
{
	4,				// Num bytes of this descriptor
	DT_STRING,				// String descriptor
	0x09,			// Language ID LSB
	0x04			// Language ID
};


//Manufacturer String
const uint8_t UsbStrDescManufacturer[12] =
{
	12,				// Num bytes of this descriptor
	DT_STRING,				// String descriptor
	'C',	0,
	'C',	0,
	'o',	0,
	'r',	0,
	'e',	0
};

//Product String
const uint8_t UsbStrDescProduct[30] =
{
	30,				// Num bytes of this descriptor
	3,				// String descriptor
	'U',	0,
	'S',	0,
	'B',	0,
	' ',	0,
	'C',	0,
	'D',	0,
	'C',	0,
	' ',	0,
	'D',	0,
	'E',	0,
	'V',	0,
	'I',	0,
	'C',	0,
	'E',	0
};



//Serial Number
const uint8_t UsbStrDescSerialNumber[34] =
{
	34,			// Num bytes of this descriptor
	DT_STRING,			// String descriptor
	'1',	0,
	'2',	0,
	'3',	0,
	'4',	0,
	'5',	0,
	'6',	0,
	'7',	0,
	'8',	0,
	'9',	0,
	'0',	0,
	'A',	0,
	'B',	0,
	'C',	0,
	'D',	0,
	'E',	0,
	'F',	0
};
