// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// File name    : usi_drv.c
// Version      : V0.1
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#include "usi_drv.h"
#include "delay.h"
#include "cpm_drv.h"
#include "debug.h"
#include "libRegOpt.h"
#include "iccemv.h"

//#define BCTC_CONTACT_TEST	//BCTCӴҪ򿪴˺
#ifdef BCTC_CONTACT_TEST
	#define DATA_EPORT	0	//7816EPORTӷʽ
#endif

/******************************************************************************
 *  Global variables defined
 ******************************************************************************/

USI_TypeDef * g_USIReg = USI;


/*******************************************************************************
* Function Name  : USI_ConfigGpio
* Description    : USIóGPIO;
* Input          : - USIx    : USIĻַUSI1USI2
*                  - USI_PINxUSIӦPINţȡֵUSI_RSTUSI_CLKUSI_DAT
*                  - GPIO_DirGPIO   GPIO_OUTPUT  GPIO_INPUT
*
* Output         : None
* Return         : None
******************************************************************************/
void USI_ConfigGpio(USI_TypeDef * USIx, USI_PIN USI_PINx, uint8_t GPIO_Dir)
{
	/* Check the parameters */
	assert_param(IS_USI_PINx(USI_PINx));
	assert_param(IS_GPIO_DIR_BIT(GPIO_Dir));

	USIx->USIPCR |= 0xC0;	//config gpio

	if (GPIO_Dir == GPIO_OUTPUT)
	{
		USIx->USIDDR |= (1<<USI_PINx);//output
	}
	else if (GPIO_Dir == GPIO_INPUT)
	{
		USIx->USIDDR &= (~(1<<USI_PINx));//input
	}
}


/*******************************************************************************
* Function Name  : USI_ReadGpioData
* Description    : ȡUSI_PINxӦŵĵƽ
* Input          : - USIx    : USIĻַUSI1USI2
*                  - USI_PINxUSIӦPINţȡֵUSI_RSTUSI_CLKUSI_DAT
*
* Output         : None
* Return         : Bit_SET:ߵƽ  Bit_RESET͵ƽ
******************************************************************************/
uint8_t USI_ReadGpioData(USI_TypeDef * USIx, USI_PIN USI_PINx)
{
	uint8_t bitstatus = 0x00;

	/* Check the parameters */
	assert_param(IS_USI_PINx(USI_PINx));

	bitstatus = USIx->USIPDR;
	if (bitstatus &(Bit_SET<<USI_PINx))
		bitstatus = Bit_SET;
	else
		bitstatus = Bit_RESET;

	return bitstatus;
}


/*******************************************************************************
* Function Name  : USI_WriteGpioData
* Description    : USI_PINxӦŵĵƽ
* Input          : - USIx    : USIĻַUSI1USI2
*                  - USI_PINxSPIӦPINţȡֵUSI_RSTUSI_CLKUSI_DAT
*                  - bitValõĵƽBit_SETΪߵƽ  Bit_RESETΪ͵ƽ
*
* Output         : None
* Return         : None
******************************************************************************/
void USI_WriteGpioData(USI_TypeDef * USIx, USI_PIN USI_PINx, uint8_t bitVal)
{
	/* Check the parameters */
	assert_param(IS_USI_PINx(USI_PINx));

	if (bitVal == Bit_SET)
		USIx->USIPDR |= (Bit_SET<<USI_PINx);
	else
		USIx->USIPDR &= (~(Bit_SET<<USI_PINx));
}


/*******************************************************************************
* Function Name  : USI_Init
* Description    : USIʼ
* Input          : None
*
* Output         : None
* Return         : None
******************************************************************************/
void  USI_Init(void)
{
	//CHIP_RESET->RCR &= ~CRE;
}

/*******************************************************************************
* Function Name  : TransmitByte
* Description    : һֽ
* Input          : ͵ֽdata
*
* Output         : None
* Return         : None
******************************************************************************/
void TransmitByte(uint8_t data)
{
    while((g_USIReg->USISR & USISR_TDRE_MASK)==0);
    g_USIReg->USITDR = data;
	
    while((g_USIReg->USISR & USISR_TC_MASK)==0);		//ÿַĵ11etuʱɣ⵽errorȻ¸ַ
}

/*******************************************************************************
* Function Name  : ReceiveByte
* Description    : һֽ
* Input          : None
*
* Output         : None
* Return         : ؽյֽ
******************************************************************************/
uint8_t ReceiveByte(void)
{
    uint8_t data;

    while((g_USIReg->USISR & USISR_RDRF_MASK) != USISR_RDRF_MASK);
    data = g_USIReg->USIRDR;
    return data;
}


/*******************************************************************************
* Function Name  : USI_DeInit
* Description    : USIʼ
* Input          : None
*
* Output         : None
* Return         : None
******************************************************************************/
void USI_DeInit(void)
{
	SC_RSTSET(0); 	//RST 
	DelayMS(1);

//	g_USIReg->USIPDR &= 0xfd;                   //isoclk L
//	g_USIReg->USIPCR |= 0x40;	                //clkΪGPIOģʽCLKֹͣмʮusĸߵƽ
	g_USIReg->USICSR |= 0x40;                   //ʱֹͣΪ͵ƽ
	DelayNETU(1);
	g_USIReg->USICSR &= 0x7F;                   //disable cclk
	g_USIReg->USICR1 = g_USIReg->USICR1 & 0xef;	//ر7816ģ

	//IOCLKRST0ͨVCC
	g_USIReg->USIPCR = 0xC7;		            //IO/CLKGPIO
	g_USIReg->USIDDR = 0x07; 	                //isoclk, isorst, isodat output
	g_USIReg->USIPDR = 0x00;		            //0
}

/*******************************************************************************
* Function Name  : USIMasterInit
* Description    : USIʼ
* Input          : None
*
* Output         : None
* Return         : None
******************************************************************************/
void USIMasterInit(void)
{
	unsigned char ret,i;

	//ʱӣCLKһʱʱӣϹ淶
	g_USIReg->USICSR = g_ips_clk/4000000-1;  //fclk = fips/(ccps+1); fclk = 4M

	g_USIReg->USICSR |= 0x80;       //enable cclk

	g_USIReg->USIPDR &= 0xfe;       //isorst L
	g_USIReg->USIDDR = 0x03;        //isoclk, isorst output

	g_USIReg->USIBDR = 0x02;        // 372 F/D
	g_USIReg->USIIER = 0x0;         //disable interrupt

	g_USIReg->USIPCR = 0x07;		//IO/CLKUSIģʽ
	g_USIReg->USIPCR |= 0x20;       //isodat is open-drain
	g_USIReg->USICR1 = 0x14;		//ʹ7816ģ
	g_USIReg->USICR1 |= 0x80;	    //SBλЧ־SBֻstopģʽյʼλŻ1

	//Clear RDR
	ret = g_USIReg->USISR;
	g_USIReg->USISR = ret; //clear ATR
	ret = g_USIReg->USIRDR;

	for(i=0;i<8;i++)		// 20131226,ִ1CF110.02ִ1CF110.03ȡATRʧ⣬ԭ110.02෢NֽڣԱڻ
	{
		//FIFOΪ8ֽڣso8ֽڼɡͨUSISRжǷ
		ret = g_USIReg->USIRDR;
	}
}

/*******************************************************************************
* Function Name  : USIMasterHotInit
* Description    : USIʼ
* Input          : None
*
* Output         : None
* Return         : None
******************************************************************************/
void USIMasterHotInit(void)
{
	uint8_t ret,i;
	
	ret = ret;

	g_USIReg->USIBDR = 0x02; // 372 F/D
	g_USIReg->USIIER = 0x0; //disable interrupt

	for(i=0;i<8;i++)		// 20131226,ִ1CF110.02ִ1CF110.03ȡATRʧ⣬ԭ110.02෢NֽڣԱڻ
	{
		//FIFOΪ8ֽڣso8ֽڼɡͨUSISRжǷ
		ret = g_USIReg->USIRDR;
	}
}

/*******************************************************************************
* Function Name  : USI_OpenWTC
* Description    : USI֡ȴʱ
* Input          : ȴʱetu
*
* Output         : None
* Return         : None
******************************************************************************/
void USI_OpenWTC(uint32_t etu)
{
	g_USIReg->USICR1 &= ~0x02;		// WTENرգͬʱWait TimeOut Flag

	g_USIReg->USIWTRH = (uint8_t)(etu>>16);	//õȴʱ
	g_USIReg->USIWTRM = (uint8_t)(etu>>8);
	g_USIReg->USIWTRL = (uint8_t)etu;

	g_USIReg->USICR1 |= 0x02;		// WTENʹ
}

/*******************************************************************************
* Function Name  : Card2_Power_On
* Description    : ϵ
* Input          : None
*
* Output         : None
* Return         : None
******************************************************************************/
void Card2_Power_On(void)
{
//	uint32_t temp;
	
	CPM->CPM_SLPCFGR &= ~(0x1<<15);
	CPM->CPM_SLPCFGR |= (0x2<<12);            //(Ĭ0x0=1.8V)  0x2=3.3V    

//	CPM->CPM_PWRCR &= ~(0x1<<26);
	CPM_PWRCR_OptBits((0x1<<26),RESET);

#if 0
	//ȴcard vccȶ
	while((CPM->CPM_PWRSR & 0x02) != 0x02);
#else
	DelayMS(2);
	if ((CPM->CPM_PWRSR & 0x02) != 0x02)	//·ûȶVCCµ
	{
//		CPM->CPM_PWRCR |= (0x1<<26);
		CPM_PWRCR_OptBits((0x1<<26),SET);
		CPM->CPM_SLPCFGR |= (0x1<<15);		
	}
#endif	
}

/*******************************************************************************
* Function Name  : Card2_Power_Off
* Description    : µ
* Input          : None
*
* Output         : None
* Return         : None
******************************************************************************/
void Card2_Power_Off(void)
{
//	CPM->CPM_PWRCR |= (0x1<<26);
	CPM_PWRCR_OptBits((0x1<<26), SET);
	CPM->CPM_SLPCFGR |= (0x1<<15);

	//ȴcard ldoԴͷ
	DelayMS(5);
}

/*******************************************************************************
* Function Name  : Card2_Power_Switch
* Description    : ѹл
* Input          : mode ѹлģʽ
*
* Output         : None
* Return         : None
******************************************************************************/
void Card2_Power_Switch(uint8_t mode)
{
	Card2_Power_Off();

	CPM->CPM_SLPCFGR &= 0xffffcfff;

	CPM->CPM_SLPCFGR |= (mode<<12);

	Card2_Power_On();
}

/*******************************************************************************
* Function Name  : Card3_Power_Off
* Description    : µ
* Input          : None
*
* Output         : None
* Return         : None
******************************************************************************/
//void Card3_Power_Off(void)
//{
//	CPM->CPM_PWRCR |= (0x1<<25);
//	CPM->CPM_SLPCFGR |= (0x1<<11);

//	//ȴcard ldoԴͷ
//	DelayMS(5);
//}

/*******************************************************************************
* Function Name  : Card3_Power_On
* Description    : ϵ
* Input          : None
*
* Output         : None
* Return         : None
******************************************************************************/
//void Card3_Power_On(void)
//{
//	CPM->CPM_SLPCFGR &= ~(0x1<<11);
//	CPM->CPM_PWRCR &= ~(0x1<<25);

//#if 0
//	//ȴcard vccȶ
//	while((CPM->CPM_PWRSR & 0x04) != 0x04);
//#else
//	DelayMS(2);
//	if ((CPM->CPM_PWRSR & 0x04) != 0x04)	//·ûȶVCCµ
//	{
//		CPM->CPM_PWRCR |= (0x1<<25);
//		CPM->CPM_SLPCFGR |= (0x1<<11);
//	}
//#endif	
//}

/*******************************************************************************
* Function Name  : Card3_Power_Switch
* Description    : ѹл
* Input          : mode ѹлģʽ
*
* Output         : None
* Return         : None
******************************************************************************/
//void Card3_Power_Switch(unsigned char mode)
//{
//	Card3_Power_Off();

//	CPM->CPM_SLPCFGR &= 0xfffffcff;

//	CPM->CPM_SLPCFGR |= (mode<<8);

//	Card3_Power_On();
//}









