/*
 * usi_dev.h
 *
 *  Created on: 2017526
 *      Author: YangWenfeng
 */

#ifndef USI_DEV_H_
#define USI_DEV_H_

#include "usi_reg.h"

#define USI_BASE_ADDR      USI1_BASE_ADDR
#define USI_2_BASE_ADDR      USI2_BASE_ADDR

#define USI          ((USI_TypeDef *)USI_BASE_ADDR)
#define USI2         ((USI_TypeDef *)USI_2_BASE_ADDR)

#if(USI_BASE_ADDR == USI1_BASE_ADDR)
	#define USI_IRQn    USI1_IRQn
#else
	#define USI_IRQn    USI2_IRQn
#endif




typedef enum
{
    USI_RST = 0,
    USI_CLK,
    USI_DAT,
}USI_PIN;

#define IS_USI_PINx(pin) (((pin) == USI_RST) || \
                          ((pin) == USI_CLK) ||\
                         ((pin) == USI_DAT) )
                          
#define ISO7816_1    1
#define ISO7816_2    2

#define card_1v8			0x0
#define card_3v				0x1
#define card_3v3			0x2
#define card_5v			    0x3

extern USI_TypeDef * g_USIReg;

/*******************************************************************************
* Function Name  : USI_ConfigGpio
* Description    : USIóGPIO;
* Input          : - USIx    : USIĻַUSI1USI2
*                  - USI_PINxUSIӦPINţȡֵUSI_RSTUSI_CLKUSI_DAT
*                  - GPIO_DirGPIO   GPIO_OUTPUT  GPIO_INPUT
*
* Output         : None
* Return         : None
******************************************************************************/
extern void USI_ConfigGpio(USI_TypeDef * USIx, USI_PIN USI_PINx, uint8_t GPIO_Dir);

/*******************************************************************************
* Function Name  : USI_ReadGpioData
* Description    : ȡUSI_PINxӦŵĵƽ
* Input          : - USIx    : USIĻַUSI1USI2
*                  - USI_PINxUSIӦPINţȡֵUSI_RSTUSI_CLKUSI_DAT
*
* Output         : None
* Return         : Bit_SET:ߵƽ  Bit_RESET͵ƽ
******************************************************************************/
extern uint8_t USI_ReadGpioData(USI_TypeDef * USIx, USI_PIN USI_PINx);

/*******************************************************************************
* Function Name  : USI_WriteGpioData
* Description    : USI_PINxӦŵĵƽ
* Input          : - USIx    : USIĻַUSI1USI2
*                  - USI_PINxSPIӦPINţȡֵUSI_RSTUSI_CLKUSI_DAT
*                  - bitValõĵƽBit_SETΪߵƽ  Bit_RESETΪ͵ƽ
*
* Output         : None
* Return         : None
******************************************************************************/
extern void USI_WriteGpioData(USI_TypeDef * USIx, USI_PIN USI_PINx, uint8_t bitVal);

extern void USI_Init(void);
extern void USI_DeInit(void);

extern void USI_PullLow(void);
extern void USI_Resume(void);

extern void USIMasterInit(void);
extern void USIMasterHotInit(void);

extern void Card2_Power_On(void);
extern void Card2_Power_Off(void);
extern void Card2_Power_Switch(uint8_t mode);

extern void Card3_Power_On(void);
extern void Card3_Power_Off(void);
extern void Card3_Power_Switch(uint8_t mode);

extern void USI_OpenWTC(uint32_t etu);

extern void TransmitByte(uint8_t data);
extern uint8_t ReceiveByte(void);
#endif /* USI_DEV_H_ */
