/*
 * usi_reg.h
 *
 *  Created on: 2017525
 *      Author: YangWenfeng
 */

#ifndef USI_REG_H_
#define USI_REG_H_
#include "type.h"
#include "memmap.h"

enum
{
USISR_TDRE_MASK    =   0x80,
USISR_TC_MASK      =   0x40,
USISR_RDRF_MASK    =   0x20,
USISR_OR_MASK      =   0x10,
USISR_ERROR_MASK   =   0x08,
USISR_ATR_MASK     =   0x04,
USISR_WTO_MASK     =   0x02,
USISR_SB_MASK      =   0x01,
};
#pragma anon_unions
typedef struct
{
	__IO uint8_t USIBDR;  //0x00
	__IO uint8_t USICR1;  //0x01
	__IO uint8_t USICR2;  //0x02
	__IO uint8_t USISR;   //0x03
	__IO uint8_t USIIER;  //0x04
	union
	{
		__IO uint8_t USIRDR;  //0x05
		__IO uint8_t USITDR;  //0x05
	};
	__IO uint8_t USIWTRH;  //0x06
	__IO uint8_t USIWTRM;  //0x07
	__IO uint8_t USIWTRL;  //0x08
	__IO uint8_t USIGTRH;  //0x09
	__IO uint8_t USIGTRL;  //0x0a
	__IO uint8_t USICSR;   //0x0b
	__IO uint8_t USIPCR;   //0x0c
	__IO uint8_t USIPDR;   //0x0d
	__IO uint8_t USIDDR;   //0x0e
	__IO uint8_t USIFIFOINTCON;  //0x0f
	__IO uint8_t USICRCH;   //0x10
	__IO uint8_t USICRCL;   //0x11
}USI_TypeDef;





#endif /* USI_REG_H_ */
